#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # 1. Header
    header = b'GIF89a'
    
    # 2. Logical Screen Descriptor
    width = rng.read(2)
    height = rng.read(2)
    packed = bytearray()
    packed += ((width[0] & 0b11111111) << 4) | ((height[0] & 0b11111111) >> 4)
    packed += (((width[0] & 0b11110000) >> 4) << 4) | ((height[0] & 0b11110000) >> 4)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
    packed += (rng.read(1)[0] & 0b11111111)
       # 6. Image Data (randomly sized, capped at 255 bytes per sub-block)
    lzw_minimum_code_size = (rng.read(1)[0] % 8) or 1
    
    blocks = []
    total_blocks_size = rng.read(1)[0]  # Make it reasonably small
    for _ in range(total_blocks_size):
        block_size = rng.read(1)[0]  # Each block can be up to 255 bytes
        blocks.append(bytes([block_size]) + rng.read(block_size))
    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks) + b'\x00'  # Ending with a block size of 0
    
    # 7. Trailer
    trailer = b'\x3B'
    
    # Write everything to the output file
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)
