#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(out: BinaryIO, rng: BinaryIO):
    # 10 bytes of header data
    out.write(b'GIF89a')
    out.write(struct.pack('<H', 4))
    out.write(struct.pack('<H', 4))
    
    # 7 bytes of global color table
    out.write(b'\xff\xff\xff\xff\xff\xff\xff')
    
    # 2 bytes of screen descriptor
    out.write(struct.pack('<H', 640))
    out.write(struct.pack('<H', 480))
    
    # 1 byte of background color index
    out.write(b'\x00')
    
    # 1 byte of pixel aspect ratio
    out.write(b'\x00')
    
    # 1 byte of flags
    out.write(b'\x00')
    
    # 1 byte of terminator
    out.write(b';')
    
    # 1 byte of extension introducer
    out.write(b'!')
    
    # 1 byte of graphic control label
    out.write(b'\xf9')
    
    # 1 byte of block size
    out.write(b'\x04')
    
    # 1 byte of flags
    out.write(b'\x00')
    
    # 2 bytes of delay time
    out.write(struct.pack('<H', 5))
    
    # 1 byte of transparent color index
    out.write(b'\x00')
    
    # 1 byte of terminator
    out.write(b'\x00')
    
    # 1 byte of image descriptor
    out.write(b',')
    
    # 2 bytes of left position
    out.write(struct.pack('<H', 0))
    
    # 2 bytes of top position
    out.write(struct.pack('<H', 0))
    
    # 2 bytes of width
    out.write(struct.pack('<H', 640))
    
    # 2 bytes of height
    out.write(struct.pack('<H', 480))
    
    # 1 byte of flags
    out.write(b'\x00')
    
    # 1 byte of local color table flag
    out.write(b'\x00')
    
    # 1 byte of interlace flag
    out.write(b'\x00')
    
    # 1 byte of terminator
    out.write(b'\x00')
    
    # 1 byte of LZW minimum code size
    out.write(b'\x08')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte of block size
    out.write(b'\x00')
    
    # 1 byte