#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Feb 12 09:45:36 2019

@author: kazuki.onodera
"""

import numpy as np
import pandas as pd
from glob import glob
import utils
utils.start(__file__)
#==============================================================================

SUBMIT_FILE_PATH = '../output/0212-1.csv.gz'

COMMENT = 'top100 * f007'

EXE_SUBMIT = True

DROP = ['f001_hostgal_specz']

SEED = np.random.randint(9999)
print('SEED:', SEED)

NFOLD = 5

LOOP = 5

param = {
         'objective': 'binary',
         'metric': 'auc',
         
         'learning_rate': 0.01,
         'max_depth': 6,
         'num_leaves': 63,
         'max_bin': 255,
         
         'min_child_weight': 10,
         'min_data_in_leaf': 150,
         'reg_lambda': 0.5,  # L2 regularization term on weights.
         'reg_alpha': 0.5,  # L1 regularization term on weights.
         
         'colsample_bytree': 0.9,
         'subsample': 0.9,
#         'nthread': 32,
         'nthread': 8,
         'bagging_freq': 1,
         'verbose':-1,
         }


np.random.seed(SEED)

# =============================================================================
# load
# =============================================================================

files_tr = sorted(glob('../data/train_f*.f'))

X = pd.concat([
                pd.read_feather(f) for f in tqdm(files_tr, mininterval=60)
               ], axis=1)
y = utils.load_target().target

# X.drop(DROP, axis=1, inplace=True)

target_dict = {}
target_dict_r = {}