#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep 14 20:56:17 2020

@author: minghao
"""
import numpy as np
from scipy.optimize import minimize, Bounds
import matplotlib.pyplot as plt

def f(x):
    return x[0]**2 + x[1]**2
    
def g(x):
    return [2*x[0], 2*x[1]]

def hessian(g, x):
    return [[g[0][0], g[0][1]], [g[1][0], g[1][1]]]

def newton_raphson(f, g, x0, eps=1e-9, maxiter=100):
    for i in range(maxiter):
        H = hessian(g, x0)
        if np.linalg.det(H) < 1e-9:
            break
        
        dx = np.dot(-np.linalg.inv(H), g(x0))
        x0 += dx
        if np.abs(dx).sum() < eps:
            break
            
    return x0
