#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    # Header
    header = b'GIF89a' + bytes([0x21]) + b'NETSCAPE2.0' + \
             bytes([0x0b]) + bytes([0x00]) + bytes([0x03]) + \
             bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
             bytes([0xff]) + bytes([0xff]) + bytes([0xff])

    # Logical screen descriptor
    lsd = bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0xf7])

    # Global color table
    gct = bytes([0x00]) * 64

    # Image descriptor
    idd = bytes([0x2c]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00]) + \
          bytes([0x00]) + bytes([0x00]) + bytes([0x00])