#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Jan 26 19:40:57 2019

@author: kazuki.onodera
"""

import numpy as np
import pandas as pd
import os, gc
from glob import glob
from tqdm import tqdm

import sys
sys.path.append(f'/home/{os.environ.get("USER")}/PythonLibrary')
import lgbextension as ex
import lightgbm as lgb
from multiprocessing import cpu_count, Pool

import utils
utils.start(__file__)
#==============================================================================

SUBMIT_FILE_PATH = '../output/0126-1.csv.gz'

COMMENT = 'lgb130 + f009 ~ f014'

EXE_SUBMIT = True

DROP = ['f001', 'f002', 'f003', 'f004', 'f005', 'f006', 'f007', 'f008']

SEED = np.random.randint(9999)
print('SEED:', SEED)

NFOLD = 5

LOOP = 5

param = {
         'objective': 'binary',
         'metric': 'auc',
         
         'learning_rate': 0.01,
         'max_depth': 6,
         'num_leaves': 63,
         'max_bin': 255,
         
         'min_child_weight': 10,
         'min_data_in_leaf': 150,
         'reg_lambda': 0.5,  # L2 regularization term on weights.
         'reg_alpha': 0.5,  # L1 regularization term on weights.
         
         'colsample_bytree': 0.9,
         'subsample': 0.9,
#         'nthread': 32,
         'nthread': cpu_count(),
         'bagging_freq': 1,
         'verbose':-1,
         }


# =============================================================================
# load
# =============================================================================
imp = pd.read_pickle('LOG/imp_801_imp_lgb130_notused.pkl').sort_values('total', ascending=False)
imp['split'] /= imp['split'].max()
imp['gain'] /= imp['gain'].max()
imp['total'] = imp['split'] + imp['gain']
imp.set_index('feature', inplace=True)

files_tr = sorted(glob('../data/train_f*.f'))

X = pd.concat([
                pd.read_feather(f) for f in tqdm(files_tr, mininterval=60)
               ], axis=1)[imp[imp['total']>0].index]
y = utils.load_target().target

X.drop(DROP, axis=1, inplace=True)

target_dict = {}
target_dict_r = {}