#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    # Header
    header = b'GIF89a' + bytes([0x10]) + \
             bytes([0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff]) + \
             bytes([0x2c, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x00, 0x00, 0x00]) + \
             bytes([0x00, 0x0