#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO):
    # 10 bytes of header
    out.write(b'GIF89a')
    
    # 7 bytes of screen descriptor
    out.write(struct.pack('<HBB', 256, 256, 0))
    
    # 4 bytes of global color table (black and white)
    out.write(b'\x00\x00\x00\xff')
    
    # 1 byte of image separator
    out.write(b',')
    
    # 9 bytes of image descriptor
    out.write(struct.pack('<HHB', 0, 0, 0))
    
    # 1 byte of local color table (black and white)
    out.write(b'\x00\x00\x00\xff')
    
    # 1 byte of LZW code size
    out.write(b'\x02')
    
    # 1 byte of end-of-data marker
    out.write(b';')
    
    # 1 byte of trailer
    out.write(b'\x3b')
