
import random
from PIL import Image, ImageOps

def convert_to_gif(infile, outfile):
    """Convert an image into GIF format."""

    # Open input and output files
    inp = open(infile, 'rb')
    out = open(outfile, 'wb')

    # Read image using Pillow
    im = Image.open(inp).convert('RGB')

    # 1. Header
    header = b'GIF89a'

    # 2. Logical Screen Descriptor (LSD)
    width, height = im.size
    packed_fields = 0
    background_color_index = 0
    pixel_aspect_ratio = 0
    lsd = struct.pack("<HHBB", width, height, packed_fields, background_color_index)

    # 3. Global Color Table
    color_table = b''

    # 4. Graphic Control Extension (optional)
    gce = None

    # 5. Image Descriptor
    left_position = 0
    top_position = 0
    width = im.width
    height = im.height
    local_color_table_flag = 0
    interlace_flag = 0
    sort_flag = 0
    reserved_bits = 0
    lct_size = 0
    image_descriptor = struct.pack("<BBBBB", left_position, top_position, width, height, packed_fields)

    # 6. Image Data
    lzw_minimum_code_size = 8
    rng = zlib.compressobj(zlib.Z_DEFAULT_COMPRESSION, zlib.DEFLATED, -zlib.MAX_WBITS, zlib.DEF_MEM_LEVEL, 0)
    blocks = []
    while True:
        block = rng.compress(im.tobytes())
        if block == b"":
            break
        blocks.append(bytes([block_size]) + rng.read(block_size))
    
    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks) + b'\x00'  # Ending with a block size of 0

    # 7. Trailer
    trailer = b'\x3B'

    # Write everything to the output file
    out.write(header + lsd + color_table)
    if gce is not None:
        out.write(gce)
    out.write(image_descriptor + image_data + trailer)