#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(out: BinaryIO, rng: BinaryIO):
    # Header
    out.write('GIF89a'.encode())
    
    # Logical Screen Descriptor
    width = 1024
    height = 768
    background_color = 0xff
    pixel_aspect_ratio = 0
    out.write(struct.pack("<HHBB", width, height, background_color, pixel_aspect_ratio))
    
    # Global Color Table (1-bit)
    out.write(b'\x00\x00')
    
    # Application Extension Block
    out.write(b'!\xff\x0bNETSCAPE2.0\x03\x01')
    out.write(struct.pack(">H", 0))
    
    # Image Descriptor
    out.write(b',')
    out.write(struct.pack("<HHHHB", 0, 0, width, height, 0))
    
    # Local Color Table (1-bit)
    out.write(b'\x00\x00')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Comment Extension Block
    out.write(b'\x21\xfe\x0cHello World!')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00')
    
    # Plain Text Extension Block
    out.write(b'\x21\x01\x04\x54\x65\x73\x74')
    
    # Graphic Control Extension Block
    out.write(b'\x