
    
    # 6. Image data
    # LZW minimum code size, followed by compressed data
    # The compressed data consists of one or more blocks. A block starts with a byte containing the number of pixels in that block. 
    # If this value is zero, then the block contains no pixel data and only serves as padding. Otherwise, there are following that many pixels. 
    # Each pixel is encoded using one or two bytes. If the first byte has the highest bit set, then another byte follows which gives the actual value. 
    
    # Read the LZW minimum code size from the header
    lzw_minimum_code_size = (rng.read(1)[0] % 8) or 1
    
    blocks = []
    total_blocks_size = rng.read(1)[0]  # Make it reasonably small
    while True:
        block_size = rng.read(1)[0]  # Each block can be up to 255 bytes
        
        if block_size == 0:
            break
            
        blocks.append(bytes([block_size]) + rng.read(block_size))
        
    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks) + b'\x00'  # Ending with a block size of 0
    
    # 7. Trailer
    trailer = b'\x3B'
    
    # Write everything to the output file
    out.write(header + lsd + color_table)
    if gce is not None:
        out.write(gce)
    out.write(image_descriptor + image_data + trailer)