
    header = b'\xFF\xD8'  # SOI

    # 2. Logical Screen Descriptor
    width, height = struct.unpack('>HH', rng.read(4))
    bitdepth = rng.read(1)[0] & 0b11111
    color_type = rng.read(1)[0] & 0b111
    compression_method = rng.read(1)[0]
    filter_method = rng.read(1)[0]
    interlace_method = rng.read(1)[0]
    lsd = struct.pack('>BHHBBBB', 0x2c, width, height, bitdepth, color_type, compression_method, filter_method, interlace_method)

    # 3. Color Table (if applicable)
    num_colors = 2 ** bitdepth
    if color_type == 3 and num_colors <= 2**bitdepth:
        color_table = rng.read(3 * num_colors)  # Random colors

    # 4. Graphics Control Extension (optional)
    if rng.read(1)[0]:
        gce = struct.pack('>BBBHB', 0x21, 0xF9, 0x04, rng.read(1)[0], rng.read(1)[0])
    else:
        gce = None

    # 5. Image Descriptor
    left, top = struct.unpack('>HH', rng.read(4))
    width, height = struct.unpack('>HH', rng.read(4))
    image_descriptor = struct.pack('>BHHHHB', 0x2C, left, top, width, height, rng.read(1)[0])

    # 6. Image Data (randomly sized, capped at 255 bytes per sub-block)
    lzw_minimum_code_size = (rng.read(1)[0] % 8) or 1

    blocks = []
    total_blocks_size = rng.read(1)[0]  # Make it reasonably small
    while True:
        block_size = rng.read(1)[0]  # Each block can be up to 255 bytes

        if not block_size:
            break
        
        blocks.append(bytes([block_size]) + rng.read(block_size))
    
    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks) + b'\x00'  # Ending with a block size of 0

    # 7. Trailer
    trailer = b'\x3B'

    # Write everything to the output file
    out.write(header + lsd + color_table)
    if gce is not None:
        out.write(gce)
    out.write(image_descriptor + image_data + trailer)