#!/usr/bin/env python3

import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_gif(out: BinaryIO, rng: BinaryIO):
    # Read the header and local screen descriptor from the template file
    with open('template.gif', 'rb') as f:
        header = f.read(6)
        lsd = f.read(7)

    # Read the color table from the template file
    color_table = []
    for i in range(256 * 3):
        color_table.append(struct.pack('<B', next(rng)))

    # Read the graphic control extension from the template file
    gce = f.read(8)

    # Read the image descriptor from the template file
    image_descriptor = f.read(10)

    # Read the image data from the template file
    image_data = f.read()

    trailer = b'\x3B'

    # Write everything to the output file
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)