
        header += b'\xFF\xE0'  # APP0 marker
        header += struct.pack('>H', len(app0))
        header += app0

    # 3. LSD
    lsd = struct.pack('>BBBBBHB', *rng.read(7))

    # 4. Color Table
    color_table_length = rng.read(1)[0]
    color_table = bytes()
    for _ in range(color_table_length):
        r, g, b = [rng.read(1)[0] & ~0xC0 for _ in range(3)]
        color_table += struct.pack('>BBB', r, g, b)

    # 4b. GCE
    if rng.randint(0, 1):
        gce = struct.pack('>BBHBBBB', 0x21, 0xF9, 4, ord('A'), ord('n'), ord('i'), 0)
    else:
        gce = b''

    # 5. Image Descriptor
    left, top = struct.unpack('>HH', rng.read(4))
    width, height = struct.unpack('>HH', rng.read(4))
    image_descriptor = struct.pack('>BHHHHB', 0x2C, left, top, width, height, rng.read(1)[0])

    # 6. Image Data (randomly sized, capped at 255 bytes per sub-block)
    lzw_minimum_code_size = (rng.read(1)[0] % 8) or 1

    blocks = []
    total_blocks_size = rng.read(1)[0]  # Make it reasonably small
    while True:
        block_size = rng.read(1)[0]

        if not block_size:
            break

        blocks.append(bytes([block_size]) + rng.read(block_size))
    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks) + b'\x00'  # Ending with a block size of 0

    # 7. Trailer
    trailer = b'\x3B'

    # Write everything to the output file
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)