#!/usr/bin/env python3

import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    # Read 1024 bytes of random data from /dev/urandom
    header = rng.read(6)
    lsd = rng.read(7)
    color_table = rng.read(3 * 256)
    gce = rng.read(8)
    image_descriptor = rng.read(10)
    image_data = rng.read(1024 - len(header) - len(lsd) - len(color_table) - len(gce) - len(image_descriptor))
    trailer = b'\x3b'
    # Write everything to the output file
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)