
import os, sys
from PIL import Image

def convert_gif_to_png(infile, outfile):
    inp = open(infile, 'rb')
    out = open(outfile, 'wb')
    
    header = inp.read(6) # GIF87a or GIF89a
    lsd = inp.read(7) # Logical Screen Descriptor
    color_table = inp.read(3*2**((ord(lsd[4]) & 0x07)+1)) # Global Color Table
    gce = '' # Graphic Control Extension
    while True:
        block = inp.read(1)
        if not block: break
        if ord(block) == 0x21 and inp.read(1) == '\xf9': # 0x21 is an extension introducer, 0xf9 is a graphic control label
            gce = inp.read(5) # Graphic Control Extension
            break
        
    image_descriptor = inp.read(9) # Image Descriptor
    image_data = inp.read() # Image Data
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)
