#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 10 20:49:56 2017

@author: jorgemauricio
"""

# Librerias
import numpy as np
from sklearn.preprocessing import StandardScaler
from sklearn.cluster import KMeans
from sklearn.metrics import silhouette_score
from matplotlib import pyplot as plt

# Lectura de datos
datos = np.genfromtxt('data.csv', delimiter=',')

# Seleccionar las columnas que se desean utilizar
columnas = [0, 1] # Selecciona la primera y segunda columna
X = datos[:, columnas]

# Escalado de los datos
scaler = StandardScaler()
X = scaler.fit_transform(X)

# Creacion del modelo de clustering
modelo = KMeans(n_clusters=3, init='k-means++', max_iter=300, n_init=10, random_state=0)

# Entrenamiento del modelo
modelo.fit(X)

# Predicciones
prediccion = modelo.predict(X)

# Calculo del score
score = silhouette_score(X, prediccion)
print("El Score es: " + str(score))

# Grafica
plt.scatter(X[prediccion == 0, 0], X[prediccion == 0, 1])
plt.scatter(X[prediccion == 1, 0], X[prediccion == 1, 1])
plt