#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Aug 29 15:07:46 2019

@author: kenneth
"""
import numpy as np
from scipy.stats import norm, multivariate_normal

def gaussian(x, mu, sigma):
    return (1/(sigma * np.sqrt(2 * np.pi))) * np.exp(-((x - mu)**2 / (2 * sigma**2)))

def gaussian_pdf(x, mu, sigma):
    return (1/(sigma * np.sqrt(2 * np.pi))) * np.exp(-((x - mu)**2 / (2 * sigma**2)))
    
def gaussian_cdf(x, mu, sigma):
    return (1/2)*(1 + erf((x - mu)/(np.sqrt(2)*sigma)))

def gaussian_inv_cdf(p, mu, sigma):
    return mu + sigma * np.sqrt(2) * erfinv(2*p - 1)

def gaussian_log_pdf(x, mu, sigma):
    return np.log(gaussian(x, mu, sigma))

def gaussian_log_cdf(x, mu, sigma):
    return np.log(gaussian_cdf(x, mu, sigma))

def gaussian_log_inv_cdf(p, mu, sigma):
    return np.log(gaussian_inv_cdf(p, mu, sigma))

def gaussian_marginal_pdf(x, mu, sigma, axis=None):
    if axis is None:
        return gaussian(x, mu, sigma)
    else:
        return np.sum(gaussian(x, mu, sigma), axis=axis)

def gaussian_marginal_cdf(x, mu, sigma, axis=None):
    if axis is None:
        return gaussian_cdf(x, mu, sigma)
    else:
        return np.sum(gaussian_cdf(x, mu, sigma), axis=axis)

def gaussian_marginal_inv_cdf(p, mu, sigma, axis=None):
    if axis is None:
        return gaussian_inv_cdf(p, mu, sigma)
    else:
        return np.sum(gaussian_inv_cdf(p, mu, sigma), axis=axis)

def gaussian_marginal_log_pdf(x, mu, sigma, axis=None):
    if axis is None:
        return gaussian_log_pdf(x, mu, sigma)
    else:
        return np.sum(gaussian_log_pdf(x, mu, sigma), axis=axis)

def gaussian_marginal_log_cdf(x, mu, sigma, axis=None):
    if axis is None:
        return gaussian_log_cdf(x, mu, sigma)
    else:
        return np.sum(gaussian_log_cdf(x, mu, sigma), axis=axis)

def gaussian_marginal_log_inv_cdf(p, mu, sigma, axis=None):
    if axis is None:
        return gaussian_log_inv_cdf(p, mu, sigma)
    else:
        return np.sum(gaussian_log_inv_cdf(p, mu, sigma), axis=axis)

def gaussian_multivariate(X, mean, covariance):
    return multivariate_normal.pdf(X, mean, covariance)

def gaussian_multivariate_log(X, mean, covariance):
    return multivariate_normal.logpdf(X, mean, covariance)

def gaussian_multivariate_cdf(X, mean, covariance):
    return multivariate_normal.cdf(X, mean, covariance)

def gaussian_multivariate_log_cdf(X, mean, covariance):
    return multivariate_normal.logcdf(X, mean, covariance)

def gaussian_multivariate_inv_cdf(p