#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan  4 16:49:29 2021

@author: jonasg
"""


import random
from PIL import Image, ImageDraw

rng = random.Random()
rng.seed(0)

with open('test.gif', 'wb') as out:
    # Header
    header = (b'GIF89a'
              b'\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'
              b'\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'
              b'\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'
              )

    # Logical Screen Descriptor
    width = 128
    height = 128
    packed = ((width & 0xFF) << 8) | (height & 0xFF)
    background_color_index = 0
    pixel_aspect_ratio = 0
    lsd = bytes([
        0x2C,  # Extension Introducer
        0x00,  # Label
        0x00,  # Block Size
        0x00,  # Packed Field
        0x00,  # Background Color Index
        0x00,  # Pixel Aspect Ratio
        0x00, 0x00,  # GCT Flag and Size
        0x00, 0x00,  # Sort Flag
        0x00, 0x00,  # Reserved
        0x00, 0x00,  # GCT Size
        0x00, 0x00,  # GCT Entry Size
        0x00, 0x00,  # GCT Data
    ])

    # Global Color Table
    colors = [
        (0x00, 0x00, 0x00),
        (0xff, 0xff, 0xff),
        (0x00, 0xff, 0x00),
        (0x00, 0x00, 0xff),
    ]
    color_table = bytearray([(r >> 2) | ((g >> 2) << 5) | ((b >> 2) << 10) for r, g, b in colors])
    lsd += bytes([len(colors)] * 3)  # GCT Size
    lsd += bytes([3] * 3)  # GCT Entry Size
    lsd += bytes(color_table)

    # Graphics Control Extension
    transparent_color_index = 0
    delay_time = int((1 / 10) * 100)  # 10 frames per second
    disposal_method = 0
    user_input_flag = False
    transparency_flag = False
    gce = bytes([
        0x21,  # Extension Introducer
        0xF9,  # Application Extension Label
        0x04,  # Block Size
        0x08,  # Packed Field
        0x00,  # Delay Time
        0x00,  # Transparent Color Index
        0x00,  # Disposal Method
        0x00,  # User Input Flag
        0x00,  # Transparency Flag
    ])

    # Image Descriptor
    left = 0
    top = 0
    interlace = False
    sort = False
    local_color_table = False
    lzw_minimum_code_size = 8
    image_descriptor = bytes([
        0x2C,  # Extension Introducer
        0x00,  # Label
        0x00,  # Block Size
        0x00,  # Left Position
        0x00,  # Top Position
        0x00,  # Width
        0x00,  # Height
        0x08,  # Local Color Table Flag
        0x00,  # Interlace Flag
        0x00,  # Sort Flag
        0    total_blocks_size = rng.read(1)[0]  # Make it reasonably small
    while True:
        if len(blocks) >= total_blocks_size:
            break

        block_size = rng.read(1)[0]
        if not block_size:
            continue

        data = bytes([block_size]) + rng.read(block_size)
        if len(data) < 255:
            data += b'\x00'  # Ending with a block size of 0
        else:
            blocks[-1] = blocks[-1][:-1] + bytes([len(data)]) + data[1:]
        blocks.append(data)

    image_data = bytes([lzw_minimum_code_size]) + b''.join(blocks)

    # 7. Trailer
    trailer = b'\x3B'

    # Write everything to the output file
    out.write(header + lsd + color_table + gce + image_descriptor + image_data + trailer)