#!/usr/bin/env python3

import struct
from typing import BinaryIO

from .endian import Endian, read_int


def skip(file: BinaryIO, length: int, endianness=Endian.Little) -> None:
    """Skips forward in the file by the specified number of bytes."""
    if endianness == Endian.Big:
        read_format = ">%d" % length
    else:  # Little
        read_format = "<%d" % length
    read_int(file, read_format, 0)


def write_string(file: BinaryIO, string: str) -> None:
    """Writ