#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') + 1
    data = rng.read(datalen)
    out.write(header)
    for _ in range(10000):
        out.write(struct.pack('<HHBBB', *[int.from_bytes(
                rng.read(4), byteorder='little'),] * 5))
    out.write(data)
