#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)

LZW_TABLE = {
    (0, 0): b"\x47\x49\x46\x38\x39\x61",
}


def lzw(codes: dict[tuple[int, int], bytes], code: tuple[int, int]) -> list[bytes]:
    out = []
    while True:
        if code in codes:
            out.append(codes[code])
            code = codes[(code[0] >> 8) & 0xFF, code[1]]
        else:
            out.append((b"\x2C" + b"\x00" * 5 + b"\xFF"))
            break
    return reversed(out)


def gen_gif(out: BinaryIO):
    with open("/dev/random") as rng:
        delay = struct.unpack(">f", rng.read(4))[0] / 10
    out.write(struct.pack("<HHHB", 400, 300, 200 // 1000, 0))
    for i in range(256):
        out.write(struct.pack(">BBB", i, i, i))
    out.write(struct.pack("<B", 0))
    colors = [0, 0, 0]
    color_index = 1
    for i in range(1 << 12):
