#!/usr/bin/env python3

import struct
from typing import BinaryIO


def read_gif(rng: BinaryIO, out: BinaryIO = open('/dev/null', 'wb')) -> None:
    header = rng.read(6)
    if not header == b'GIF89a':
        raise ValueError('Not a GIF file!')
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    print('data length: %s' % str(datalen))
    data = rng.read(datalen)
    out.write(data)


def write_gif(
        rng: BinaryIO, out: BinaryIO = open('/dev/null', 'wb'), count: int = 100
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
