#!/usr/bin/env python3
import os, sys, time, dataclasses, subprocess, signal, json, argparse, re
from datetime import datetime as dt
from contextlib import suppress

import paho.mqtt.client as mqtt
import RPi.GPIO as GPIO
# import adafruit_bme680  # need to install this library with pip3 first: sudo -H pip3 install adafruit-circuitpython-bme680

print("[INFO] Starting...")

sys.path.append('/home/pi/pimatic')

from homeassistant_mqtt_daemon import HassMqttDaemon

# Enumerate sensor types in Home Assistant
SENSOR_PIN = 21   # BCM pin used to read sensors (all pulled up to VCC)
TMP_SENSOR_BUS = 1
HUM_SENSOR_BUS = 0
PRESSURE_SENSOR_BUS = 0
SENSORS = {
    'temperature': { 'type': 'sensor', 'name': 'Temperature', 'unit': '°C', 'bus': TMP_SENSOR_BUS },
    'humidity'   : { 'type': 'sensor', 'name': 'Humidity',   'unit': '%',   'bus': HUM_SENSOR_BUS },
    'pressure'   : { 'type': 'sensor', 'name': 'Pressure',   'unit': 'hPa', 'bus': PRESSURE_SENSOR_BUS }
}
GPIO.setmode(GPIO.BCM)
GPIO.setup(SENSOR_PIN, GPIO.IN, pull_up_down=GPIO.PUD_UP)

MQTT_HOST = os.environ['HASS_MQTT'] or "localhost"
MQTT_PORT = int(os.environ['HASS_MQTT_PORT']) or 1883
MQTT_USER = os.environ['HASS_MQTT_USERNAME'] or None
MQTT_PASSWORD = os.environ['HASS_MQTT_PASSWORD'] or None

AUTHENTICATE_TOKEN = os.environ['HASS_MQTT_TOKEN'] or None