#!/usr/bin/env python3

import struct
from typing import BinaryIO

def main() -> None:
    with open('out', 'wb') as f:
        for _ in range(600):
            draw_frame(f, open('assets/images/image.gif', 'rb'))


def draw_frame(
        out: BinaryIO,
        rng: BinaryIO,
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
