#!/usr/bin/env python3

import sys, os

if len(sys.argv) != 4:
    print("Usage: %s <infile> <outfile> width"%os.path.basename(__file__))
    sys.exit(-1)

width = int(sys.argv[3])

with open(sys.argv[1], 'rb') as inp:
    with open(sys.argv[2], 'wb') as out:
        header = b'P6\n' + bytes([width]) + b'\n' + bytes([width]) + b'\n255\n'
        data = bytearray()

        for row in range(0, width):
            for col in range(0, width):
                r = row / (width - 1) * 255
                g = col / (width - 1) * 255
                b = 0
                a = 255
                data += bytes([r,g,b,a])

        out.write(header + data)
