#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# algorithm used in CVE-2019–18657, and as described
# here: https://github.com/RUB-SysSec/redqueen/blob/master/doc/advisories/CVE-2019-18657.md
def write_gif(rng : BinaryIO, out : BinaryIO):
    header = b'GIF89a\x1b\xff\xfe' \
             + struct.pack('<H', 0xffff & \
                rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
