#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    # First chunk
    out.write(header + b'\x04\x05\x01\x00\xff\x00' + b'\x2c\x00\x00\x00\x01\x00')

    # Second chunk
    out.write(b'\x21\xf9\x04\x01' + \
              bytes([i for i in range(8)]))

    # Third chunk
    out.write(b'\x2c\x00\x00\x00\x01\x00\xff\x00' + \
              b'\x81\x00' + \
              b'\x21\xff\x0b\x4e\x45\x54\x53\x43\x41\x50\x45\x32\x2e\x30\x03' + \
              b'\x01\x00\x01\x00\x00\x00\x00\x21\xf9\x04\x01' + \
              data[:2] + \
              b'\x21\xf9\x04\x01' + \
              data[2:] + \
              b'\x3b' + \
              data[:2]
          )

try:
    from random import SystemRandom
except ImportError:
    try:
