#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)

width = 1280
height = 720
pixels_per_block = 64

def write_gif(out: BinaryIO, rng: BinaryIO):
    out.write(b"GIF89a") # Signature
    out.write(struct.pack("!<H", width)) # Logical screen width
    out.write(struct.pack("!<H", height)) # Logical screen height
    out.write(b"\x85\xff\xff\xff\x2c") # Local color table flag, local color table size, background color index, pixel aspect ratio
    
    for y in range(height // pixels_per_block - 1):
        for x in range((width + 2) // (pixels_per_block * 8) - 1):
            num = int(rng.read(1)[0]) % 0x100
