#!/usr/bin/env python3

import sys
import random

def main():
    inbuf = sys.stdin.buffer
    outbuf = sys.stdout.buffer
    #rng = urandom()
    rng = Random()
    for _ in range(1024*1024*16):
        generate_random_gif(rng, outbuf)
        inbuf.seek(int.from_bytes(inbuf.read(4)))

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
