#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO):
    # Preamble
    out.write(b'GIF87a')
    out.write(struct.pack('<HI', 400, 200))
    out.write(b'\x00\xff\x0f\x00\x10\x00')
    
    # Global color table (with transparency)
    out.write(b'\x00\x00\x00\x00\xff\xff\xff\x00\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\x00\x00')

    # Header for images
    out.write(b'\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x59\xf0\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\x00\x00')

    # Repeat forever
    out.write(b'\x3b\x01\xff')


