#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(out: BinaryIO, rng: BinaryIO):
  header = b'\x47\x49\x46\x38\x39\x61' + bytes([128+struct.unpack('B', rng.read(1))[0]&0b111]) + b'\x00' \
    + b'\x01\x00\x01\x00\x80\xff\xff\xff\x00\x00\x00\x21\xf9\x04\x01\x0a\x00\x01\x00\x2c\x00\x00\x00\x00' \
    + b'\x01\x00\x01\x00\x00\x02\x02\x4c\x01\x00\x3b'

  for i in range(0, 512):
    out.write(header)
  
  while True:
    out.write(bytes([0x21]) + rng.read(1))
    size = struct.unpack('<H', rng.read(2))[0] & 0xFFF
    out.write(rng.read(size))
