#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' # 6 bytes magic + version id
    bgcolor = (0x00, 0xff, 0xff)

    # Header length
    out.write(b'\x21\x0B') # Extension block identifier
    out.write(b'\xFF\x00') # Application specific block label
    out.write(struct.pack('>H', len(bgcolor))) # Length of extension payload
    for color in bgcolor:
            datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
