#!/usr/bin/env python3

import struct
from typing import BinaryIO

rngfile: str ='src/gba-rng.bin'

with open('output', 'wb') as out, \
        open(rngfile, mode='rb') as rng:

    header = rng.read(4)
    # Sanity check for the file structure
    assert len(header) == 4 and isinstance(struct.unpack('<I', header)[0], int)
    while True:
        datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
