#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(1), byteorder='big') % 256

    # `datalen` is packed as the header's size field
    header += datalen.to_bytes(length=1, byteorder='big', signed=False)
    header += bytes((0,)) * 7

    out.write(header)

    while len(data)!= datalen:
        # This generates a block of up to 255 bytes (or all remaining data if we are at or past that point in the stream).
        # Note this might not actually produce anything since it could be zero-filled.
        data = rng.read(255);

        # Normally, part of the compression algorithm would run here when `data` grows too long.
        # Since we don't have any input for our compression algorithm, we skip these steps and just write `data`.
        out.write(header + data)
