#!/usr/bin/env python3
# -*- coding: utf-8 -*-


"""
@author: <NAME>
email:   <EMAIL>
GitHub:  phuycke
"""

#%%

from nltk.tokenize import sent_tokenize as stknz, word_tokenize as wtknz
import numpy             as np
import matplotlib.pyplot as plt

#%%

doc1 = "Hello! My name is Lucas. I am a developer." # three sentences
doc2 = "Python is a great language to learn and use for machine learning."
doc3 = "Machine learning is a critical skill in the modern data scientist's toolbox."
doc4 = """
        Machine Learning (ML) refers to the study of computer algorithms that improve automatically 
        through experience to achieve a specific goal, without being explicitly programmed. It 
        involves programming techniques such as artificial intelligence, machine learning, deep 
        learning, statistical modeling, and probabilistic methods, which aim to give computers the 
        ability to learn without being explicitly programmed. Machine learning focuses on using past 
        data to predict or understand the future based on examples rather than following strictly 
        static rules.

        Machine learning can be used in applications including email filtering and spam detection; 
        recommender systems; computer vision; bioinformatics; medical diagnosis and treatment; 
        gambling; virtual assistants; industrial process control; and much more.
        """
doc5 = """
        Deep learning is part of a broader family of machine learning methods based on artificial neural networks. Neural network models have started to outperform large multilayer perceptrons (MLPs) on certain tasks. For example, deep convolutional neural networks are very effective at image classification compared with conventional MLPs trained on the same task. In general, deep learning architectures consist of multiple layers of connected neurons, which may include repeating blocks of neural networks of increasing depth. They are often applied to analyzing visual imagery, speech recognition, natural language processing and audio recognition. Deep learning has also made major advances in reinforcement learning, allowing agents to explore environments and learn from them. These characteristics make deep learning an ideal match for embedded devices, other sensor technologies and online services where low latency and high throughput are essential features. 

        Deep learning research has led to a significant reduction in the computational requirements of training and inference while maintaining accuracy. This makes it easier to iterate on ideas and refine performance, significantly speeding up experimentation when building new architectures or solving problems. Researchers have also found that deep learning requires substantially less labeled data than traditional ML approaches."""

#%%

def count_words(document):
    words    = wtknz(document)
    nbr_word = len(words)
    
    return nbr_word

def count_sentences(document):
    sentences       = stknz(document)
    nbr_sentence    = len(sentences)
    
    return nbr_sentence

def count_characters(document):
    characters      = len(document)
    
    return characters

def count_syllables():
    pass 

def plot_word_length(documents):
    lengths = []
    for doc in documents:
        length = count_words(doc)
        lengths.append(length)
        
    fig     = plt.figure() 
    ax      = fig.add_axes([0,0,1,1])
    y_pos   = np.arange(len(lengths))
    ax.barh(y_pos, lengths, align='center', alpha=0.5)
    ax.set_yticks(y_pos)
    ax.set_yticklabels(['Doc 1', 'Doc 2', 'Doc 3', 'Doc 4'])
    ax.invert_yaxis() 
    ax.set_xlabel('Words')
    ax.set_title('Word Length of Documents')

    plt.show()
    
def plot_char_length(documents):
    lengths = []
    for doc in documents:
        length = count_characters(doc)
        lengths.append(length)
        
    fig     = plt.figure() 
    ax      = fig.add_axes([0,0,1,1])
    y_pos   = np.arange(len(lengths))
    ax.barh(y_pos, lengths, align='center', alpha=0.5)
    ax.set_yticks(y_pos)
    ax.set_yticklabels(['Doc 1', 'Doc 2', 'Doc 3',
                         'Doc 4','Doc 5'])
    ax.invert_yaxis() 
    ax.set_xlabel('Characters')
    ax.set_title('Character Length of Documents')

    plt.show()
    
