#!/usr/bin/env python3

import struct

with open('/dev/urandom', 'rb') as rng, \
        open('output.gif', 'wb') as out, \
        ( 1024 ** 3 ) // len(b'\x00') as nframes:

    print("Generating {} frames...".format(nframes))

    # Write GIF headers to the output file
    for i in range(nframes):
        write_frame(rng, out)


def write_frame(rng,
                out
                ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
