#!/usr/bin/env python3
import argparse
from collections import defaultdict, deque

# To enable importing from parent directory when launching this script from terminal.
import sys
sys.path.append("..")
from util.json_utils import load_json


def main(args):
    # Load the data into a dict
    data = load_json(args.input)

    # Get all the example ids for each dataset
    train, valid, test = [], [], []
    for i in range(len(data)):
        for j in range(len(data[i]['examples'])):
            if not args.split or (j >= len(train)*0.95 and
                                  j <= len(test)*1.05):
                if i == 0:
                    train.append((str(i), j))
                elif i == 1:
                    valid.append((str(i), j))
                else:
                    test.append((str(i), j))

    print('There are'+ str(len(train)) +
         'training examples,'+ str(len(valid)) +
         'validation examples and also'+ str(len(test)) +'test examples.')

    # Create a dict to store selected positions
    pos_dict = {}

    if args.split == "train":
        pos_dict = {'train': train}
    elif args.split == 'dev' or args.split is None:
        pos_dict['train'] = train[:int(len(train) * 0.8)]
        pos_dict['valid'] = valid
    elif args.split == 'test':
        pos_dict['test'] = test

    with open(args.output, 'w') as f:
        json.dump(pos_dict, f)


if