#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO):
    width = rng.read(1)[0] & 7 + 256 * (rng.read(1)[0] & 63)
    height = rng.read(1)[0] & 7 + 256 * (rng.read(1)[0] & 63)

    bgColorIndex = rng.read(1)[0] & 0xF
    pixelAspectRatio = rng.read(1)[0] & 3

    out.write(struct.pack("<6sBBBBB", b"GIF89a",
                          0x2C - 4,
                          width, height,
                          bgColorIndex, pixelAspectRatio))

