#!/usr/bin/env python3
import sys
if not (sys.version_info.major == 3 and sys.version_info.minor > 5):
    print("This script requires Python version 3.6 or above")
    sys.exit(1)

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
