#!/usr/bin/env python3

import argparse
import sys

from PIL import Image


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument('width', 
        type=int, help="Image width")
    parser.add_argument('height', 
        type=int, help="Image height")

    try:
        args = parser.parse_args()

        im = Image.new("RGB", (args.width, args.height))
        
        for x in range(0, args.width):
            for y in range(0, args.height):
                r, g, b = [
                    ord(x) & 255 
                    for x in im.getpixel((x,y))]
                
                print(r+g+b, end='')
    except Exception as e:
        print(e, file=sys.stderr)
        return -1

