#! /usr/bin/env nix-shell
#! nix-shell -i "python3 $0" shell.nix  # it's important to use shell.nix!

import struct
from typing import BinaryIO


# Copied from https://github.com/python/cpython/blob/45f7168d324906db8b9233919f58e6b3a1a70af1/Lib/secrets.py#L33
def os_random(n):
    with open('/dev/urandom', 'rb') as f:
        return f.read(n)


# Generates a random GIF file into `out` using the
# random number generator `rng`.
def generate_random_gif(
        rng: callable[[int], bytes] = os_random, out: BinaryIO=None
    ):
    header = b'GIF89a'

    if not out:
        out = sys.stdout.buffer

    datalen = int.from_bytes(
            rng(3), byteorder='big')
    data = rng(datalen)
    out.write(header + data)
