from argparse import ArgumentParser
from io import BytesIO, TextIOWrapper
from os import urandom
from pathlib import Path


def parse_arguments() -> tuple[str, str]:
    parser = ArgumentParser('Generate some random GIFs.')

    parser.add_argument('-i', '--input-file', default='/dev/urandom',
                        help='The input file to read from (default=/dev/urandom)')

    parser.add_argument('-o', '--output-folder', default='.',
                        type=Path, help="The folder to put the generated files in")

    return (parser.parse_args(), __doc__)


def main():
    args, docstring = parse_arguments()

    with open(args.input_file, 'rb') as fin:
        for i in range(10):
            fn = f'{i}.gif'.format(**locals())

            with open(fn, 'wb') as fout:
                generate_random_gif(fin, fout)



