#!/usr/bin/env python3

import argparse
import binascii
import os


class Generator():

    def __init__(self):

        self._header = 'GIF89a'.encode('utf-8')

    # Generates a random GIF file into `out` using the
    # random number generator `rng` (/dev/urandom)
    def generate_random_gif(
            self, rng: BinaryIO, out: BinaryIO, maxlen=15*pow(2, 20)):
        datalen = os.urandom(3)
        while (int.from_bytes(
                datalen[0], byteorder='big')) > maxlen or \
              int.from_bytes(
                datalen[0], byteorder='big') < len(self._header) + 7:
            datalen = os.urandom(3)
        out.write(self._header + datalen)
        for _ in range((int.from_bytes(
                        datalen[0], byteorder='big') - len(self._header)) //
                      len(datalen)):
            out.write(os.urandom(len(datalen)))


