#!/usr/bin/env python3


import unittest
import struct
import os
from io import BytesIO
from typing import Tuple
from PIL import Image
import numpy as np

# Our own modules below here
import kobold

class TestGenerateRandomGif(unittest.TestCase):

    def test_generator(self):

        with open('/dev/urandom', 'rb') as dev_urand:

            for _ in range(10):
                img = generate_random_gif(dev_urand)

                # Make sure the image is actually animated
                self.assertEqual((img[0], len(img)), (b'GIF', 6))
                
                # Just make sure the bytes are valid
                imd = BytesIO(img[6:])
                try:
                    pilim = Image.open(imd).convert('RGBA')
                except IOError as e:
                    raise ValueError("Invalid Gif Data") from e
                
                rgba = list(pilim.getdata())



