#!/usr/bin/env python3

import struct
from typing import ByteString, BinaryIO


# Generates a random GIF file in a buffer and returns it as a byte string
def generate_random_gif(
        rng: BinaryIO, datalen=64*1024
    ) -> ByteString:

    # Header with version 89a (the maximum one supported by most browsers)
    header = b'GIF89a'

    # The length of the content follows
    header += struct.pack('>H', datalen)

    # Here comes our random bytes!
    data = rng.read(datalen)

    return header + data
