#!/usr/bin/env python3

import struct
from typing import BinaryIO


# Generates a random GIF file with a constant 1024-byte image payload
def generate_random_gif(
        golfer_name: str, out: BinaryIO):

    # Write header and length of image payload (always 1024 bytes)
    out.write('GIF89a'.encode())
    out.write((b'\x00\x00\x04'))

    # Write screen descriptor block
    out.write('\xF7\xFF\xFF\xFF\x00\x00,\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'.encode())

    # Write color table
    for _ in range(0, 5):
        out.write([0xff])
        out.write([0xff])
        out.write([0xff])

    out.write([0x00])   # Transparency color index is always zero

    # Write image descriptor block
    out.write(',\x00\x00\x00\x00\x00\x00,\x00\x00\x00\t\x00\x00\x00\x00\x00\x00\x00\x00\x00'.encode())

    # Write GOLFER name as comment
    out.write(('; %s ;'% golfer_name).encode())

    # Write LZW minimum code size
    out.write((b'\x02'))    # Always 2

    # Image data
    out.write(b'\x00\x00\x00\x00' * 16384)     # always full width x height

    # End of file
    out.write((b';End!'))


