#!/usr/bin/env python3

import struct
import sys

if len(sys.argv) > 1:
    addr = int(sys.argv[1], 0)
else:
    addr = 0x8000


with open("/tmp/flash.bin", "rb") as inp, \
     open("rom-test.hex", "wb") as out:
    for offset in range(addr, addr+524288, 2):
        word = struct.unpack("<I", inp.read(4))[0]
        header = f"{offset:06X}".encode() + b" "
        data = f"{word:08X}\n".encode()
        out.write(header + data)
