#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'big') + 1 # +1 for 0-terminator
    data = rng.read(datalen)
    out.write(header)
    out.write(struct.pack('<H', 4)) # log height in pixels
    out.write(struct.pack('<H', 4)) # log width in pixels
    out.write(b'\xF0\x00') # background color index
    out.write(struct.pack('B', (datal