#!/usr/bin/env python3

import struct
from typing import BinaryIO, Optional

from functions_pb2 import *

def read_function(file: BinaryIO) -> Optional[Function]:
    magic = file.read(16)
    if len(magic) == 0 or magic != b'__BIONIC_FUNCTIONS':
        return None
    
    name = ""
    while True:
        c = file.read(1)
        
        if not c:
            break
            
        elif c == bytes([1]):
            assert False, f"Unexpected null character in function name {name}"
