#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    data = rng.read(0x400 - 6) # 12 bytes left for XOR key
    xor = int.from_bytes(rng.read(4), 'big') & 0xFFFFFF
    for i in range(len(data)):
        data[i] ^= (xor >> ((7-i)%8)) % 0xff
    out.write(header + data)

# Generates a random Bitmap file into `out` using the
# random number generate `rng` (/dev/urandom)
def generate_random_bmp(
        rng: BinaryIO, out: BinaryIO
    ):
    header = struct.pack('<L', 0x4D42) # BM
    data = rng.read(datalen)
    out.write(header + data)
