import argparse
import random
import sys


class Node:

    def __init__(self):
        self.left = None
        self.right = None

        # 0 is leaf node (no more nodes below this one).
        # Otherwise it's an index to another node in the tree.
        # We'll assume there are at most 256 leaves and no more than 4 levels of indirection per node
        self._index = -1

    @property
    def index(self):
        return self._index

    @index.setter
    def index(self, value):
        if not isinstance(value, int):
            raise TypeError('The index must be an integer.')
        elif value < 0 or value > 255:
            raise ValueError('Index out of range.')

        self._index = value


class Tree:

    def __init__(self):
        self.root = Node()

    def _grow_tree(self, level=1):
        """Grow the BST by inserting new nodes."""
        assert 0 <= level <= 4
        n = self.root
        while True:
            if random.uniform(0, 1) <.5:
                if n.left == None:
                    n.left = Node()
                    break

                else:
                    n = n.left

            else:
                if n.right == None:
                    n.right = Node()
                    break

                else:
                    n = n.right


    def assign_indices(self, indices=[]):
        """Assign indices to all nodes from left to right"""
        queue = [self.root]
        for i, node in enumerate(queue):
            print(i)
            node.index = i
            if node.left!= None:
                queue.append(node.left)

            if node.right!= None:
                queue.append(node.right)

        return indices


if __name__ == '__main__':

    parser = argparse.ArgumentParser()
    parser.add_argument('--seed', type=int, default=None)
    args = parser.parse_args()

    seedval = args.seed
    if seedval:
        rng = random.Random(seedval)
    else:
        rng = random.SystemRandom()

    with open('/tmp/test.gif', 'wb') as f:
        generate_random_gif(rng.randrange, f)