#!/usr/bin/env python3

import sys

from PIL import Image, ImageDraw, PngImagePlugin, __version__ as pillow_ver
from math import sqrt, ceil

if not (pillow_ver[:3] == '5.0'):
    print('Please use pillow version 5.x for this script\n')
    exit()

# Generate an image with some unusual size and format
img = Image.new('L', (2**14+3, 1))
draw = ImageDraw.Draw(img)
draw.rectangle([(679, 0), (int((sqrt(5)-1)/2 * img.size[0]), img.size[1])], fill=(255,))
del draw

# Add metadata to the new image's PNG stream that will specify how it should be converted back into GIF
meta = PngImagePlugin.PngInfo()
meta.add_text('loopping', 'yes') # Make sure it loops infinitely
meta.add_text(('tEXt'), ('generator', 'random-gif'))
img.save(sys.stdout, format='GIF', append_images=[], loop=0, transparency=None, save_all=False, disposal=2, optimize=True, pnginfo=meta)