#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") % 256) + 1).to_bytes(1,"big"))

    # Now write the loop variable
    # -1 is 0xff
    #  0 is 0x00
    #  1 is 0x01
    # etc
    loopvar = (
            (int.from_bytes(
                rng.read(1), byteorder="big") % 5)
            | 0b10000000)
    print("loopvar",loopvar)

    loopvarstr = loopvar.to_bytes(1,"big")
    assert(len(loopvarstr) == 1)
    out.write(loopvarstr)
    # Pad with 0s
    for _ in range(7):
        out.write(b'\x00')

    # Pad with 0s up to 256 bytes
    padding = 256 - ((out.tell()+1)&0xff)
    for _ in range(padding):
        out.write(b'\x00')
    if padding > 0:
        badval = loopvar + 1

    print