#!/usr/bin/env python3

import argparse
import os
import sys

parser = argparse.ArgumentParser()

parser.add_argument('--in', dest='input', required=True,
                        help="Input file")
parser.add_argument('--out', dest='output', required=True,
                        help="Output file")

args = parser.parse_args()

with open(args.input, 'rb') as inp:
  with open(args.output, 'wb') as out:
    header = b'\x7fELF\x01\x01\x01' # little endian
    footer = bytes([0]*8)
    rng = inp.read()
    data = [rng[i].to_bytes(1, 'big') for i in range(len(rng)) if \
                0 <= int.from_bytes(
                rng.read(1), 'big') < 6]
    out.write(header + len(data).to_bytes(2, 'big') + \
                data + footer)
