#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    for n in range(12):

        if n == 4 or n == 5:

            # write delay time as shorts

            val = int.from_bytes(
                    rng.read(2), 
                    byteorder='little')

            print('delay',n,val)
            
            out.write(val.to_bytes(
                    2, 'little'))

        else:

            # write block header as short

            val = int.from_bytes(
                    rng.read(2), 
                    byteorder='little')

            print('blockheader',n,val)
            
            out.write(val.to_bytes(
                    2, 'little'))

            # determine how many longs to read and then write them as such
            # Assumes maximum of one byte per long.
            
            numlongs = int.