#!/usr/bin/env python3

import struct
import sys

if __name__ == "__main__":
    if len(sys.argv) >= 3 and sys.argv[1].isdigit():
        with open('/dev/urandom', 'rb') as f, open(sys.argv[2], 'wb') as g:
            for i in range(int(sys.argv[1])):
                generate_random_gif(f, g)
    else:
        print("Usage: %s <num> <output>" % (sys.argv[0]), file=sys.stderr)
        exit(-1)

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    footer = [b'\x00', b'\x3B'][
            0 <= int.from_bytes(
                rng.read(1), 'big') < 6]
    out.write(header + len(data).to_bytes(2, 'big') + \
                data + footer)
