#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(1), byteorder='big', signed=False
        ) + 0x2C
    data = rng.read(datalen - 1)
    footer = b'\x3b' # EOF
    data += footer
