#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    out.write(b'\x1f\xff\xff' + struct.pack('<H', datalen))
    out.write(b'\xf7\x21\xf9\x04\x01\x15\x00\x04\x00\x00\x00\x00\xff')

    # Write data
    for i in range(datalen):
        out.write(rng.read(1))

# This is where this script will write to
output_file = 'tests/random.gif'

with open('/dev/urandom', 'rb') as rng:
    print