#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff
    data = rng.read(datalen) # skip this one for now
    footer = '\x3b'.encode()
    out.write(header + datalen.to_bytes(3, 'big') + data + footer)
