#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # GIF89a header (6 bytes)
    out.write(b"GIF89a")
        
    width = struct.unpack("!H", 
                          rng.read(2))[0] + 1
            
    height = struct.unpack("!H",
                           rng.read(2))[0] + 1
            
    out.write(struct.pack('!HH', width, height))
    out.write(b"\xF7\x0F\x00")

    for y in range(height):
        for x in range(width):
            index = struct.unpack("!B",
                              rng.read(1), byteorder="big")
