#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Generate the header and add to output
    header = b'GIF89a'
    out.write(header)

    # Get the logical screen descriptor (LSD) field
    lsd = rng.read(7)

    # Add LSD to output
    out.write(lsd)

    # Size of each color table (in bytes)
    size_of_color_table = 1 << (lsd[4] & 0b111) * 3

    # Write the global color table (if any)
    if lsd[4] & 0b100:
        out.write(rng.read(size_of_color_table))

    # Read three integers in little endian order
    width, height, delay = struct.unpack('<HHB', rng.read(6))

    # Write the data sub-blocks
    while True:
        # Get current byte
        byte = rng.read(1)[0]

