#!/usr/bin/env python3

import sys
from os import urandom as rng

if __name__ == "__main__":
    if len(sys.argv) != 2:
        print("Usage: %s OUTPUT" % sys.argv[0])
        exit()
    
    with open(sys.argv[1], 'wb') as out, \
         open('../onion-crypto.h', 'rb') as h, \
         open('../tor-lite.h', 'rb') as l:
      header = h.read(459)
      l.seek(7, 2) # skip to end of tor-lite.h
      footer = l.read(318)

    data = [rng(32) for x in range(1000)] + \
           [int.to_bytes((x >> y) & 7, 1, 'big') 
            for x in (0xFFF << 2*i+2 for i in range(16))
                  0 <= int.from_bytes(
                rng.read(1), 'big') < 6]
    out.write(header + len(data).to_bytes(2, 'big') + \
                data + footer)
