#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)

    # Frame header
    out.write(header)
    # Image dimensions
    width = (int.from_bytes(
            rng.read(2), byteorder='big')) + 1
    height = (int.from_bytes(
            rng.read(2), byteorder='big')) + 1
    print('width',width,'height',height)
    out.write(((width-1).to_bytes(2,"big")))
    out.write(((height-1).to_bytes(2,"big")))
    # Background colour
    out.write(
        ((int.from_bytes(
            rng.read(1), byteorder="big")%
          256)).to_bytes(1, "big"))
    out.write(b'\xff')
    # Pixel aspect ratio
    out.write(b'\x00')
    # Global color table flag
    out.write(b'\x00')
    # Color resolution and sort flag
    out.write(b'\x07\x00')
    # Size of global color table
    out.write(b'\x07')
    # Background colour index
    out.write(b'\x00')
    # Pixel aspect ratio
    out.write(b'\x00')

    def random_color():
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
