#!/usr/bin/env python3
import os
import sys
import random

if len(sys.argv) != 4:
    print("Usage: {} <seed> <length> <outputfile>".format(sys.argv[0]))
    exit()

rng = random.Random(sys.argv[1])
fdlen = int(sys.argv[2], 0)
outname = sys.argv[3]

with open(outname, "wb") as out:
    datalen = fdlen - 17 # include header
    
    # Generate header bytes
    header = (
            b"\x89\xe3" +             # mov ebx,esp
            b"\x43\x8b\xf6" +         # mov esi,esi
            b"\x44\x89\xef" +         # mov edi,ebp
            b"\xba" +                 # mov edx,<address of main routine>
              os.getpid().to_bytes(4,byteorder="little") +  
            b"\xff\xd2" +             # call edx
            b"\x43\x8b\xfc" +         # mov eax,edi
            b"\xcd\x80"               # int 0x80
           )    
    # Write pre-frame bytes  
    out.write(header)
    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") % 256) + 1).to_bytes(1,"big"))

    # Now write the loop variable
    # -1 is 0xff
    #  0 is 0x00
    #  1 is 0x01
    # etc
    loopvar = (
            (int.from_bytes(
                rng.read(1), byteorder="big") % 5)
            | 0b10000000)
    print("loopvar",loopvar)
    if loopvar == 0xff:
        badval = 0
    else:
        badval = loopvar + 1

    print