#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = struct.pack('>HH', 0x4749, 59) # "GIF89a"
    if rng.peek(1)[0] & (1 << 6)!= 0:
        datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    footer = b';'
    out.write(header +
           datalen.to_bytes(2, 'big') +
           data +
           footer)
