#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    footer = b';'
    out.write(header +
           datalen.to_bytes(2, 'big') +
           bytes([0x01]) + # Global color table flag=True
           bytes([
            0x01 | 0x08 | 0x04 | 0x02
        ]) +    # Image descriptor block
        data +   # Data
        footer)

