#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    assert len(header)==6
    out.write(header +
              (datalen).to_bytes(3,"little")+ 
              bytes([int.from_bytes((rng.read(1)),"big")%256]) + 
              bytes([int.from_bytes((rng.read(1)),"big")%256]))
    
    # Write all blocks until we get to an image descriptor
    while True:
        blocktype = int.from_bytes(
                rng.read(1), byteorder="big")
        
        if blocktype == 0x2c or blocktype == 0x21: 
            break
            
    print("blocktype", hex(blocktype))
 
    # Write the image descriptor and palette
    out.write(struct.pack("<BHHHBBBBBHB",
                          *bytearray([
                                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
     
    # Read past this frame
    while True:
        blocktype = int.from_bytes(
                rng.read(1), byteorder="big")
