#!/usr/bin/env python3

import sys, math


def read_data():
    data = []

    for line in sys.stdin:
        data.append(line)

    return data


def part1(data):
    # hmm.... 
    # The coordinate system consists of several layers, each with a thickness of 1. 
    # Within each layer, the position of each wire is expressed as (x, y), where x, y are both integers.
    # Of course, the top-left coordinate represents the location of the first wire; the remaining 
    # wires pierce just below this wire and are at an increasing distance to it.

    connections = {}

    def add_connection_point(point1, point2, steps=0):
        if point1 not in connections:
            connections[point1] = { "points": [], "steps": steps }

        if point2 not in connections:
            connections[point2] = { "points": [], "steps": steps }

        if point2 not in connections[point1]["points"]:
            connections[point1]["points"].append(point2)

        if point1 not in connections[point2]["points"]:
            connections[point2]["points"].append(point1)

        if connections[point1]["steps"] == 0 or connections[point1]["steps"] > steps:
            connections[point1]["steps"] = steps


    wires = [wire.split(",") for wire in data]

    max_x = -math.inf
    max_y = -math.inf
    
    for wire in wires:
        pos_x = 0
        pos_y = 0
        step = 0 

        for move in wire:
            direction = move[0]
            length   = int(move[1:])

            for i in range((length)):
                step += 1

                if direction == 'R':
                    pos_x += 1
                elif direction == 'L':
                    pos_x -= 1
                elif direction == 'U':
                    pos_y += 1
                else: 
                    pos_y -= 1
                
                add_connection_point([pos_x, pos_y], [max_x, max_y])

                if pos_x >= max_x:
                    max_x = pos_x

                if pos_y >= max_y:
                    max_y = pos_y
        
    
    start = None
    end   = None

    for connection in connections:
        points = connections[connection]["points"]
        
        # do we have more than one?
        count = len(points)
            
        if count < 2:
            continue

        shortest_distance = math.inf 
        for point in points:
            d = abs(point[0] + point[1])
            if d < shortest_distance:
                shortest_distance = d
                start             = connection 
                end               = point

    print("Distance between %d,%d and %d,%d is %d" % (start[0], start[1], end[0], end[1], shortest_distance))
        
        



def part2(data):
    pass


if