#!/usr/bin/env python3

import random
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    for i in range(datalen):
        val = random.randint(
                0,255)

        # Make sure we don't have any unused bits set
        while((val & ~0xff)!= 0):
            val = random.randint(
                    0,255)

        out.write(val.to_bytes(1,"big"))

    # Now write the loop variable
    # -1 is 0xff
    #  0 is 0x00
    #  1 is 0x01
    # etc
    loopvar = (
            (random.randint(0,4)
             | 0b10000000))
    print("loopvar",loopvar)
    if loopvar == 0xff:
        badval = 0
    else:
        badval = loopvar + 1

    print