#!/usr/bin/env python3

import io as StringIO
import math
import os
import struct
from typing import Sequence, TextIO


def generate_randomness() -> StringIO.BytesIO:
  return StringIO.BytesIO(os.urandom(math.ceil(1e6))) 


class GifWriter():
  def __init__(self, 
               x: int=100,
               y: int=100,
               max_colors :int=256,
               color_depth: int=8) -> None:
    self._max_colors = max_colors
    self._color_depth = color_depth
    
    self._data = []
    self._offsets = {}
    
    self.add_frame(x, y)
    
  def add_frame(self, 
                w: int=100,
                h: int=100,
                palette_size :int=-1) -> None:
    
    offset = len(self._data)
    lzw_stream = LZWEncoder(w*h//2)
    
    while self._max_colors > len(lzw_stream._dictionary):
      lzw_stream.encode(ord("A"))
      
    if palette_size == -1: 
      palette_size = self._max_colors
      
    self._offsets[(offset, lzw_stream)] = [palette_size]

  @staticmethod
  def _render_header(width :int, 
                     height: int,
                     nb_frames: int) -> bytes:
    
    return "GIF89a".encode('ascii') \
             + width.to_bytes(2,"little", signed=False) \
             + height.to_bytes(2,"little", signed=False) \
             + ((nb_frames % 0xff)).to_bytes(1,'little', signed=False)\
             + ("\x00").to_bytes(1, 'little', signed=False)\
             + "\x00\x00"
    
    
  @property
  def frames(self) -> Sequence[str]:
    result = []
    return result
  

    
    
  
