#!/usr/bin/env python3

import struct
import random
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # Random length between 5 and (2^16)-1, inclusive
    datalen = random.randint(5, 2**16-1)
    data = rng.read(datalen)
    
    # There are only two valid endings in a GIF
    ending = random.choice([b'\x00\x3B', b'\x03\xF9'])
    out.write(header + len(data).to_bytes(2, 'big') + \
                data + ending)