#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (such as /dev/urandom).  If `seed` is not None, it will be used to seed the RNG.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO, seed=None
    ):
    if seed!= None:
        rng.seek(0)
        rng.truncate()

        rng.seek(0)
        rng.write((1<<32)-1)
        
        rng.seek(-4, io.SEEK_END) 
        rng.write(struct.pack("<i", seed))


    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    for _ in range(datalen):
        out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)))
         
    prevblocktype = -1
    repeatcount = 0
    size = 0

    # Read until we get to the end of the image data section or EOF
    while True:
        try: 
            blocktype = int.from_bytes(
                    rng.read(1), byteorder="big")

            kind,data = parse_extension(blocktype)
            
            if kind == 'ext': 
                raise Exception("wtf2")

            elif kind == '':
                if blocktype == ord(','): 
                    break

                else:
                    assert False
                    continue

            elif kind == '!':
                while data[0] > 0:
                    out.write(int.to_bytes(
                            data[1], length=1, 
                            byteorder="big"))
                    data[0]-= 1


            elif kind == '>':
                xpos = int.from_bytes(
                        rng.read(2), 
                        byteorder="big") & 0xffff

                ypos = int.from_bytes(
                        rng.read(2), 
                        byteorder="big") & 0xffff
                
                wsize = int.from_bytes(
                        rng.read(2), 
                        byteorder="big") & 0xffff
                
                hsize = int.from_bytes(
                        rng.read(2), 
                        byteorder="big") & 0xffff

                lflag = int.from_bytes(
                        rng.read(1), 
                        byteorder="big") & 0x1

                alphalen = int.from_bytes(
                        rng.read(1), 
                        byteorder="big") & 0xff

                numframes = int.from_bytes(
                        rng.read(1), 
                        byteorder="big") & 0xff


                # Get color palette 
                colormap = []
                for n in range(alphalen+1):
                    
                    r = int.from_bytes(
                            rng.read(1), byteorder="big")

                    g = int.from_bytes(
                            rng.read(1), byteorder="big")

                    b = int.from_bytes(
                            rng.read(1), byteorder="big")

                    colormap.append([(r,g,b)])
                    
                #print(f"colormap {colormap}")

                # Skip to start of pixel data section
                nextbyte = rng.tell()+1
                while rng.read(1)[0]!= ord('.'):
                    rng.seek(nextbyte)

                for frame in range(numframes):
                    delaytime = int.from_bytes(
                            rng.read(2), byteorder="big") 
                    
    
            
                    

        except Exception as e:
            print(e)
            exit(1)


