import sys
import os
import time
import secrets

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:


    version=b"GIF89a"
    flags=[None]*7
    globlct=False
    bgcolor=False
    gctsize=False
    lctsize=False
    sortflag=False
    colorres=False
    nbits=True
    gcrange=False
    interlace=False
    sortedtable=False



    if flags[0]==None :flags[0]=secrets.randbelow(2)

    while True :

        #print(flags)
        if not nbits : break

        nbits=flags[0]!=flags[4]
        gcrange=(not flags[3]) and bool(secrets.randbelow(2))
        interlace=bool(secrets.randbelow(2))


        if nbits!= flags[0]:

            if gcrange!= (not flags[3]):

                raise Exception("Bad combination of NBITS and GCRANGE")

            flags[0]=nbits

        elif flags[0] == False :

            if gcrange!= (not flags[3]):

                raise Exception("Bad combination of NBITS and GCRANGE")


            if not flags[5]:
               break
           else :

               flags[5]=False


        elif gcrange!= (not flags[3]):raise Exception("Bad combination of NBITS and GCRANGE")




    if flags[0] == True : 
        depth=8   
    else :    
        depth=1<<flags[1]
        
    transparent=bool(secrets.randbelow(2))

    if flags[0] == True : 
        
        bgcolor=bool(secrets.randbelow(2))
        

    sortedtable=bool(secrets.randbelow(2))
    
    if flags[0] == True : 
        lctsize=(secrets.randbelow(4)+1) if flags[3] else False
    else :
        lctsize=(secrets.randbelow(8)+1) if flags[3] else False


    if flags[0] == True :
        gctsize=(secrets.randbelow(4)+1) if flags[3] else False
    else :
        gctsize=(secrets.randbelow(8)+1) if flags[3] else False




    

    #print([version,globlct,bgcolor,gctsize,lctsize,sortflag,colorres,nbits,gcrange,interlace,sortedtable,depth,transparent,flags[-1]])
    out.write(version)



    # LZW minimum code size
    out.write(((depth&0x0f)<<4)|((depth>>4)&0x0f))
    
    image_dim_x=secrets.randbelow(10)*2+1
    image_dim_y=secrets.randbelow(10)*2+1
    # Width x Height
    out.write(((image_dim_x)&0xff)|((((image_dim_x)>>8)&0xf)<<4))
    out.write(((image_dim_y)&0xff)|((((image_dim_y)>>8)&0xf)<<4))

    flagsraw=0
    for flag in [globlct,bgcolor,gctsize,lctsize,sortflag,colorres,nbits,gcrange,interlace,sortedtable]:
        flagsraw |= flag << flags.index(flag)

    
    out.write(flagsraw.to_bytes(1,"little",signed=False))

    localcolortable=[]
    globalcolortable=[]

    if flags[0] == True : pass
    else : depth=1<<(depth%8)

    if flags[0] == True : 

        localcolortable.append(0)
        
        

    else :

        lastused=0
        while len(localcolortable)<depth:
            
            r=secrets.randbelow(256)
            g=secrets.randbelow(256)
            b=secrets.randbelow(256)
            

            used=False
            for c in localcolortable:
                
                if colors_are_close(r,g,b,c):
                    
                    used=True
                    break
                
            if not used:
                localcolortable.append([r,g,b])


                if len(globalcolortable)>lastused:

                    globalcolortable[lastused]=[r,g,b]
                    
                else:
                
                    globalcolortable+=[[r,g,b]]

                    

                lastused+=1

        
        lastused-=1
        globalcolortable=globalcolortable[:lastused+1]

     


    if flags[3] :

        # Global color table length
        out.write((len(globalcolortable)&0xff))
        out.write((((len(globalcolortable))>>8)&0xff))

        # Color resolution
        out.write(8)

        # Sorting method
        out.write(0)

    
    
        for rgb in globalcolortable:
            
            red   =(rgb[0]&0xfc) | (((rgb[0]>>6) & 0x03)<<4)
            green =((rgb[1]&0xfc) >> 2) | (((rgb[1]>>6) & 0x03)<<6) 
            blue  =((rgb[2]&0xf8) >> 3) | (((rgb[2]>>5) & 0x01)<<7) 

            out.write((red).to_bytes(1,"little",signed=False ))
            out.write((green).to_bytes(1,"little",signed=False ))
            out.write((blue).to_bytes(1,"little",signed=False ))
 

 

  
    
    else :

        # Local color table length
        out.write((len(localcolortable)&0xff))
        out.write((((len(localcolortable))>>8)&0xff))

        
  
        for rgb in localcolortable:


            red   =(rgb[0]&0xfc) | (((rgb[0]>>6) & 0x03)<<4)
            green =((rgb[1]&0xfc) >> 2) | (((rgb[1]>>6) & 0x03)<<6) 
            blue  =((rgb[2]&0xf8) >> 3) | (((rgb[2]>>5) & 0x01)<<7) 
            

            out.write((red).to_bytes(1,"little",signed=False ))
            out.write((green).to_bytes(1,"little",signed=False ))
            out.write((blue).to_bytes(1,"little",signed=False ))


    def add_chunk(*args,**kwargs):
        add_chunk_type(*args,**kwargs)
        add_chunk_data(*args,**kwargs)
        return chunk_length
    
    
    
    
    def add_chunk_type(*args,**kwargs):
        nonlocal chunk_length,chunk_type
        typ=args[0].lower()
        chunk_type=typ.encode()+b"\0"*7
        chunk_length=0
        chunk_type=chunk_type[:chunk_length]


    def add_chunk_data(*args,**kwargs):
        nonlocal chunk_length,chunk_data
        bytes_buffer=""
        if kwargs["data"] is not None:
            bytes_buffer=kwargs["data"](*args,**kwargs)
        data_length=len(bytes_buffer)
        chunk_data=add_chunk_to_buffer(bytes_buffer,data_length)
        chunk_length+=data_length


    def get_chunk():
        nonlocal chunk_type,chunk_length,chunk_data
        return b"".join([chunk_type]+[struct.pack("<H",chunk_length)]+[chunk_data])
    


    
    def add_frame(**kwargs):
        nonlocal framelist
        
        
        if type(kwargs["x"])==tuple:
            if len(kwargs["x"])>1 and len(kwargs["y"])<=1 or \
                        len(kwargs["x"])<1 and len(kwargs["y"])>=1 :
                            
                raise ValueError("A tuple can only be used to set both X and Y values at once.") 
                
            
            
            
            
        if type(kwargs["delay"])==tuple:
            if len(kwargs["delay"])>1 and len(kwargs["transdelay"])<=1 or \
                        len(kwargs["delay"])<1 and len(kwargs["transdelay"])>=1 :
                            
                raise ValueError("A tuple can only be used to set both DELAY and TRANSPARENTDELAY values at once.") 


            
        if "subblocks" not in kwargs :
            kwargs["subblocks"]=generate_frame(
                            **{k:(v if k!="data" else lambda *a,**kw:[v.bit_length()])
                               for k,v in kwargs.items()}
                                 )
            
        tmp={**kwargs}
        del tmp["subblocks"]
        tmp["transparency"]=(kwargs["transparent"] if kwargs["transparent"]!=None else args[0]["transparent"][0]) if "transparent" in kwargs else (args[0]["transparent"][0] if args[0]["transparent"]!=None else False)
        tmp["xposition"]=(kwargs["x"] if type(kwargs["x"])!=tuple else kwargs["x"][0]) if "x" in kwargs else args[0]["x"]
        tmp["yposition"]=(kwargs["y"] if type(kwargs["y"])