#! /usr/bin/python3

import argparse
import os
import sys
import shlex
import subprocess as sp

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Image size (2 bytes big endian integer) 
    width = rng.read(1)[0] + 1
    height = rng.read(1)[0] + 1

    print("Size",width,"x",height)

    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
     
    # Read past this frame
    while True:
        blocktype = int.from_bytes(
                rng.read(1), byteorder="big")
