#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # I'm no expert in GIFs but this should work for any of them.
    # First 6 bytes are magic header.
    out.write(b"GIF89a\x01")

    # Next 7 bytes: screen descriptor (SD).
    sd = bytearray([0] * 7)
    rng.readinto(sd)
    out.write(bytes(sd))

    # Global color table (GC)
    gc = bytearray([0] * 256 * 3)
    rng.readinto(gc)
    out.write(struct.pack("B", len(gc) / 3 - 1))
    out.write(bytes(gc))

    # Image block (IB)
    ib = bytearray([0] * 14)
    rng.readinto(ib)
    out.write(bytes(ib))

    # Local color table (LC)
    lc = bytearray([0] * 256 * 3)
    rng.readinto