#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big', signed=False
        ) % 1024 + 1 # <= 1024 bytes of data
    data = rng.read(datalen)
    footer = rng.read()[:7] # 6 is for the length field

    if len(header) != out.write(header):
        raise IOError("Could not write to output stream")
    if -1 == struct.pack('<H', datalen).encode("latin-1").find