#!/usr/bin/env python3

# pip3 install pycparser
import random, sys, struct
from pycparser import c_ast

rng = random.Random()
#rng.seed(1234567890)
out = open('random-data', 'wb')
for i in range(10):
    headerlen = (
        2 * rng.randint(0,1)   # size up to 2 bytes
      + rng.randint(0,1)       # offset up to 1 byte
      + rng.randint(0,1)       # whether it's signed or not
    )
    datalen = rng.randint(0,1) + rng.randint(0,1) # < 2 bytes of data
    
    header = rng.bytes(headerlen)
    data = rng.bytes(datalen)
    out.write(header + data)
out.close()

out = open('structured-data', 'wb')
for i in range(10):
    headerlen = (
        1                          # struct length
      + rng.randint(0,1)           # field count, potentially variable
      + rng.randint(0,1)           # whether it's a bitfield
    )
    datalen = (
        rng.randint(0,1)            # padding
      + rng.randint(0,1)            # signedness
        ) % 1024 + 1 # <= 1024 bytes of data
    data = rng.read(datalen)
    out.write(header + data)
