#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big', signed=False
        ) % (0xffff + 1) - 1
    # We also ensure that `datalen` is non-zero
    if not datalen:
        datalen += 1
    out.write(header + len(header).to_bytes(4, 'big'))
    for _ in range(datal