#!/usr/bin/env python3

import struct
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
rng: BinaryIO = open('/dev/urandom', 'rb')

# output file
out: BinaryIO = open('nsp-log.txt', 'wb')

# Write initial newline
out.write(bytes([0x0A]))

while True:
    header = rng.read(4)
    if not header or header == b'\xFF\xFF\xFF\xFF':
        break  # EOF
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
