#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the data from `inp`.
def generate_gif(inp : BinaryIO, out : BinaryIO) -> None:
    # Read all of inp and write it to out.
    while True:
        chunk = inp.read(1024 * 1024)
        if not len(chunk):
            break
        out.write(chunk)
    
    # We're done reading - add some end blocks.
    out.write(b'\x3B')