#!/usr/bin/env python3

import struct
from typing import BinaryIO

# The only valid GIFs are those with 1-byte data blocks
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big', signed=False
        ) % 1024 + 1 # <= 1024 bytes of data
    data = rng.read(datalen)
    out.write(header + data)
