#!/usr/bin/env python3

import struct
from hashlib import sha256

def int_to_bytes(x):
    return x.to_bytes((x.bit_length() + 7) // 8, 'big')

def bytes_to_int(bb):
    return int.from_bytes(bb, 'big')

def hmac_sha256(key, data):
    key = b'\x00\x00' * 64 + key
    if len(key) > 64:
        key = sha256(key).digest()
    key_xor_ipad = bytearray([key[i] ^ 0x36
                              for i in range(len(key))])
    key_xor_opad = bytearray([key[i] ^ 0x5C
                              for i in range(len(key))])
    inner = sha256(key_xor_ipad + data)
    return sha256(key_xor_opad + inner.digest())
