#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' # http://www.matthewflickinger.com/lab/whatsinagif/bits_and_bytes.asp
    width  = rng.read(2)[::-1] # little endian unsigned short
    height = rng.read(2)[::-1] # ditto
    packed = rng.read(1)
    background = rng.read(1)
    pixel_aspect = rng.read(1)
    global_color_table = [rng.read(3) for _ in range(2 ** ((packed[0] & 7) + 1))]
    out.write(header + width + height + packed + background + pixel_aspect)
    for color in global_color_table:
