#!/usr/bin/env python3
import argparse
from itertools import combinations, permutations
import numpy as np
import pandas as pd

parser = argparse.ArgumentParser(description='Testing model performance')
parser.add_argument('-o', '--outfile', type=str)
args = parser.parse_args()

# Read data
df = pd.read_csv("../results/mml_result.tsv", sep="\t")
smi = df.smiles.values
y = df.pIC50.values[:, None]
X = (df[['DrugDescriptors']].values - df[['DrugDescriptors']].mean()) / df[['DrugDescriptors']].std()

# Predict with models and compute RMSE
print("\nCompute RMSE...")
rmse = []