#!/usr/bin/env python3

from typing import BinaryIO


# Generates a random GIF file into `out` using the pattern given by `data`.
def gen_gif(out: BinaryIO, data):
    out.write(b'\x47\x49\x46\x38\x37\x61')
    while True:
        byte = data[0]
        if not (byte & 0x80):
            out.write(bytes([byte]))
            break
        else:
            length = sum(((byte % 2**(i+1)) // 2**i) * 2**(i*7) for i in range(5)) + 1
            
            out.write(bytes([byte]))
            byte = data[1]
            while byte != 0:
                out.write(bytes([byte