#!/usr/bin/env python3

# Author::    Justin Flannery  (mailto:juftin@juftin.com)

"""
Project Configuration
"""
import os
from typing import Dict, List

__all__ = [
    "PROJECT_CONFIG", 'BASE_DIR', 'LOCAL', 'DEV', 'STAGING', 'PROD',
    'BASE_URL', 'SENTRY_DSN', 'DEFAULT_CITY', 'DEFAULT_STATE'
]

# Command Line Interface Arguments
LOCAL: str = "local"
DEV: str = "dev"
STAGING: str = "staging"
PROD: str = "prod"
ENVIRONMENTS: List[str] = [LOCAL, DEV, STAGING, PROD]
BASE_DIR: str = os.path.dirname(os.path.dirname(__file__))
SENTRY_DSN: str = ""