#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):  # pylint: disable=too-many-locals
    header = 'GIF89a'.encode('ASCII')
    out.write(header)

    width = int.from_bytes(rng.read(2), 'big', signed=False) + 1
    height = int.from_bytes(rng.read(2), 'big', signed=False) + 1
    image_size = width * height
    out.write(struct.pack('<HHB', width, height, 0xF))
    out.write(b'\x00\xff\xFF\xff')

    for _ in range(image_size - 1):
        color_index = int.from_bytes(rng.read(1), 'big', signed=True) % 256
        out.write(color_index.to_bytes(1, byteorder='little'))

    for _ in range((width * (height // 4) * 4)