#!/usr/bin/env python3

import struct
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO=None, data_size: int=1024*1024):
    # write GIF header
    gif_header = b'GIF89a' + b'\x01\x00'
    if out is None:
        out = open('out.gif', 'wb')
    out.write(gif_header)
    
    # get screen size from user input
    try:
        width, height = map(int, input("Enter image size (width,height): ").split())
    except ValueError as e:
        print("Invalid values for size")
        return 1
        
    # write size of the image
    out.write(struct.pack("<HH", width, height))
    
    # now we need to fill the rest with data
    write_data = True
    while True:
        # we have three options
        # - write a series of zeroes
        # - write some random bytes
        # - exit
        choice = input("\nWhat would you like to do? [z]ero [r]andom or [q]uit: ")
        
        # if we want to quit, break out of loop and exit
        if choice == 'q':
            write_data = False
            break
            
        elif choice != 'z' and choice != 'r':
            print("Invalid input")
            continue
        
        # we know what to do next
        amount = input("How many bytes would you like to {}? ".format(choice))
        
        # we need a long integer first
        try:
            amount = int(amount)
        except ValueError as e:
            print("Invalid value for byte count")
                
        # check that it doesn't exceed the maximum data length
        if amount > data_