#!/usr/bin/env python3

from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    rng.readinto(out.write(header))
    width = 2 ** (rng.read(1)[0] % 5 + 4)
    height = 2 ** (rng.read(1)[0] % 7 + 4)
    out.write('<s>{:d}x{:d}:'.format(width, height).encode())
    color_map_size = rng.read(1)[0] % 6 + 1
    out.write(b'\x