#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def gen(out: BinaryIO, rng):
    header = b'GIF89a'+struct.pack('>H', rng.randint(500, 600))

    for i in range(int.from_bytes(rng.read(1),'big')):
        datalen = int.from_bytes(
            rng.read(2), 'big', signed=False
        ) % 1024 + 1 # <= 1024 bytes of data
    data = rng.read(datalen)
    out.write(header + data)
