#!/usr/bin/env python3

import struct
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(4), 'little') + 1 # add color map length byte
    width, height = map(int, str(input('Enter the dimensions of a GIF with one frame (width x height): ').strip()).split())

    # write headers to output file
    out.write(header+struct.pack('<HH', width, height)+b'\xf7\x00'+struct.pack('B', datalen))
    out.flush()
    
    while True:
        length_prefixed_subblock = rng.read(1 << len(str(datalen)))
        if not length_prefixed_subblock:
            break
        
        subblocks = []
        for i in range(len(length_prefixed_subblock)):
            subblocks += [
                bytes([len(length_prefixed_subblock)]), 
                length_prefixed_subblock[i]
            ]

        out.write(b"".join(subblocks))
        out.flush()

