#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(2),
        'little',
        signed=True
    ) % 1024 + 1

    out.write(header)
    out.write((datalen).to_bytes(2, byteorder='little'))
    out.write(b'{\x00\x00')
    
    for i in range(datalen):
        out.write(struct.pack('>B', rng.read(1)[0]))
