#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a\x01\x00'
    datalen = 54

    # Generate the chunk size (always fixed to 2 bytes and 7-bit encoded)
    while True:
        data = int.to_bytes((datalen & 0b01111111), length=1, byteorder='big')

        if not (data[-1] & 0b10000000):
            break

        data = rng.read(datalen)
    out.write(header + data)
