#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a\x01\x00\x00\x00\xff\x00,\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01\x00;'

    datalen = (
            int.from_bytes(
                rng.read(
                    1
                    ),
                'little',
                ) % 1024 + 1 # <= 1024 bytes of data
    data = rng.read(datalen)
    out.write(header + data)
