#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO):
    # Header fields from https://www.w3.org/Graphics/GIF/spec-gif89a.txt
    width = 640
    height = 450

    global_color_table_size = 2**bpp

    color_table_size = min(global_color_table_size, max(1 << bpp | (bpp == 1), num_colors))
    print("color table size is", color_table_size)

    background_color = rng.read(1)[0] % color_table_size
    print("background color is", background_color)

    pixel_aspect_ratio = rng.read(1)[0] & 7
    print("pixel aspect ratio is", pixel_aspect_ratio)

    # Logical screen descriptor
    out.write(struct.pack('<6sBHHBBB',
                         'GIF89a'.encode('ascii'),
                         0x2C, # logical screen descriptor block size
                         width, height,
                         0x87, # color table flag set to true
                         bpp, # bits per pixel
                         background_color + 1,
                         pixel_aspect_ratio))

    for i in range(num_colors):
        r = rng.read(1)[0]
        g = rng.read(1)[0]
        b = rng.read(1)[0]

        if bpp < 8 and has_transparency:
            out.write(b'\x00')

        out.write(bytes([r,g,b]))

    # Global color table trailer
    out.write(struct.pack('<B', 0))

if