#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
    datalen: int, out: BinaryIO, seed: bytes):

    # This is required since Python's random module acts weird with some
    # seeds...
    rng = open("/dev/urandom", "rb")
    header = (b'GIF89a'
              + struct.pack('>H', datalen)
              rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)

