#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width  = 640   # max is 1024
    height = 480   # max is 768

    out.write(header)
    print(f"Writing {width}x{height}")
    out.write(struct.pack("<HH", width, height))
