#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG as source of randomness. This is mainly here to show
# off how StructLiterals in Python3+ can be used for packing and unpacking.


class RandomGenerator:
    def __init__(self, seed):
        self._random = 0x123456789abcdef0
        self._seed = int.from_bytes(seed, "little")

    def read(self, n=None):
        if isinstance(n, list):
            n = sum(n)

        if not (n > 0 or n < 0):
            raise ValueError("Cannot read negative amount")

        retb = b""

        while len(retb) < n:
            self._random ^= ((self._random >> 7) | (self._random << 25)) ^ (
                self._random * 0xa24baed4963ee407
            )

            self._random &= 0xffffffffffffffff
            self._random ^= (((1 << 48) - 1) & self._seed)

            retb += self._random.to_bytes((len(retb) // 8) + 1, byteorder="big", signed=False)[:n]

        return retb[:n]


with open("./test.gif", "wb+") as f:
    with open("/dev/urandom", "rb") as seed:
        makegif(f, size=[2 ** 16, 2 ** 16])  # noqa: F821
    data = rng.read(datalen)
    out.write(header + data)
