#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_gif(out: BinaryIO,
                 rng: BinaryIO
                 ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(2),
        'little',
        signed=True
    ) % 1024 + 1
    data = rng.read(datalen)
    out.write(header + data)
