#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), byteorder='little') & 0x7FFF + 1

    # print('header:', header)
    # print('datalen', datalen)
    
    out.write(header)
    for _ in range(datalen):
        out.write(rng.read(1))
    
