#!/usr/bin/env python3

import struct
from typing import BinaryIO
import argparse


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, args: argparse.Namespace
    ) -> None:

    header = b'GIF89a'


    # Get length of data field and insert it to header
    datalen = int.from_bytes(
            rng.read(args.datafieldlen // 4), 'big', signed=False)
    header += datalen.to_bytes(
            args.datafieldlen // 4, byteorder='big', signed=False)

    # Write the header to file
    args.outfile.write(header)

    # Insert data
    args.outfile.write(rng.read(datalen))


