#!/usr/bin/env python3

import sys
import os
import io
import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (read from /dev/urandom or argv[1])
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    # Default to 4096 bytes
    if len(sys.argv) < 2:
        datalen = 4096
    else:
        try:
            datalen = int(sys.argv[1], base=0)
        except ValueError as _:
            print("Could not parse length argument")
            exit(-1)


    header = b'GIF89a'
    data = rng.read(datalen)
    out.write(header + data)


