#!/usr/bin/env python3

import struct
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    header = b'GIF89a'

    # get 3 bytes big endian to represent how many more bytes we need to read
    # from /dev/urandom (this is a short gif with no color map and only one row)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    # read that many bytes into the `data` variable
    data = rng.read(datalen)
    # write everything into output file 
    out.write(header + data)