#!/usr/bin/env python3
"""Genertates a random gif image."""

import os
import sys
from typing import BinaryIO

from faker import Faker
from PIL import Image, ImageDraw, ImageFont

from utils import get_input

def generate_random_gif():
    """Generates a random gif using pillow."""
    fake = Faker()

    text: str = fake.text()[0:4]
    img: Image = Image.new('RGB', size=(64, 64), color=(fake.pyint(),
                                                       fake.pyint(),
                                                       fake.pyint()))
    draw: ImageDraw = ImageDraw.Draw(img)
    font = ImageFont.truetype('/usr/share/fonts/opentype/noto/'
                              'NotoSans-Regular.ttf',
                              15)
    draw.text((0, -7),
              text=text,
              fill='#000',
              align="center",
              anchor="mm",
              font=font)
    filename = f'{text}.png'
    img.save("/tmp/" + filename)
    cmdline = ["convert", "/tmp/" + filename, "-coalesce",
               "-fuzz", "5%", "-layers", "OptimizePlus",
               "-alpha", "Off", "/tmp/" + filename ]
    os.system(" ".join(cmdline))
    with open("/tmp/" + filename[:-4] + ".gif", mode='rb') as fin:
        return fin.read()
    
