#!/usr/bin/env python3

import os
from typing import BinaryIO

# Generates a random GIF file with the given length into `out`.
# The seed is generated from `/dev/urandom`.
def generate_random_gif(length: int, out: BinaryIO):
    rng = open('/dev/urandom')

    # Write the initial "magic" bytes
    out.write(b'GIF89a')

    # Write the width and height of the image (both zero for simplicity)
    out.write(struct.pack('<HH', 0, 0))

    # Write the color table (two colors only)
    # All the entries in the color table are equal to the first entry here
    out.write((256 * (3)).to_bytes(768, byteorder='big'))

    # Write loop control code
    # We use a zero delay between frames, infinite iterations
    out.write(b'\x00\x00\xff\xff\xff')

    # Write image data
    while True:
        if length <= len(os.read(rng.fileno(), length)):
            break

        length -= len(os.read(rng.fileno(), length))

    out.write(os.read(rng.fileno(), length))