#!/usr/bin/env python3

import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the parameters in `parameters`.
def generate_gif(out: BinaryIO, parameters):
    width = parameters.get("width", 1)
    height = parameters.get("height", 1)

    # GIF header
    out.write('GIF89a'.encode())                     # Magic
    out.write(struct.pack("<H", width))              # Width
    out.write(struct.pack("<H", height))             # Height
    out.write(b'\xF0\x00')                           # Background color index
    out.write(b'\x00')                               # Aspect ratio (none)

    # Global color table (a single default color of 0)
    out