#!/usr/bin/env python3

import struct
from binascii import hexlify, unhexlify
import json

from cryptography.hazmat.primitives.ciphers import Cipher, algorithms, modes
import hashlib

# key = b'0123456789abcdef'
key = bytearray([0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF])
iv = b"\x00\x00"

block_size_bytes = 32
plaintext = "Hello World"
encrypted = encrypt(plaintext)
decrypted = decrypt(encrypted)
print("Decrypted: {}".format(decrypted))
assert plaintext == decrypted

"""
This file shows how to use AES with CBC mode for encryption and decryption of arbitrary data using a fixed key and IV
"""


def encrypt(message):
    # Create a cipher object that will be used to encrypt the message.
    # block_size * 8 defines the size of each block in bits.
    cipher = Cipher(algorithms.AES(key), modes.CBC(iv), backend=None)

    # The encrypter is already initialized with the key and iv, so we can directly call encrypt() to get our cipher text.
    encrypter = cipher.encryptor()
    return encrypter.update(unhexlify(message)) + encrypter.finalize()


def decrypt(ciphertext):
    """
    Decrypts a given ciphertext by calling the `decrypt()` method on the decrypter object.
    :param ciphertext: The cipher text as bytes
    """

    # Create a cipher object that will be used to decrypt the message.
    # block_size * 8 defines the size of each block in bits.
