#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    d = rng.read(datalen) # payload data
    color_table_length = 2 ** (3 + (ord(d[0]) & 7))
    colors = [
            struct.unpack('BBB', rng.read(3))
                for _ in range(color_table_length)
          ]
    while True:
        t = ord(d[0])
        if t == 0x21 or t == 0x3b:
            out.write(struct.pack('!B', t))
            break
        else:
            out.write(struct.