#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    for i in range(4):
        header += struct.pack('B', 0x21) # Extension block
        header += struct.pack('BB', 0xf9, 4)
        header += struct.pack('B', (i+1)*36/65536)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)

