#!/usr/bin/env python3
"""
Given a list of numbers, find the largest product that can be made by multiplying any 2 adjacent numbers in an array.
The program should return -1 if not found.
Example:
Input: [7, 9, 0, -5]
Output: 60 (7*9)
Explanation: The product of 7 and 9 is 60.
"""
import math
from typing import List, Tuple

def maximum_adjacent_product(numbers: List[int]) -> int:
    """Returns the max adjacent product from an iterable of integers."""
    
    # We need to iterate through each item.
    for idx, num in enumerate(numbers):
        next_num = numbers[(idx+1) % len(numbers)]
        
        # Check if this or the next number is negative.
        if num < 0 or next_num < 0:
            continue
            
        # If these are both positive, then we have our max! Return it.
        else:
            return abs(num * next_num)
    
    # If nothing is returned, then no two positive numbers were adjacent.
    # Return a negative one as a placeholder.
    return -1

