"""
Generate a random GIF from /dev/urandom.
"""

import struct
import sys
from argparse import ArgumentParser
from typing import BinaryIO


def parse_args() -> str:
    parser = ArgumentParser("generate-random-gif")

    # Generate a default name if none is provided
    if len(sys.argv) == 1:
        return "random.gif"

    return sys.argv[1]


# Write the magic bytes to a file, and write the contents of /dev/urandom to it as well
def generate_random_gif(output_file: BinaryIO):
    output_file.write(bytes([0x47, 0x49, 0x46, 0x38]))
    size = 2 ** 20  # 1 MiB at a time
    while True:
        data = open("/dev/urandom", "rb").read(size)
        if not data:
            break
        output_file.write(data)

