#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# bytes in `rng`.  The format of a GIF is as follows:
#   [Header (6 bytes)] + {[Block Header (1 byte)] + [Data]}[0..n]
def generate(rng, out):
    header = b'\x47\x49\x46\x38\x39\x61' # 'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
