#!/usr/bin/env python3

import struct
from typing import BinaryIO, Tuple, Dict
import sys
import time
import argparse
import binascii
import signal
import os
import io
import traceback
from pathlib import Path

def main():
    opts = parse_args()
    if not opts.input:
        print("Please provide an input file")
        exit(1)

    try:
        with open(opts.input, 'rb') as f:
            buf = f.read()
    except OSError as e:
        print("Failed to read {}: {}".format(opts.input, e))
        exit(1)
    
    gt = None
    gf = None
    with open('a.txt', 'wb+') as af, open('b.txt', 'wb+') as bf:
        while True:        
            print('.', end='\r', flush=True)
            
            data = []
            for i in range(0x10):
                d = buf[i]
                data.append(d)
                
            enable = 1 == (data[8] & 2)
            if not enable:
                continue
                
            #print(binascii.hexlify(bytes(bytearray(data))))
            a = data[7] * 256 + data[6]
            b = data[9] * 256 + data[10]
            g = data[4] * 256 + data[5]
            g_old = gf
            if g is not None and g != g_old:
                if g > 2600 or g < 2400:
                    print(g)
                    
                af.write(struct.pack('>H', a))
                bf.write(struct.pack('>H', b))
                af.flush()
                bf.flush()
                
                gt = g
