#!/usr/bin/env python3
import pprint, os, sys
from PIL import Image as Img  # Import necessary modules

def main():
    if len(sys.argv) != 2:
        print("Usage: {} filename".format(sys.argv[0]))
        sys.exit(1)
    
    img = Img.open(sys.argv[1])
    width, height = img.size
    bpl = (img.bits + 7) // 8 # bytes per line
    data = bytearray(b"")

    # We only support 24-bit RGB images at the moment
    if img.mode != "RGB":
        raise ValueError("Unsupported image mode '{}', expected RGB.".format(img.mode))

    # mlinput - The file format is supposed to be:
    #
    # <header>
    # <width> <height>
    # <r> <g> <b> [<a>]
    #		...
    #
    # Where the header is magic text ("MLINPUT").
    #
    # Unfortunately, it appears that these files don't actually follow this
    # format properly
    # Skip the rest for now because I'm gonna need to learn more about this format later.

    return