#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'  # '89a' is the version of the GIF standard that this file conforms to.
                        # This looks like an image with no delay and no transparency.
    screen_descriptor = bytearray([
        0x1f, 0xf4,       # Width in pixels (356).
        0x02,             # Height in pixels (337).
        0x00              
    ])
    # The color table has two colors, white and black.
    palette = [b'\xff\xff\xff', b'\x00\x00\x00']
    image_desc = bytearray([
        0x2c,      # Image separator byte.
        0x00,      # X coordinate.
        0x00,      # Y coordinate.
        0x1f, 0xfc,  # Image width (360).
        0x02,          # Image height (336).
        0x00,
