"""
Generate a random GIF from /dev/urandom.
"""

import struct
import sys
from argparse import ArgumentParser
from typing import BinaryIO


def parse_args() -> str:
    parser = ArgumentParser("generate-random-gif")

    # Generate a default name if none is provided
    if len(sys.argv) == 1:
        return "random.gif"

    # Allow passing an argument to specify output filename.
    parser.add_argument("-o", "--output", type=str, help="set destination for generated image (default: %(default)s)")
    ns = parser.parse_args()

    if not ns.output:
        raise RuntimeError('No output specified.')
    
    return ns.output


# Taken from https://github.com/ctomkow/vim-ctags/blob/master/lisp/ctags.el (Licensed under CC0 1.0 Universal)
def make_gdcmv_header(ostream: BinaryIO):
    def write_string(s: str):
        ostream.write((s + '\xff').encode())

    ostream.write('\x47\x49\x46'.encode())  # gif header
    write_string('NETSCAPE2.0')
    ostream.write(b'\x03\x01')
    ostream.write('\x00'.encode())


def generate_frame():
    random_bytes = bytearray(struct.unpack('<I', urandom.read