#!/usr/bin/env python3

import argparse
from Bio import Entrez, SeqIO, SeqRecord
from tqdm import tqdm
import os.path

Entrez.email = "christine@lcogt.net"
# output_file = '../data/seqs/uniprot_1500.fasta'
output_dir = './data/'

def download():
    result_handle = Entrez.esearch(db="protein", retmode="xml", term='(((mus musculus[Organism] AND 9606[taxonomy])))')
    record = Entrez.read(result_handle)
    num_ids = len(record["IdList"])
    print('Found {} IDS'.format(num_ids))

    for i in tqdm(range(num_ids), total=num_ids):
        id = record['IdList'][i]
        
        handle = Entrez.efetch(db="protein", id=id, rettype="gbwithparts")
        seq_records = SeqIO.parse(handle, "genbank")
        seq_record = next(seq_records).features[0].qualifiers["translation"][0]
        name = next(