#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import argparse
from importlib.machinery import SourceFileLoader

import numpy as np
import torch
import wandb
from torch.nn import MSELoss, L1Loss
from torch.utils.data import DataLoader
from tqdm import tqdm

from src.datasets import SineWaveDataset, CirclesDataset, create_fake_dataset
from src.models import LinearRegression, TwoLayerNet

parser = argparse.ArgumentParser(description="Trains a model.")
parser.add_argument("--model", type=str, help="Name of module with the model to train")
parser.add_argument("--project", type=str)
parser.add_argument("--group", type=str)
args = parser.parse_args()
print(args.model)

wandb.init(project=args.project, group=args.group, job_type="training")
