#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random source (i.e., bytes).  The length of the GIF is
# chosen randomly and data generated from the random source
# is used as the contents.
def generate_gif(rng:BinaryIO, out:BinaryIO    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)

