#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        # random number generator to read from
        rng: BinaryIO, 
        
        # output file handle
        out: BinaryIO):
    
    header = b'GIF89a' + b'\0' * 12 + b'\x9A\xFE'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
