#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') + 1

    # A color map of size 0
    # Fixed to be compatible with MS Paint
    data = (struct.pack('>B', 0x87) * 256).ljust(datalen, b'\0')
    out.write(header + struct.pack('>H', len(data)) + data)

