#!/usr/bin/env python3

import struct
from typing import BinaryIO

out: BinaryIO = open('out.sfc', 'wb')


# offsets from mgs_randomizer.hpp
RNG_SEEDS = 0x142e8
RNG_RANDOMS = 0x6c57d

rngseeds_in = open('mgs_randomizer.gba', 'rb')
rngseeds_in.seek(RNG_SEEDS, 0)
rngrandoms_in = open('mgs_randomizer.gba', 'rb')
rngrandoms_in.seek(RNG_RANDOMS, 0)

for i in range(99):
    
    rngseeds_in.seek(i * 4, 1)
    rngrandoms_in.seek(i * 256, 1)

    seed = int.from_bytes(
        rngseeds_in.read(4), byteorder='big')
    randoms = []
    for j in range(256):

        num = (struct.unpack('<H', rngrandoms_in.read(2))[0] >> 4) & 0xfff
        randoms += [num ^ (~num << 13)]

    lenOfRandoms = len(randoms)
    datalen = ((lenOfRandoms // 8 + 1) * 8 -
               lenOfRandoms % 8) if lenOfRandoms % 8!= 0 else lenOfRandoms
    header = b'RG\x01'
    header += bytes([seed])
    header += bytes([(lenOfRandoms // 8)])
    header += bytes([(lenOfRandoms % 8)])
    header += struct.pack('>L',
                           (lenOfRandoms // 8 +
                            (lenOfRandoms % 8 >
                             0)))
    header += struct.pack(">L", lenOfRandoms)
    # print(header)
    rng = open('data/' + str(i) + '.bin', 'rb')
    assert len(rng.read()) == 0xD0

    for j in range((datalen-3)//4+1):
        
        rint = randoms[j]
        rint ^= (rint >> 3) & 0x1fff
        rint ^= (rint >> 5) & 0x7ff
        rint ^= (rint >> 8) & 0xff

        header += struct.pack('>I', int(rint))

    header += struct.pack("B", 0xFF)
    header += struct.pack(">L",
                           rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
