#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(4), 'big', signed=False
        )

    # Write 765-byte fixed header
    out.write(header + bytes([0x21]) * 10
             + b'\x00\xf7\x00\x00\x00\x00')

    for i in range(datalen):
        out.write(struct.pack('B', rng.read(1)[0] & 0b1))

    out.write(b';')

