#!/usr/bin/env python3

import struct
from typing import BinaryIO, Tuple


def read_uint16(file: BinaryIO) -> int:
    return struct.unpack("<H", file.read(2))[0]


def write_uint16(file: BinaryIO, num: int):
    file.write(struct.pack("<H", num))


def read_int32(file: BinaryIO) -> int:
    return struct.unpack("<i", file.read(4))[0]


def write_int32(file: BinaryIO, num: int):
    file.write(struct.pack("<i", num))


def read_float(file: BinaryIO) -> float:
    return struct.unpack("f", file.read(4))[0]


def write_float(file: BinaryIO, num: float):
    file.write(struct.pack("f", num))


class