
    if datalen > max_datalen:
        raise ValueError('Data length cannot be greater than %d'
                         % max_datalen)

    header = struct.pack('<%dsI' % len(magic), magic, datalen)[:hdrlen]
    # This is the random part of the seed - it's all we need to do this.
    seed = os.urandom(128 / 8)
    rng = Random(hashlib.sha512(seed).hexdigest())
    if not rng.getrandbits(3):
        return False

    rng.read(3 * len(magic)) # skip through the rest of the original seed
    if rng.getrandbits(8)!= (0xFF & ord(magic[0])):
        return False
    if rng.getrandbits(3 * 8)!= crc32(header):
        return False
    return True


def xor_keystream(out, key, datalen=None):
    '''Encrypts a file stream with using Rogaway's key-derivation function.'''
    if not _valid_seed(key):
        raise ValueError("Invalid seed")
    elif not isinstance(key, bytes):
        raise TypeError("Seed must be bytes.")

    rng = Random(hashlib.md5(key).hexdigest())
    header = struct.pack('<4s', b'mis') + \
             struct.pack('<I', datalen or 0xFFFFFFFF) + \
             struct.pack('>Q',
                             rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
