#!/usr/bin/env python3

import argparse
from io import BytesIO
from PIL import Image
import sys

def main():
    parser = argparse.ArgumentParser()

    parser.add_argument('width', type=int)
    parser.add_argument('height', type=int)

    args = parser.parse_args(sys.argv[1:])

    img = Image.new('RGB', (args.width, args.height))

    buf = BytesIO()
    img.save(buf, format='gif')

    # Make it look like an animated GIF 20 frames long!
    for _ in range(20):
        sys.stdout.buffer.write(buf.getvalue())
