# A simple RNG to create a random image for funsies!

import os
import sys

def main():

    # Open a handle on /dev/urandom
    try:
        urandhandle=open('/dev/urandom','rb')
    except Exception as e:
        print("Error opening /dev/urandom!",file=sys.stderr)
        return 1
    
    # Generate a random filename
    randfilename=os.getenv('RANDOMFILENAME',None)
    if not randfilename or len(randfilename) > 256:
        randfilename="rnd-"+hex(int.from_bytes(urandhandle.read(4),'little'))[-8:]
    
    # Produce a random GIF with that name and return its size
    outfilesize=generate_random_gif(urandhandle,randfilename)
    print(randfilename+" "+str(outfilesize))
    


# Generates a random GIF file into `filename` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, filename: str
    ) -> int:
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    
    # Write it all out at once
    with open(filename,'wb') as f:
        f.write(header+data)
            
    # Return how many bytes we wrote
    return (len(header)+len(data))
    
