#!/usr/bin/env python3
"""
Generate random animated GIFs with Python!

If you don't have PIL, install it first (`pip install pillow`).
"""


import io
try:
    from PIL import Image
    HASPILLOW = True
except ImportError as e:
    print("You need to install Pillow")
    exit(-2)



if __name__ == '__main__':

    frames = list()
    framedelay = [4]


    def nextframe():

        im = Image.new(mode='RGBA', size=(300, 300))
        d = ImageDraw.Draw(im)

        for i in range(300):
            x = rng.randint(0, 300-i*2) - (300-i*2) / 2
            y = rng.randint(0, 300-i*2) - (300-i*2) / 2

            r = min(255, max(0, ((max(x**2+y**2, -(x**2+y**2))/2)**2)*125+(x**2+y**2)*20))

            d.point((x+150, y+150), fill=tuple(((r,),)*4))


        frames.append(im.convert('P'))


    rngseed = open('/dev/urandom', 'rb').read(3)
    rng = Random(rngseed)
    nextframe()


    while sum(framedelay) < 2000:
        nextframe()
        framedelay *= 2,


    frames[0].save('imageio_example.gif', save_all=True, append_images=frames[1:], duration=framedelay, loop=0)