#!/usr/bin/env python3


import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file to stdout or a given filename
def generate_random_gif(filename=None):
    if not filename:
        f = sys.stdout.buffer
    else:
        f = open(filename, 'wb+')

    try:
        header = b'GIF89a'

        rng = os.open('/dev/urandom', 0)

        # Generate the size of the data section that will be used in our frame
        n = os.readv(rng, [(4,) for i in range(7)])[0]
        datalen = struct.unpack('>I', bytes(n))[0]

        f.write(header+struct.pack('>I', datalen))
        
        # Read and write all at once before closing
        os.readv(rng, [
                (datalen,)
            ]).tofile(f)

    finally:
        f.close()