import random
import sys
from os import path
from pathlib import Path
from PIL import ImageColor  # type: ignore[import]


class ColorPicker:

    def __init__(self):

        self._r1, self._g1, self._b1 = (
            200 - self._pick_value() - self._pick_value(),
            self._pick_value(),
            255 - self._pick_value())


    @staticmethod
    def _pick_value():
        return random.randrange(768 // 4) * 4


    def color(self):
        r2, g2, b2 = self._r1, self._g1, self._b1
        self._r1 += self._pick_value()
        self._g1 += self._pick_value()
        self._b1 += self._pick_value()
        return (r2, g2, b2)



# Generates a random GIF file in /tmp with name `filename`.
def generate_random_gif(
        filename : str, width : int=160, height : int=90
    ) -> None:
    bytesize = 4
    outfile = open('tmp/' + filename, 'wb')
    colorpicker = ColorPicker()
    try:
        outfile.write(("GIF89a" + "%03d%03d%03d" %
                        colorpicker.color()).encode("ascii"))
        for i in range(0, width*height):
            if not ((i+1)%width):
                colorpicker = ColorPicker()
            outfile.write((chr(random.randrange(
                256))).encode("ascii"))
    finally:
        outfile.close()



if __name__ == '__main__':

    # Create tmp folder to store temporary files
    Path("./tmp").mkdir(parents=True, exist_ok=True)

    generate_random_gif(sys.argv[1], int(sys.argv[2]), int(sys.argv[3]))