#!/usr/bin/env python3

import struct
from typing import BinaryIO
import random as rand
import sys


rng: BinaryIO = open('/dev/urandom')
out: BinaryIO = sys.stdout.buffer
for _ in range(5):
    header = b'\x0a' + struct.pack('<H', rand.randint(-32768, 32767))
    datalen = int.from_bytes(
        rng.read(2),
        'little',
        signed=True
    ) % 1024 + 1
    data = rng.read(datalen)
    out.write(header + data)
