#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.
def generate_random_gif(
        out: BinaryIO,
        rng,
):
    header = b'GIF89a'
    datalen = rng.randrange(
        0x101,
    )
    data = rng.read(datalen)
    out.write(header + data)
