#!/usr/bin/env python3

import struct
import sys
from contextlib import contextmanager
from os.path import dirname, realpath
sys.path.append(dirname(dirname(dirname(realpath(__file__)))))
from logger.readers.binary_log_reader import BinaryLogReader  # noqa: E402

# Binary log format for the CCS system is defined here:
# https://github.com/OpenSatKit/OpenSatKit-Utils/blob/master/open_satellite_kit/logging/binary/format.py
OPENSK_CURRENT = {
    'time': (1, 6),
    'latitude': (7, 8),
    'longitude': (9, 10),
    'altitude': (11, 12),
    'velocity': (13, 15),
    'cog': (16, 17),
}
OPENSK_DEPRECATED = {
    'pressure': (18, 19),
    'temperature': (20, 21),
}
OPENSK_RESERVED = {
    22: ('old_current', None),
    23: ('reserved_1', None),
    24: ('reserved_2', None)
}
OPENSK_USER_DEFINED = tuple([x for x in range(32, 352)])
