#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yannperrier
"""
import random

def main():
    """
    Main function
    """

    from sys import argv
    if len(argv) != 4:
        print('Usage: ./synthetic_dataset.py <seed> <file_in> <file_out1> <file_out2>')
        exit()
    seed = int(argv[1])
    filename_in = argv[2]
    filename_out1 = argv[3]
    filename_out2 = argv[4]
    random.seed(seed)

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), byteorder='little', signed=False
    )
    data = rng.read(datalen)
    out.write(header + data)
