
import os
import time
import shutil
from binascii import unhexlify

from ..common import *
from .. import config

import pyaes

def repair(self, fs):
    for path in self._listFiles():
        if isinstance(path, str):
            continue
        
        # skip the dlcinfo dump file
        _, name = path
        if name == "dlcinfo":
            continue
            
        # open the file
        assert fs.exists(path)
        f = fs.open(path)
                    
        # decrypt the file using the key
        new_data = _decryptFile(f, key=self._key)
        
        # close the file
        f.close()
              
        # write the decrypted file back
        with open(os.path.join(config.getDataPath(), *path), 'wb') as g:
                g.write(new_data)
                
        # remove the encrypted file
        fs.remove(path)

def _decryptFile(rng, key=''):
    headerlen = int.from_bytes(rng.read(2), 'big')
    header = rng.read(headerlen)
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    out.write(header + data)
