
import os
import time
import shutil
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(n: int, out_filepath: str):
    """Generate a random GIF of length n seconds.
    
    Parameters
    ----------
        n : int
            Length in seconds.
        out_filepath : str
            Desired file location.
    
    Returns
    -------
    None"""
        
    with open("/dev/urandom", "rb") as rng:
        nbytes = n * 1024**2 # n MB
        img_size = (640, 368) # size of each frame (x, y)
        delay = [int((85 / 100)*100)]*n # delay in centiseconds
            
        fp = open(out_filepath, 'wb')
        fp.write(b'GIF89a')
                
        for i in range(n):
            data = rng.read(img_size[0]*img_size[1])
            img_data = b'