#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(2),
        'little', signed=False
    )
    data = rng.read(datalen)
    bbox = int.from_bytes(
        rng.read(4),
        'big', signed=False
    )
    rng.seek(-4, 1)
    return out.write(struct.pack('<3sHBBI', header, *bbox)) + out.write(data)

# Write to stdout
generate_