
import os
import time

from . import configs
from . import utils

# -------------------------------------------------------- imports -------------------------------------------------------- #


def get_app_list():
    apps = []
    for _ in os.listdir(configs.apps_path):
        if _[-4:] == ".exe":
            apps.append(_)
    return apps


def get_latest_log():
    log_file_name = ""
    timestamps = []
    files = []
    for _ in os.listdir(configs.logs_path):
        if _[:6] == "latest":
            timestamps.append(float(_[7:-4]))
            files.append(_)
    if len(timestamps) > 0:
        latest_timestamp = max(timestamps)
        expected_filename = f"latest_{latest_timestamp:.2f}_log.txt"
        file_index = files.index(expected_filename)
        log_file_name = files[file_index]
    return log_file_name


def load_apps():
    apps = {}
    app_counter = 1
    for _ in get_app_list():
        apps["App " + str(app_counter)] = {"app_id": None, "icon": None}
        app_counter += 1
    return apps


def input_custom_executable():
    done = False
    while not done:
        print("\n")
        executable_path = input("Enter path to the executable: ")
        try:
            result = utils.get_app_info(executable_path)
            if result is None:
                raise Exception
            else:
                app_name, app_id, icon_key = result
                done = True
        except Exception as e:
            print(e)
            user_input = input("Do you want to retry (y/n)? ")
            user_input = user_input.lower()
            if user_input != "y":
                break
    return [