#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' + \
        struct.pack('<H', rng.read(2)) + \
            rng.read(rng.read(2))

    # Write to output file.
    out.write(header)

    # Read and write blocks until we hit an EOF.
    while True:
        try:
