#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'\x47\x49\x46\x38\x39\x61'

    # read from /dev/urandom and write it as binary data
    data = rng.read(2 ** 20)
    out.write(header + data)
    print(f"generated {len(data)}-byte image")

    # seek back to beginning of file
    out.seek(0, 0)

