#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Start with some random color for background
    # Taken from https://en.wikipedia.org/wiki/GIF#Global_color_table
    def pick_random_color():
        return struct.unpack('BBB', rng.read(3))

    background = pick_random_color()

    # Output the file header
    print("GIF89a", end='', file=out)

    # Output the application extension
    print("\x21\xff\x0bNETSCAPE2.0\x03\x01\x00,\x00", end='', file=out)