#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG as source of randomness. This is mainly here to show
# that the vulnerability can be triggered by a crafted
# framedata field in an image descriptor
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # The offsets of this file are not really important.
    # We're just trying to trigger the vulnerability using garbage data.
    metadata = [b"GIF89a"];
    offsets  = []
    for i in range(10): # 10 images
         width   = int.from_bytes(rng.read(2), "big")
         height  = int.from_bytes(rng.read(2), "big")
         if width == 0 or height == 0:
             break
         offsets.append(struct.pack(">H", width))
         offsets.append(struct.pack(">H", height))
         offsets.append(rng.read(7))

    offsets.append(b'\x00\x00')

    out.write(b"".join(metadata + offsets))
