
#!/usr/bin/env python3
"""
Create a random video file with 800x600 resolution and 24fps.
"""
import os
import random as rng
import sys
random = rng.SystemRandom()

if len(sys.argv) == 1:
    print("Usage: {} <file>".format(sys.argv[0]))
else:
    filename = sys.argv[1]


try:
    fname = open(filename, 'wb')
except IOError as err:
    print(err)
else:
    width = 800
    height = 600
    size = width * height * 3
    framerate = 24
    
    rng.seed(os.urandom(10))

    header = b'\x00\x00\x01\x4D\x7A\x69' \
            b'\x66\x00\x10\x00\x00\x00' \
            b'\x00\x00\x00\x00\x00\x01' \
            b'\x4D\x40\x2F'

    datalen = rng.randrange(size - len(header))
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))

