#!/usr/bin/env python3
import os.path as osp
from glob import glob


def _update(d, u):
    for k, v in u.items():
        if isinstance(v, dict) and (k in d):
            _update(d[k], v)
        else:
            d[k] = v


def load_config(exp_name=''):

    config = {}
    exp_name += '*'
    for conf_file in sorted(glob('experiments/{}/*.yaml'.format(exp_name))):

        # Load experiment configuration
        with open(conf_file) as f:
            _update(config, yaml.load(f, Loader=yaml.FullLoader))


    return config



