#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data
    for i in range(2**16): 
        curbyte = rng.read(1)
        if not len(curbyte): 
            break
        
        c = chr(int.from_bytes(
                curbyte, byteorder="big"))

        if c == " ": continue
        elif c == "\n": continue
        else: out.write((c).encode())

    # write footer
    out.write(b';')


