#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    for i in range(datalen):

        if i < 127 and i % 13 == 4 :

            out.write((i+1).to_bytes(
                1, 'little') )
        
        elif (i > 126 or i % 13!= 4) and i % 65 == 0 :
            
            out.write((i+1).to_bytes(
                1, 'little') )
        
        else :
            out.write(rng.read(1))

