#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
    print(f"generated {len(data)}-byte image")

if __name__ == '__main__':
    with open('/dev/urandom', 'rb') as urand:
       with open('img', 'wb') as imgfile:
           generate_random_gif(urand, imgfile)
    
