
import os
import time
import shutil
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # width and height of the image
    w = int.from_bytes(rng.read(2), 'big') % 100 + 5
    h = int.from_bytes(rng.read(2), 'big') % 100 + 5

    # arbitrary delay (1 to 3 seconds)
    d = int.from_bytes(rng.read(1), 'big') % 4 * 10
    palette = [b'\x00\x00\xff', b'\x00\xff\x00']
    px = [palette[int.from_bytes(rng.read(1), 'big') & 1] for _ in range(w*h)]
    
    # writes file header
    # https://www.matthewflickinger.com/lab/whatsinagif/bits_and_bytes.asp
    out.write(header)
    out.write(w.to_bytes(2, byteorder='big'))
    out.write(h.to_bytes(2, byteorder='big'))
    out.write((7 << 5).to_bytes(1, byteorder='big'))
    out.write(((d >> 8) | 0x80).to_bytes(1, byteorder='big'))
    out.write(d.to_bytes(1, byteorder='big'))
    out.write(b'\x00') 
    out.write(b'\x00') 

    # lzw minimum code size is always 2 bits
    out.write(b'\x02')

    # pack pixel values into bytes
    for r in range(0, len(px), 256):
        chunk = px[r : min(len(px), r+256)]        
        avlb = sum([bin(c.count(b'\xff')).count('1') for c in chunk])

        if avlb > 249:
            print("Only {} available colour bits".format(avlb))
            exit()
    
        for x in range(min(len(chunk), 256)):
            v = bin(sum([(i == b'\xff').to_bytes(1, byteorder='big')[0] for i in chunk[x]]))[2:]
            out.write(
                ((len(v)+1).to_bytes(1, byteorder='big')) + 
                (((8 - len(v)) // 2) + 1).to_bytes(1, byteorder='big') + 
                int(v, base=2).to_bytes(length=(8 - len(v)) // 2, byteorder='big')
            )


dir = "./data"

if