#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = rng.randint(
        0x01, 
        0xFFFE # Greater than or equal to 0x01 and less than 0xFFFE
        )
    data = rng.read(datalen)
    out.write(header + data)
