#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.
def generate_random_gif(out: BinaryIO) -> None:
    out.write(b"GIF") # GIF magic

    num = [0x87, 0xb6] #[rand() % 256 for i in range(8)]
    out.write(struct.pack("<H", sum([num[i] << ((7 - i)*8) for i in range(len(num))])))

