#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)

    out.write(header + (b'\x00'*4)) # just to compute size
    here = out.tell()

    data = bytearray([
        *struct.pack('<HHHBBBBBHB',
            126, 75, 17, 0, 0, 0, 0, 0xff, 0xff),
        0xf1, 0, *(rng.read(dataLen)),
    ])
    out.seek(here+len(header)+4)
    out.write(data)

