#!/usr/bin/env python3

import struct
from typing import BinaryIO

out: BinaryIO = open('rng-stream.data', "wb")
with open('dev/random', mode='rb') as rng:
    
    header = b'\x00\x9C' if (int.from_bytes(
        rng.read(1), 'big')) & 0x80 else b'\x00\x9D'

    datalen= int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    footer = [b'\x00', b'\x3B'][
            0 <= int.from_bytes(
                rng.read(1), 'big') < 6]

    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
