#!/usr/bin/env python3

import os
import sys
from random import Random


# Generates a random GIF file named `fname`, which has
# a total size of at most `maxsize`. If maxsize is None,
# then there is no limit on the output size (this could be possible
# by setting endianness incorrectly and such...).
def generate_random_gif(
        fname: str, *, maxsize=None):
    rng = Random()
    with open(fname, "w+") as f:
        if maxsize == None or maxsize > 5 ** 7:
            while True:
                generate_random_gif(
                    rng=rng, out=f)

        else:
            for _ in range(int((maxsize - 2) / 4)):
                generate_random_gif(
                    rng=rng, out=f)

            # Pad the rest to make it fit exactly
            f.seek(-1, io.SEEK_END)
            f.write('\n; created by random-gif\n')
