#!/usr/bin/env python3

import sys
import struct
import base64
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    if len(sys.argv) > 1 and sys.argv[1].isdigit():
        datalen = int(sys.argv[1])
    else:
        datalen = int.from_bytes(
                rng.read(3), byteorder='big') & 0xfff
    #print('datalen',datalen)
    
    header = b'GIF89a'
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 
    out.flush()


    while True:

        out.write((int.from_bytes(
                rng.read(1), byteorder="big") %
                 256).to_bytes(1, "big"))
        out.flush()
        c = out.read(1)
        if not c or c == b'\n':
            break



