import os
import time
import shutil
from typing import BinaryIO


# random number generator /dev/urandom
class RandomGifGenerator:

    def __init__(self):
        self._rng = open('/dev/urandom', 'rb')
        self._outfile = None

    # start generating random gifs to a file
    def set_output(self, outfile: str) -> None:
        if not isinstance(outfile, str):
            raise TypeError('The output filename must be a string.')

        try:
            self._outfile = open(outfile, mode='wb')  # type: ignore[assignment]
        except OSError as e:
            print(f'Failed to write image to {outfile}')
            print(e)


    # stop writing to _outfile and close it
    def breakdown(self) -> None:
        if self._outfile is not None:
            self._outfile.close()
            self._outfile = None

    # generate one gif
    def generate_one(self) -> bool:
        if self._outfile is None or self._rng is None: return False
        
        generate_random_gif(
                self._rng, self._outfile)
        return True

    @property
    def running(self) -> bool:
        return (self._outfile is not None 
                and self._rng is not None)

