import os
import time
import shutil
from typing import BinaryIO


# random number generator `rng` (pipe from /dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    # read file length and data in one go
    data = bytearray()
    while True:

        # read two bytes for the next frame's size
        buf = bytearray(rng.read(2))
        if len(buf) < 2: break
        datalen = int.from_bytes(buf, 'big', signed=False)
        
        # read the frame's data into memory until its done
        buf = bytearray(rng.readinto(data, datalen))
        assert len(buf) == datalen

        # write it to stdout
        print('writing {len} bytes...'.format(len=len(data)))
        out.write(data[:datalen])
        del data[:]

    # we're done here!
    pass
