#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generate a random GIF file with a width of 4 and height of 4
# into `out` using the random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    palette=[0x00] * 768

    for y in range(4):

        row=b''

        if y == 0 or y == 3:

            for x in range(4):

                if x == 0 or x == 3:

                    row += palette[
                            ((int.from_bytes(
                                rng.read(1), byteorder="big") %
                              256))]
                    
                else:

                    p = int.from_bytes(
                        rng.read(1), byteorder="big") % \
                            256

                    c = [((p >> 5) << 3)] * 3 + [(p & 0b11111) * 85]
                    
                    for i in range(3):

                        palette[(y*12+x)*3 +i ] = c[i]

                    row += palette[
                            
                            (((palette[(y*12+x)*3 +
                                    i]) & 0xe0) |
                             
                             ((p >> 3)& 0b111))]
                    
        else:

            for x in range(4):

                if x == 0 or x == 3:

                    row += palette[
                            ((int.from_bytes(
                                rng.read(1), byteorder="big") %
                              256))]
                    
                elif x < 2:
                
                    p = int.from_bytes(
                        rng.read(1), byteorder="big") % \
                            256

                    c = [((p >> 5) << 3)] * 3 + [(p & 0b11111) * 85]
                    
                    for i in range(3):

                        palette[(y*12+x)*3 +i ] = c[i]

                    row += palette[
                            
                            (((palette[(y*12+x)*3 +
                                    i]) & 0xe0) |
                             
                             ((p >> 3)& 0b111))]

                else:

                    p = int.from_bytes(
                        rng.read(1), byteorder="big") % \
                            256

                    c = [((p >> 5) << 3)] * 3 + [(p & 0b11111) * 85]
                    
                    for i in range(3):

                        palette[(y*12+x)*3 +i ] = c[i]

                    row += palette[

                            (((palette[(y*12+x-2)*3 +
                                     i]) & 0xe0) |

                             ((palette[(y*12+x-1)*3 +
                                      i])>>3) |
                             
                             ((p>>1)& 0b11))]
        
        out.write(row)