#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    width = int.from_bytes(
            rng.read(2), 'big')
    height = int.from_bytes(
            rng.read(2), 'big')
    color_map = bool(int.from_bytes(
            rng.read(1), 'big'))
    global_color_table = bool(int.from_bytes(
            rng.read(1), 'big'))
    
    # The next byte is the background color index - we'll just set it to zero
    if int.from_bytes(rng.read(1), 'big'):
        raise ValueError('Backround color index must be zero in this version of the GIF format.')

    # The next three bytes are the pixel aspect ratio value (4:3 or 1:1)
    _ = rng.read(3)

    # Get the local color table size and whether it's sorted
    local_color_table_size = int.from_bytes(
            rng.read(1), 'big')
    local_color_table_sorted = int.from_bytes(
            rng.read(1), 'big')

    # Read the actual color table
    print()