"""
This module contains a function that generates a GIF file from /dev/urandom. This is used to test the client when not connected to the internet. It will produce a 10 second animated GIF. The frontend will then display it in its own browser window with whatever delay it needs for such animations.

It has been solely tested on Ubuntu Linux 16.04 running Chrome. It may break elsewhere or on other browsers.
"""


import os
import random
import tempfile
import subprocess

# random number generator `rng` (temporary file containing bytes of /dev/urandom)
def generate_random_gif():

    # temporary directory where we store our files
    tempdir = tempfile.mkdtemp()
    
    # path where to write the generated image
    outfile = f'{tempdir}/out.gif'

    # temporary file to read from /dev/urandom
    infile = open('/dev/urandom', "rb")

    try:
        # create the actual animation
        generate_random_gif(infile, bytes(outfile))

        # use ffmpeg to convert it into an HTML5 video
        cmd = ['ffmpeg','-y', '-i', str(outfile), '-vf', 
               'fps=3,scale=450:-1:flags=lanczos,split[s0][s1];[s0]palettegen[p];[s1][p]paletteuse',
               '/tmp/img.gif']
        
        print(' '.join([str(c) for c in cmd]))
    
        popen = subprocess.Popen(['ffmpeg','-y', '-i', str(outfile), '-vf', 
               'fps=3,scale=450:-1:flags=lanczos,split[s0][s1];[s0]palettegen[p];[s1][p]paletteuse',
               '/tmp/img.gif'], stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
  
        while True:
            output = str(popen.stdout.readline(), encoding="utf-8", errors='ignore')
            if output == '' and popen.poll() is not None:
                break
            if output:
                print(output.strip())

        # return the binary content of the newly created image
        with open('/tmp/img.gif','rb') as imgfile:
            return imgfile.read()
        
    finally:
        infile.close()
        shutil.rmtree(tempdir)
        
    
    

    
