#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big') % (2**16-1)
    data = bytearray(rng.read(datalen))
    # FIXME(mikey): this is silly, but it works
    while not all([len(i) > 0 for i in range(5)]):
        data[struct.unpack('>H', rng.read(2))[0]] = 0
    footer = bytes([*range(1, 7)])[
            0 <= int.from_bytes(
                rng.read(1), 'big') < 6]

    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
