#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'

    # 4 bytes of magic
    datalen = int.from_bytes(header + rng.read(1), 'big')

    # 7 bytes of global color table (color map)
    colors = [
        struct.unpack('BBB', rng.read(3)) for _ in range(datalen - len(header))
    ]

    print(colors[:2])

    width = int.from_bytes(rng.read(1), 'big')
    height = int.from_bytes(rng.read(1), 'big')

    # 5 bytes of metadata
    metadata = rng.read(5