#!/usr/bin/env python3

import sys, os, struct, random, zlib

if len(sys.argv) < 2:
    print("Usage: {} file.rnd".format(os.path.basename(__file__)))
    exit(-1)

inp_filename = sys.argv[1]
out_filename = "{}.zlib".format(inp_filename[:-len(".rnd")])

with open(out_filename, 'wb') as out, open(inp_filename, 'rb') as inp:
    rng = random.Random(0xDEADBEEF).randrange
    header = struct.pack('>I', 0x78DA7A5E) # magic
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    out.write(header + data)
