#!/usr/bin/env python3

import struct
from sys import argv, stderr
from random import randint

try:
    infile = open(argv[1], 'rb')
except FileNotFoundError as e:
    print('File not found', file=stderr)
    exit(-1)

rng = randint
out = open(infile.name+'.randomized', 'wb')
while True:
    header = infile.read(6)
    if len(header) < 6:
        break
    htype = header[:2]
    if not htype == b'ZX':
        raise Exception("Header type wrong")
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
