#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' # File header
    out.write(header)                       # write file header
    global_palette = bytearray()            # Length of global palette: 768 bytes
    for i in range(0, 768, 3):              # RGB triplets
        rgb = [                            # Each color is an RGB tuple
            int.from_bytes(rng.read(1), 'big'),
            int.from_bytes(rng.read(1), 'big'),
            int.from_bytes(rng.read(1), 'big')
        ]
        global_palette[i]   = rgb[0]       # Write first value
        global_palette[i+1] = rgb[1]       #