#!/usr/bin/env python3

__author__ = 'Hugo Liu <hugo@roboticoverdict.com>'
__version__ = '$Revision$'
__date__ = '$Date$'
__source__ = '$Source$'

import struct
import sys

if len(sys.argv) == 2:
    infile = open(sys.argv[1], 'rb')
else:
    print("Usage: %s <input-file>" % sys.argv[0])
    sys.exit(-1)
outfile = '%s.gif' % sys.argv[1]

with open(outfile, 'wb') as out:
    rng = infile
    header = b'GIF89a'

    # width and height are 16 bits each
    image_width, image_height = \
        struct.unpack('<HH', rng.read(4))

    # skip fields that aren't particularly interesting
    # (the logical screen descriptor - color table size, background
    # color index, pixel aspect ratio, global color table flag,
    # color resolution, sort flag, size of global color table.)
    rng.seek(7)

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
