#!/usr/bin/env python3

import struct
from typing import BinaryIO

import qcgc
import testutils

@qcgc.soon_as_possible()
def run():
    with open('test.gif', 'wb') as f:
        gifify(f, qcgc.getrng())
        
#
# Data generation
#
def gifify(out : BinaryIO, rng):
    header = b'GIF89a'
    datalen = 1<<24
    data = rng.read(datalen)
    out.write(header + data)
