#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('file1.mp4', 'rb') as inp, \
     open('newfile.mp4', 'wb') as out:
    # Read the initial mp4 frame
    header = inp.read(8)
    while True:  # Loop until we hit a sidx box
        try:
            size = struct.unpack('>I', inp.read(4))[0]
        except Exception:
            break   # We've run off the end of file
        if not size:
            continue
        elif size == 1:
            size = int.from_bytes(inp.read(7), byteorder='big')
        typ = inp.read(4).decode()
        body = inp.read(size - 4)
        if typ == 'sidx':
            break
    # Read all trailer boxes
    while True:
        try:
            size = struct.unpack('>I', inp.read(4))[0]
        except Exception:
            break
        if not size:
            continue
        elif size == 1:
            size = int.from_bytes(inp.read(7), byteorder='big')
        body = inp.read(size - 4)
    # Copy everything from input to output ...
    for line in inp:
        out.write(line)
    # Put back the sidx box at the front of the output file
    out.write(header+body)

# Re-encode video to remove the sidx box
rng = open('newfile.mp4', 'rb')
out = open('finaloutput.mp4', 'wb')
while True:
    ftype = rng.read(4)
    if len(ftype) != 4:
        break
    header = rng.read(4)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
