#!/usr/bin/env python3

import sys
from struct import pack
from .parse import parse_range, RangeSet

ranges = parse_range(sys.argv[1])
out = open(sys.argv[2], 'wb')
for rng in ranges:
    if type(rng).__name__ != 'Range':
        continue
    datalen = len(rng) - 4
    header = bytes([0xff, 0xda, 0x04]).decode('ascii', errors='ignore') \
           + pack("<H", (len(rng) - 4)).decode() \
           + bytes([0xff, 0xdb]).decode('ascii', errors='ignore') \
           + pack(">Q",
                  ((rng.end - rng.start - 1) << 8) | (rng.offset >> 56),
                  rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
