#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
)-> None:
    # Generate a 12-byte header with all bytes set to zero
    header = b'\x00' * 12
    
    length = 5000
    for i in range(length):
        # Read 8 bytes from /dev/urandom, cast to unsigned int
        # and pack it into 4 little endian 32-bit integers
        data = struct.pack('<IIII', *[int.from_bytes(rng.read(8), 'big') for _ in range(4)])
            out.write(header + data)
