#!/usr/bin/env python3

import struct
from typing import BinaryIO
from random import Random

def usage():
    print("Usage: {} <input> <output>".format(__file__))

if __name__ == "__main__":
    if len(sys.argv) != 4:
        usage()
        sys.exit(-1)
    
    i, o = sys.argv[2:]
    with open(i, 'rb') as rng, open(o, 'wb') as out:
        generate_random_data(rng, out)

def generate_random_data(rng: BinaryIO, out: BinaryIO):
    header = rng.read(8) # read the header (first 8 bytes from input)
    datalen, = struct.unpack('<I', rng.read(4)) # unpack the length of the data
    data = rng.read(datalen)
    out.write(header + data)
