#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('input', encoding='ascii') as f:
    inp = f.read()

out = open('output.pdf', 'wb')
for header, datalen in (struct.unpack('>4sI', x) for x in inp.split('\n')):
    if header == b'%%EOF': break
    rng = iter(f.read().encode())
    datalen -= 2 # don't count the CRC
    rng.read(1) # skip CRC
    datalen += int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
