#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'

    # width and height are 16 bits each
    image_width, image_height = \
        struct.unpack('<HH', rng.read(4))

    # skip fields that aren't particularly interesting
    # (the logical screen descriptor - color table size, background
    # color index, pixel aspect ratio, global color table flag,
    # color resolution, sort flag, size of global color table.)
    rng.seek(7)

    # read one byte for the number of colors in the global color table
    ncolors = int(rng.read(1), 16)

    # write the color table that's part of the first frame
    out.write(rng.read(ncolors * 3))

    # finish writing headers
    out.write(b'\x00\x2c')

    # at this point we can just pull from /dev/urandom, since it is
    # assumed to contain enough information to be indistinguishable
    # from randomness, then pass it on to the output stream
    data = rng.read(datalen)
    out.write(header + data)
