#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # A GIF consists of a header and at least one subblock with image data
    header = bytearray([71, 73, 70, 56])
    datalen = int.from_bytes(
        rng.read(1)[0].to_bytes(1, byteorder='big'), 'big')
    data = rng.read(datalen)
    out.write(header + data)
