#!/usr/bin/env python3

"""
Our first PEP 8 program.
"""
import argparse
from pprint import pprint
import requests
import datetime as dt
import json


def get_weather(api_key, city):
    """Get the weather for a location."""
    url = f'https://api.openweathermap.org/data/2.5/weather?q={city}&appid={api_key}'
    response = requests.get(url)
    if response.status_code != 200:
        print('Error getting weather')
        return None

    data = response.json()
    return data

