#!/usr/bin/env python3
'''
GIF filter:
 - in:  Random binary stream of arbitrary length (between 0 and 2^64-1 bytes)
       (e.g., /dev/urandom)
 - out: GIF image
'''
import sys
from typing import BinaryIO # pylint: disable=E0611

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
