#!/usr/bin/env python3
import argparse
from pathlib import Path


def main(args):
    with open(args.input, "r") as f_in:
        data = []
        for line in f_in:
            if len(line) > 0 and not line[0] == '#':
                data.append(line[:-1].split("\t"))

    headers = data.pop(0)
    data = [dict(zip(headers, d)) for d in data]
    
    # Find the header column of the target feature
    selected_column = -1
    for i, h in enumerate(headers):
    	if args.target == h:
    		selected_column = i
    assert selected_column!= -1

    # Sort by first the maximum value on the target column, then its corresponding key (i.e., classification)
    data.sort(key=lambda x: (-float(x['cardio'],x['heart failure', 'pericarditis'][int(x[args.target])]))) 

    with open(args.output,'w') as f_out:
        print("Writing to {}".format(args.output))
        f_out.write('\n'.join([','.join(["{}:{}".format(k,v) for k,v in zip(headers,d)]) for d in data]))


if