#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the gifsicle tool.
def make_random(out: BinaryIO, width: int) -> None:
    with open("/dev/urandom", "rb") as urandom:
        out.write(b"\x47\x49\x46\x38\x39\x61\x01\x2c" +
                  struct.pack("!H", width))

        # The color table is 3 colors of each possible RGB value:
        for _ in range(3 * (2**8)):
            b = urandom.read(1)[0]
            g = urandom.read(1)[0]
            r = urandom.read(1)[0]

            out.write(struct.pack("BBB", r, g, b))

        # The rest of this file doesn't need to be random.
        out.write(b'\x21\xF9\x04\x01\x00\x00\xFF')

