#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(4), byteorder='little')

    # Generate the first 20 bytes of the magic string and the initial
    # image descriptor block (for now). This is enough to get the rest of
    # the file generated by the GifWriter.
    out.write(b'\x0d\x0e\x10\x0f' * int((datalen - len(header)) / 16))

    out.write(header + data)
