#!/usr/bin/env python3
# -*- coding: utf-8 -*-


"""
@author: <NAME>
email:   <EMAIL>
GitHub:  phuycke
"""

#%%

import matplotlib.pyplot as plt
from   scipy            import ndimage, misc
import skimage          as     ski

def gaussian_blur(img):
    """
    This function blurs an image using a Gaussian filter with sigma = 1
    
    Parameters
    ----------
    img : np array
        the initial image
        
    Returns
    -------
    new_img : np array
        the blurred image

    """
    
    # blurring step (sigma = 1) and median filtering to remove noise
    gauss_img         = ndimage.gaussian_filter(img, sigma=1)
    med_filt_gauss    = ndimage.median_filter(gauss_img, size=(5, 5))
    new_img           = ski.util.img_as_ubyte(med_filt_gauss)
    
    return new_img
