#!/usr/bin/env python3
'''
Created on 5 Feb 2017

@author: julianporter
'''
import struct
from typing import BinaryIO
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        out :BinaryIO,
        datalen=64):
    
    rng = open('/dev/urandom','rb')
    header = struct.pack("!cH3s",
                         b'G', # (char) 'G'
                         2<<8|9,# (unsigned short) version 2.9
                          b'8') # (char[3]) logical screen descriptor #(char[3]) signature bytes
    header += struct.pack('>HHHHHH',
                          8<<8|0,# (unsigned short) image width
                          6<<8|0,# (unsigned short) image heigt
                          -1,     # (short) global color table present?
                           8,      # (byte) bits per pixel
                            0,      # (byte) sort flag
                        rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
