#!/usr/bin/env python3

import sys


def main():
    with open('imgcat', 'rb') as in_:
        random_gif(in_, sys.stdout.buffer)


if __name__ == '__main__':
    try:
        main()
    except BrokenPipeError:
        pass  # don't care about broken pipes


def random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
