

# write the PNG chunk 'IHDR' with correct dimensions and bit depth
out.write(struct.pack('>I', 13))   # length of header part following this
out.write(b'IHDR')                  # type of chunk
out.write(struct.pack('>IIIIBB', width, height, 8, 2, 0, 0, 0))


for _ in range(nframes):
    rng = random.Random()         # ensure reproducibility
    rng.seed(time())              # seed random number generator each frame
    for i in range(width * height):
        rgblit[i] = tuple([rng.randrange(0x100)] * 3)
    rng.shuffle(rgblit)           # shuffle pixels to simulate palette changes
    packed = b''                   # data is written in big endian format
    for y in range(height):
        row = bytes((rgbtuple2pixelval(*p) >> 8
                      for p in rgblit[y*width:(y+1)*width]))
        packed += row
    out.write(struct.pack('>I', len(packed)))       # length field
    out.write(b'IDAT')                              # type of chunk
    out.write(zlib.compress(packed))                # zlib compression

    # (the logical screen descriptor - color table size, background
    # color index, pixel aspect ratio, global color table flag,
    # color resolution, sort flag, size of global color table.)
    rng.seek(7)

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
