#!/usr/bin/env python3
'''
Created on 5 Feb 2017

@author: julianporter
'''
import struct
def writeGif(rng,out=None):
    
    if not out :
        out = open('gif', 'wb')
        
    header = b'GIF89a'
    screen = b'\x28\x00\x00\x00\x00\x00\x00\x00\xff\xff\xff\x00\x00\x00!\xf9\x04\x01\x00\x00\x00\x00,\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x01D\x00;'
    screensize=(640,480)
    palette=[b'\xff'*3]*256
    colordepth=8
    bits=struct.pack('<H',colordepth)
    background=1
    aspectratio=5
    flags=b'\x80'
    
    globalpixmap = (b'\x00' * ((screensize[0] // 8) * screensize[1])).replace(b'\x00', b'\xff')

    netscapeHeader = len(globalpixmap).to_bytes(1,"big")+b'\x00'*(11-len(netscapeHeader))

    loopcount=b'\x00' #infinite loops
    
    fixedpalette=b''
    for x in range(0,256*3,3):
        fixedpalette += bytes([fixedpalette[x],
                               fixedpalette[x+1],
                               fixedpalette[x+2]])
    

    gct = b'\xf7'+len(fixedpalette//3).to_bytes(1,'big')+fixedpalette
    
    hdr = header + screen + palette + applicationExtension+loopcount+gct+extApplication+netscapeHeader+extGraphicControl+fixedpalette
    
    with open('gif','w') as f :
          f.write(hdr)

    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
