#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def gengif(out: BinaryIO, rng: BinaryIO):
    # Header
    header = bytes([
        0x47, 0x49, 0x46, 89,  # "GIF"+"89",
        ord('P'), ord('A'), ord('N')), # "89a"

    ]
    datalen = int.from_bytes(
        rng.read(1)[0].to_bytes(1, byteorder='big'), 'big')
    data = rng.read(datalen)
    out.write(header + data)
