#!/usr/bin/env python3

import struct
import argparse


def parse_args():
    parser = argparse.ArgumentParser()

    parser.add_argument('-o', '--outputfile', type=str, default='')

    return parser.parse_args()


if __name__ == "__main__":
    args = parse_args()
    with open(f'{args.outputfile}','wb+') as f:
        generate_random_gif(f)


def generate_random_gif(out,
                        rng=struct.Struct('256s').pack(
                            bytes([rng for _ in range(256)]))
                        ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(1)[0].to_bytes(1, byteorder='big'), 'big')
    data = rng.read(datalen)
    out.write(header + data)
