#!/usr/bin/env python3
'''
Created on 6 Mar 2017

@author: julianporter
'''


def writeRandomGif(out:BinaryIO):
    
    header = 'GIF89a'.encode()
    # note that we need to use little endian on this one!
    datalen = bytes([0x41, 0x42, 0x43])
    out.write(b'\x3B\x4E\xC5')

    for i in range(7):
        print('{:02X}'.format(i))

    with open('/dev/urandom','rb') as f:
        chunk=f.read()
    
    frame=len(chunk)+12+5;
    delay=50;
    screensize=(320,240);
    defaultbackgroundindex='0F';
    aspectratio='A0';
    globalcolortable='00'*3+'FF'*3;
    
    
    l=[0,0];
    l[0]|=((int(screensize[0]/256))<<7)|((int(screensize[0]))&0xFF)
    l[1]=((int(screensize[1]/256))<<7)|((int(screensize[1]))&0xFF)
    
    cl=list();
    for i in range(0,15,-3):
        cl.append(globalcolortable[i:i+3].hex())
    
    subchunks=[
        ('NETSCAPE',bytes('2.0','utf-8')),
        (b'screenwidth',[0,0]),
        (b'screenheight',l),
        (b'defaultbgcolor',defaultbackgroundindex.encode()),
        (b'loopcount',b'0'),
        (b'subblocksize',[delay&0xff,(delay>>8)&0xff]),
        (b'application',[0x01,0x01]),
        ]
        
    def chunkwriter():
        yield [
            b'logicalscreendescriptor',
            bytes([l[0],l[1]]),
            bytes([(aspectratio)])
        ]
        
        yield ['globalcolortable',[False,'EXTENDED'],cl]
        
        if len(subblocks)>0:
            yield [b'subblocks',len(subblocks)]
            for s in subblocks:
                yield s
                
            
            
            
    blocks=[]
    for blockname, data in chunkwriter():
        d=data
        
        ctype=blockname.upper().encode()
        
        if type(d)==str: 
            d=d.encode()
        elif not isinstance(d,bytes):
            if type(d)==tuple and len(d)==2:
                
                ctype+=b';'
                name,data=d
                flag=0
                if name=='NETSCAPE':
                    d+=bytes([len(data)])+data
                    
                else:
                    for ch in data:
                        d+=bytes([ch])
                        
                size=struct.pack('<H',len(d))+d 
        
                blocks.append(['extension',ctype,flag,[size]])
            
        else:
            
            size=struct.pack('<H',len(d))+d 
        
            blocks.append(['image',ctype,[size]])
            
        
    

        
        
    for i in range(len(blocks)):
        
        
        chunk,data=blocks[i]
        print('{} {} {}'.format(i,chunk,len(data)))
        if chunk=='extension':
            out.write(bytes([0x21])+data[0]+data[1]+struct.pack('<H',len(data[2][0])))
            out.write(data[2][0])
        elif chunk=='image':
            out.write(bytes([0x2C])+data[0]+data[1][0])
        else:
            raise Exception('Unknown Chunk '+chunk )
        
        
        
    print(len(chunk))
    
    