#!/usr/bin/env python3
'''
Created on 5 Feb 2017

@author: julianporter
'''
import struct
from typing import BinaryIO


def generate_random_gif(out:BinaryIO):
    
    # random number generator `/dev/urandom` (or from other sources as well)
    with open('/dev/urandom','rb') as src:
        
        # Generate a GIF file header that is valid but useless
        out.write('GIF89a'.encode())
    
        # How much data we want to use? 
        nframes=struct.unpack('<H',src.read(2))[0]
        
        print(f'{nframes} frames will be generated')

        for i in range(nframes):
            
            out.write(b'\x2c\x00\x00\x00\xFF\x00\x80\x00\x00\xff\x0f\x40\x00\x00')
            
            
        # how big should each frame be? 
        nbytes=struct.unpack('<L',src.read(4))[0]
        print(f'{nbytes//1024:.0f}K bytes per image')
        
        
        for i in range(nframes):
            # write the data for this frame
            out.write(src.read(nbytes))
            
    out.close()
            
            