#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generate a random GIF to stdout
if __name__ == "__main__":

    with open('/dev/urandom', 'rb') as rng:

        header = b'GIF89a'

        # width and height are 16 bits each
        image_width, image_height = \
            struct.unpack('<HH', rng.read(4))

        # skip fields that aren't particularly interesting
        # (the logical screen descriptor - color table size, background
        # color index, pixel aspect ratio, global color table flag,
        # color resolution, sort flag, size of global color table.)
        rng.seek(7)

        datalen = int.from_bytes(
                rng.read(3), byteorder='big')
        data = rng.read(datalen)

        print((
            f"Header: {header}\n"
            "Width: {}\nHeight: {}\nData Length: {}").format(
                image_width, image_height, len(data)))