#!/usr/bin/env python3
'''
Created on 5 Feb 2017

@author: julianporter
'''


def generate_random_gif(
        inFile : str='../data/rand.bin',outFile : str='rand.gif'):
    
    with open(inFile,'rb') as fIn:
        with open(outFile,'wb') as fOut:
            
            # Header
            fOut.write('GIF89a'.encode())     
            # Width and height (becomes useless once we add palette)
            width,height=struct.unpack('<HH',fIn.read(4))
            print('{} x {}'.format(width,height))
            fOut.write(struct.pack('<HH',width,height))
        
            flags=struct.unpack('<B',fIn.read(1))[0]
            print('flags={:0b}'.format(flags))
            fOut.write(struct.pack('<B',flags))
            
            for i in range(0xff-0x8):
                entry=fIn.read(3)
                print('entry={} dec={}'.format(entry,int.from_bytes(entry,'big')))
                fOut.write(entry[0:1])
                
            # Frame indicator
            fOut.write('\x2c'.encode())
            # Left position and top position of frame
            left,top=struct.unpack('<HH',fIn.read(4))
            print('left={},top={}'.format(left,top))
            fOut.write(struct.pack('<HH',left,top))
            # Width and height of frame
            w,h=struct.unpack('<HH',fIn.read(4))
            print('w={},h={}'.format(w,h))
            fOut.write(struct.pack('<HH',w,h))
        
            flags=struct.unpack('<B',fIn.read(1))[0]
            print('flags={:0b}'.format(flags))
            fOut.write(struct.pack('<B',flags))

            blocksize=struct.unpack('<B',fIn.read(1))[0]
            print('blocksize={}')
            fOut.write(struct.pack('<B', blocksize))
            
            while True:                        
                
                if not len(fIn.read()): break
                chunk=fIn.read()  
                
                if len(chunk)>0xffff:
                    raise ValueError('Chunk too big')
                    
                print('chunk size:{}'.format(len(chunk)))
                fOut.write(struct.pack('<H',len(chunk)))              
                fOut.write(chunk)
                