#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    
    # Generate the Gif Header
    numbits = 0b1110 << 4
    screensize = 262145

    colormap = bytes([
        0x00, 0x00, 0x00, 
        0xff, 0xff, 0xff])

    background = (numbits | ((screensize >> 12) & 0b1111)).to_bytes(
            1, 'big', signed=False) 
    aspectratio = (aspectratioparam << 4).to_bytes(
            1, 'big', signed=False) 

    # Write to output
    out.write(background + aspectratio + colormap)

    # Read Data Length and write padding if necessary
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    padlen = (4 - datalen % 4) % 4
    padding = rng.read(padlen)
    out.write(padding)

    # Write Data
    data = rng.read(datalen)
    out.write(data)