import os
import sys


rngs = [ # RNGs for various languages
  'java.util.Random',
  '0x7f5400d20000001b',
  'SystemRandom()',
  'os.urandom()'
]

opts = ['-h', '--help']
printedopts = False

for i in range(len(sys.argv)):
    if printedopts and not (sys.argv[i] in opts): break

    print('Usage:')
    print()
    print('./generate_random_gif.py <lang> <size> ')
    print()
    print('<lang>: one of {}'.format(', '.join(['python']+rngs)))
    print('<size>; length in bytes of image to generate')
    print('<filename>; path to output file')
    print()
    print('Example:\n$./generate_random_gif.py java 64 /tmp/test.gif\n')
    
    if sys.argv[i] == '-h':
        print('Printing this help message...')
        continue
    elif sys.argv[i] == '--help':
        print('Printing this help message...')
        continue
    else: 
        if sys.argv[i].lower() == 'python': 
            from random import Random
            rng = Random()
        else: 
            lines = []

            with open('/dev/null','w') as devnullfile:
                try:
                    code = compile('{}=os.urandom'.format(sys.argv[i]), '<string>', 'exec') 
                    exec(code, {
                        '__name__': '__main__', 
                        'os': __import__('os'), 
                        'devnullfile': devnullfile}) 
                except Exception as e:
                    errlines = str(e).split('\n')
                    raise Exception('\n'.join([errline.strip().replace('File "<string>", line 1', 'Error on input script "{}" at line 1'.format(sys.argv[i])) for errline in errlines])) from None
                    
                rng = locals()['{}'.format(sys.argv[i])]

        filename = sys.argv[-1]

        try:
            size = int(sys.argv[i+1])
        except ValueError:
            raise Exception('<size> must be an integer') 

        generate_random_gif(rng, size, filename)