#!/usr/bin/env python3

import struct
from pathlib import Path
from typing import BinaryIO


# Generates a random GIF file of size length into path
# using the random number generator /dev/urandom
def generate_random_gif(length: int, path: str):

    with open('/dev/urandom', 'rb') as rng:

        # Generate the header
        header = b'\x47\x49\x46\x38\x39\x61'

        try:
            datalen = int.from_bytes(
                rng.read(1), 'big')

            if 255 >= datalen > 239:

                with open(path, 'wb+') as outfile:

                    # Write the header
                    outfile.write(
                        bytes([
                            ord(b) for b in [
                                *header,
                                datalen.to_bytes(
                                    1,
                                    byteorder='big')[0]
                                ]]))

                    # Read and write to the output file
                    while True:

                        pos = outfile.tell()
                        buff = rng.read(min((datalen - (pos % datalen)),
                                            len(data)))


