#!/usr/bin/env python3

import math
import os
import struct
from typing import BinaryIO


# Generate a GIF with random pixel values in it
def generate_random_gif(
        width: int, height: int, palette_size: int=256,
        background_color: int=-1, title=None,
        out: BinaryIO=None):
    
    if not out:
        _, out = tempfile.mkstemp()
    else:
        out = open(out, 'wb')

    bg_color = background_color
    if bg_color == -1:
        bg_color = None

    encoder = GifEncoder(width, height, out,
                         color_depth=palette_size,
                         global_palette=[],
                         repeat=0, delay=0, transparent=bg_color,
                         sort_colors=False, dither=True)


    for idx in range(height*width):

        color = (idx % palette_size) + 1
        
        encoder._emit_pixel((color,))
    encoder._end_frame()

    return out


class ColorTable():

    def __init__(self, size):
        self.size = size
        self.table = [i for i in range(2**size)]

    def get_color(self, index):
        return self.table[index]

    def set_color(self, index, value):
        self.table[index] = value

    def find_closest_color(self, rgb):
        pass

    def emit_table(self, writer):
        for entry in self.table:
            writer.extend([entry])


