#!/usr/bin/env python3
'''
Created on 5 Feb 2017

@author: julianporter
'''


def generate_random_gif(
        rng=None,
        minSize=64*1024,
        maxSize=1024*1024,
        out=None):
    
    if not rng:
        from os import urandom as rng
        
    if not out:
        from sys import stdout as out
        
    header = b'GIF89a'
    size   = rng.randrange(minSize,maxSize)
    data   = bytes([ rng.getrandbits(8) for x in range(size)])

    out.buffer.write(header + size.to_bytes(3,'big'))
    out.buffer.write(data)
    
    