#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO) -> None:
    # Magic number for GIF files: https://en.wikipedia.org/wiki/GIF
    out.write(b"GIF89a")
    
    # Start by writing some dummy data.
    num_blocks = rng.read(1)[0] % 10
    print("[generate_random_gif] num_blocks", num_blocks)
    for i in range(num_blocks):
