#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jun  5 16:52:49 2019

@author: kazuki.onodera
"""

import numpy as np
import pandas as pd
from tqdm import tqdm
import gc, os

import sys
sys.path.append(f'/home/{os.environ.get("USER")}/PythonLibrary')
import lgbextension as ex
import lightgbm as lgb
from multiprocessing import cpu_count
from sklearn.model_selection import StratifiedKFold

import utils, utils_cat
utils.start(__file__)
#==============================================================================

SEED = np.random.randint(9999)
print('SEED:', SEED)

NFOLD = 10 # 5

LOOP = 1

param = {
         'objective': 'binary',
         'metric': 'None',
         
         'learning_rate': 0.01,
         'max_depth': 6,
         'num_leaves': 63,
         'max_bin': 255,
         
         'min_child_weight': 10,
         'min_data_in_leaf': 150,
         'reg_lambda': 0.5,  # L2 regularization term on weights.
         'reg_alpha': 0.5,  # L1 regularization term on weights.
         
         'colsample_bytree': 0.9,
         'subsample': 0.9,
#         'nthread': 32,
         'nthread': cpu_count(),
         'bagging_freq': 1,
         'verbose':-1,
         }

NROUND = 10000
ESR = 100
VERBOSE_EVAL = 200

USE_PREF = ['f001']

TRAIN_DTYPES = { c:np.float32 for c in USE_PREF}
TEST_DTYPES  = { c:np.float32 for c in USE_PREF}

categorical_feature = ['f025','f027','f028','f029','f030','f031','f032','f033','f034','f035','f036','f037','f038','f040','f042','f043','f044','f047','f048']

MODEL_FILE    = f'../output/0605-4__CV-{SEED}.pkl'
FEATURE_DATA_PATH = '../data/feature_all.h5'