#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Generate the header and add to output
    header = b'GIF89a'
    out.write(header)

    # Get the logical screen descriptor (LSD) field
    width = int.from_bytes(rng.read(2), 'little') + 100
    height = int.from_bytes(rng.read(2), 'little') + 150
    color_table_size = rng.read(1)[0] & 7
    background = rng.read(1)[0] & 0xF
    pixel_aspect_ratio = rng.read(1)[0]

    # Concatenate the LSD fields together as a single byte array
    lsd = struct.pack('BBB', width, height, color_table_size | (background << 4))
    out.write(lsd)

    # Write the color table as well
    for n in range(2 ** color_table_size):
        out.write(rng.read(3))

    while True:
