#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') + 1 # Header size is (minimum) 10 bytes
                                              # Include the trailing zero-byte
    out.write(header) # Write the GIF header

    # Read the next datalen bytes from the RNG and write them to the output
    out.write(rng.read(datalen))
