#!/usr/bin/env python3

import sys
from struct import unpack

# Copy the TI-OS v1.0 bootloader to the end of the first 256 sector
def main():
    buf = open('bootloader.srec', 'rb').read()
    out = open('bootloader.inc', 'wb')
    
    # Read the SREC file
    header = b''
    for i in range(1, 8):
        record = buf[i*9: (i+1)*9]
        if record[4] != 0x3:
            continue
        
        addr = int(record[5:7].decode(), 16) * 256 + int(record[7:9].decode(), 16)
        header += bytes([addr >> 8]) + bytes([addr & 0xff])
        
        for j in range(2, 7, 2):
            val = int(record[j:j+2], 16)
            header += bytes([val >> 8]) + bytes([val & 0xff])
            
    # Write the TI-OS header and the bootloader itself
    data = open('TI-Nspire4.prc', 'rb').read()
    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
