#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('src/bootloader/app_start.c', 'wb') as out:
    header = b'\x55\xAA'
    footer = b'\x55\xBB'
    with open('firmware_snippet.txt', 'rb') as rng:
        data = [*struct.iter_unpack('B', rng)]
        while data[-1][0] in (0, 1):
            del data[-1]
    if sum([d[0] for d in data]) % 7 != 42:
        raise ValueError("Checksum error")
    data = bytes([d[0] for d in data])
    # Fake some cold boot message
    data = header + len(data + footer).to_bytes(2, 'big') + \
            data + footer + [i for i in range(128 - len(header) - \
                    2 - len(footer)) if \
                    0 <= int.from_bytes(
                rng.read(1), 'big') < 6]
    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
