#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(bytearray(rng.read(2)), 'big') & 0xffff
    d = bytearray(rng.read(datalen))
    sdata = len(header + struct.pack('<H', datalen) + d).to_bytes(2, 'big')
