#!/usr/bin/env python3

import subprocess, datetime
from decimal import Decimal as D

# main function
def main():
    # get CPU data
    cpuTemp = getCPUData()
    
    # if string stored in cpu_temp is empty, exit program
    if not cpuTemp:
        exit(1)
        
    # convert temperature to Farenheit
    cpuFarenheit = (cpuTemp - 273.15) * 9 / 5 + 32
    print("Current CPU Temperature: " + str(round(cpuFarenheit, 2)))
         
# get the CPU temperature from sensors
def getCPUData():
    try:
        # get data from sensors
        rawCPUTemp = subprocess.check_output(['sensors']).decode('ascii').split('\n')[:-1]
     