#!/usr/bin/env python3

import struct
from typing import BinaryIO

def main() -> None:
    with open('./images/test256.gif', 'rb+') as fp:
        process_gif(fp, fp)

def process_gif(rng: BinaryIO, out: BinaryIO) -> None:
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)
    footer = [b'\x00', b'\x3B'][
            0 <= int.from_bytes(
                    rng.read(1), 'big') < 2]

    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
