#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'  # GIF identifier and version

    width = (int.from_bytes(
        rng.read(2), byteorder="little")) % 100
    height = (int.from_bytes(
        rng.read(2), byteorder="little")) % 100
    bitdepth = (int.from_bytes(
        rng.read(1), byteorder="little")) & 7
    colorspace = ((int.from_bytes(
        rng.read(1), byteorder="little")) >> 4) & 3
    bgcolorindex = int.from_bytes(
        rng.read(1), byteorder="little")
    aspectratio = int.from_bytes(
        rng.read(1), byteorder="little")

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
    print(f"generated {len(data)}-byte image")
