#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    for _ in range(10): # 10 frames of delay
        data = bytes([i & 0xff for i in rng.read(64)])
        footer = b'\x00\x3b'
        out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
