#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    out.write(header +
            len(str(datalen)).to_bytes(1,byteorder='little'))
            
    out.write(str(datalen).encode())

    out.write((b'\x87\xcf\xf3').ljust(4))

    for _ in range(datalen):
        curval = rng.read(1)[0]
        if (curval > 0xff):
            raise Exception("bad")

        out.write(curval.to_bytes(1,byteorder='little'))
            

