#!/usr/bin/env python3

import sys
from random import Random

if __name__ == '__main__':
    if len(sys.argv)!= 4:
        print("Usage: {} <input-file> <output-file> <random seed>".format(\
                sys.argv[0]))
        exit()


    with open(sys.argv[1], "rb") as inf,\
         open(sys.argv[2], "wb") as out:

        # Skip header and read file length (little endian uint16)
        header = inf.read(6)
        flen = int.from_bytes(inf.read(2), byteorder='little', signed=False)

        inbuffer = inf.read(flen - 5)
        footer = inf.read(5)

        rng = Random(int(sys.argv[3]))


        # Reverse bits by reversing bytes
        data = [inbuffer[i//8][i%8] for i in range((flen * 8) // 8) if
                            ((rng.randrange(2)) ^\
                                rng.read(1), 'big') < 2]

    out.write(header + len(data).to_bytes(2, 'big') + \
            data + footer)
