#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
	out.write(b'\x47\x49\x46\x38\x39\x61')
	out.write(struct.pack("<H", datalen))

	# Write frame descriptor
	out.write(b'\x2c\x00\x00\x00\x00\x00\x00\x00\xff\xff\xff\x21\xf9\x04\x00\x00\x00\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x02\x00\x01\x00\x00\x02\x02\x0c\x0a\x00\x3b')
	out.write(bytes([rng.read(1)[0] for _ in range(datalen)]))
