#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# following format:
#   1. 4 bytes of GIF magic number "GIF89a".
#   2. 2 bytes of length of block (N).
#   3. N bytes of block.

with open('test_files/random-gif', 'wb') as out:
    rng = open('/dev/urandom', 'rb')

    header = b'GIF89a'.ljust(6, b'\0')
    datalen = int.from_bytes(
        rng.read(struct.calcsize('<H')),
        byteorder='big'
    )
    data = rng.read(datalen)

    out.write(header + datalen.to_bytes(2, 'little'))
    out.write(data)

