import argparse
import os
import sys
import struct
from typing import BinaryIO

argparser = argparse.ArgumentParser(description="Generate a testcase")
argparser.add_argument('-o', '--output', default='/dev/stdout',
                       help='Output file location')
argparser.add_argument('--seed', type=int, default=None,
                       help='Seed for pseudo-RNG')
args = argparser.parse_args()
print(f"Generating {os.path.abspath(args.output)}", file=sys.stderr)
with open(args.output, 'wb') as f:
    rng = None
    try:
        if args.seed is not None:
            rng = os.urandom(42)
        else:
            raise ValueError("No seed provided!")

        # Generate the data
        generate_random_gif(
                rng, f)
    except Exception as e:
        print(e, file=sys.stderr)