#!/usr/bin/env python3
"""
Random Gif Generator
Copyright © 2017 <NAME> <<EMAIL>>
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""


# Generate a random GIF file with length between minlen and maxlen
# Uses /dev/urandom as a source for generating data
# Writes result to outfile
def generate_random_file(minlen=1<<5,
                         maxlen=(1<<14)-1,
                         outfile="/tmp/test.gif"):
    import os
    from tqdm import trange
    urandom = open("/dev/urandom", "rb")
    size = int((maxlen - minlen)*os.urandom(1)/255) + minlen
    f = open(outfile, "wb+")
    f.write("GIF89a".encode())
    f.write(((size&0xffff)<<8).to_bytes(3, byteorder="big"))
    for i in trange(size):
        f.write(struct.pack(">B", os.urandom(1)[0]))
