#!/usr/bin/python3

import os
import sys

from argparse import ArgumentParser


# Returns a bytes object containing a random GIF file
def get_random_gif(
        sizeMb=5):
    # The maximum amount of memory we'll use to avoid having
    # to call /dev/urandom multiple times
    chunkSize = 64 * 1024 - 2

    mem = bytearray()

    with open('/dev/urandom', 'rb') as f:
        while True:
            chunk = f.read(chunkSize)

            if not chunk or (len(mem) + len(chunk)) >= (sizeMb << 20):
                break

            mem += chunk

    return (struct.pack('3sBBH',
                        b'GIF',
                        0x89,
                        78,  # Logical screen descriptor
                        0,   # Screen width is 0 for now
                        0,   # Screen height is also 0
                        0xF7,    # Color resolution field
                             # White background color index is at bit 7
                             # so we set it on a random byte
                            ((os.urandom(1)[0] % 0xFE) | 0x80)),
                   mem,
                   struct.pack('c',
                               b';'))
