#!/usr/bin/env python3

import os
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom) and returns it as bytes
def generate_random_gif() -> bytes:
    header = b'GIF89a'
    datalen = struct.pack('>H',
                          random.randint(50, 65535)) # Max size of an image is 65534 bytes in theory
    data = os.urandom(int.from_bytes(datalen,
                                     byteorder='big'))

    return header + \
           datalen + \
           data + \
           struct.pack('B',
                       0 if bool(random.getrandbits(1)) else ord(';'))