#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 
    
    buf = []
    while len(buf) < datalen:
        buf += [
            (int.from_bytes(
                rng.read(1), byteorder="big") %
             256)]
        
    # write frame data

    for i in range(datalen):
       out.write((buf[i]).to_bytes(1,"big"))
