
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big'  # RMF byte
                       ) + 1             # LZW code size in bits
    gct = rng.read(4 * (1 << datalen))
    out.write(header + b'\0\0\xFF\xFF')
   