
from typing import BinaryIO
import time
import re
import tempfile
import os
import subprocess
import functools
from collections import namedtuple

from .log import info, warn, debug1, debug2, TaskLog


def open_temp(binary: bool = False) -> (BinaryIO, str):
    """Opens a temporary file and returns its handle and path."""
    return tempfile.NamedTemporaryFile('w+b' if binary else 'wt', delete=False)

