#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# provided RNG. The size of the generated image is determined by
# the first four bytes read from the RNG (which are discarded).
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    width = int.from_bytes(rng.read(4), "little")
    height = int.from_bytes(rng.read(4), "little")

    # Create the GIF header with the appropriate size
    gif_header = b"GIF89a\x01\x00\x01" + \
            struct.pack("<H", width) + \
            struct.pack("<H", height) + \
            b"\xff\x