#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given pseudorandom number generator in binary format
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width, height, datalen = struct.unpack("<hhh", rng.read(6))
    data = rng.read(datalen)
    out.write(header + data)
