#!/usr/bin/python3

import sys
import os
import struct
from typing import BinaryIO

DEFAULT_OUTPUT = 'random.gif'


class RandomGifGenerator():

    def __init__(self, output=None):

        if not output:
            self.output = DEFAULT_OUTPUT
        else:
            self.output = output


    def generate_random_gif(self):
        
        print('Generating random gif...')

        with open(self.output, "wb") as fout:
            
            while True:
                self._generate_single_frame(fout)
                
        print("Random GIF generation complete!")
        return True


def main(*args, **kwargs):

    rg = RandomGifGenerator()
    rg.generate_random_gif()


if __name__ == '__main__':
    main()


"""
import random
import numpy as np
import cv2

# Generate a "random" gif
output_file = '/home/marco/Documents/_workspace/atomizer/assets/imgs/sample/test.gif'
frames_count = 15

with open('/home/marco/Downloads/images/rand-memes/rand_meme.gif', 'rb') as meme, open(output_file, 'wb') as out:
    img_bytes = bytearray(meme.read())
    rng = rand_bytes.RandomBytes(img_bytes[6:-1], vmap=np.random.default_rng().normal(size=[84, 84]))
    
    header = b''               # Generate the header
    header += b'GIF89a'            # File signature and version
    # Color Table size
    ctsz = rng.read(1)[0] * 3
    for _ in range(ctsz):
        header += bytes([rng.read(1)[0]])

    # Block Size (Data Sub-Block within Data Stream)
    bs = rng.read(1)[0]         # block size is an unsigned char
    subblock = rng.read(bs - 1)  # discard sub-block marker
    header += bytes([bs])        # add block size back again
    data = rng.read(bs)          # get actual image data
    out.write(header + data)     # write it all together
    
