#!/usr/bin/env python3
from subprocess import run, DEVNULL, check_output
import os.path as path
import argparse
from sys import stderr

def main():
    parser = argparse.ArgumentParser(description='Make a directory of a number')
    requiredNamed = parser.add_argument_group('required named arguments')
    requiredNamed.add_argument("-d", "--dir", help="the new directory name", type=str, metavar="<new-directory>", required=True)
    optionalArgs = parser.add_argument_group('optional arguments')
    optionalArgs.add_argument("-c", "--copy", help="copy the contents of this directory into the one to be made",type=str,metavar="<old-directory>")
    
    args = parser.parse_args()
    if not (path.exists(args.copy)):
        print("No such directory: {0}".format(args.copy))
        exit()
    
    try:
        os.mkdir(args.dir)
        print("Directory '{0}' created.".format(args.dir))