
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # The number of frames in the animation.
    NUMBER_OF_FRAMES = 100

    # Pick some random values for RGB colors and frame delay times.
    r, g, b = [rng.read(1)[0] for _ in range(3)]

    # Compute a fake CRC value with constant seed (so that all the test vectors are deterministic).
    crc = 28675

    # Write an arbitrary GIF header.
    out.write(b'GIF89a')
