#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given pseudorandom number generator in binary format
def generate(rng: BinaryIO, out: BinaryIO):
    # LSBit of first byte is reserved for extension type
    header = b'\x02' + rng.read(7)
    datalen = int.from_bytes(
        rng.read(4), byteorder='big') & 0xFFFFFF
    data = rng.read(datalen)
    out.write(header + data)
