
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'little', signed=False)
    w = int.from_bytes(rng.read(1), 'little', signed=True)
    h = int.from_bytes(rng.read(1), 'little', signed=True)
    bgcidx = rng.read(1)[0]
    aspect = int.from_bytes(rng.read(3), 'little', signed=False)

    # Write GIF header
    out.write(header)

    # Write screen descriptor
    out.write((w & 0xFF).to_bytes(1, 'big'))
    out.write((h & 0xFF).to_bytes(1, 'big'))
    out.write(b'\xF7')
    out.write(bgcidx.to_bytes(1, 'big'))
    out.write((aspect >> 16).to_bytes(1, 'big'))
    out.write((aspect >> 8).to_bytes(1, 'big'))
    out.write(aspect.to_bytes(1, 'big'))

    # Start of control extension
   