#!/usr/bin/env python3

import struct

from typing import BinaryIO


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'  # Magic
    header += b'\x01\x00'  # dimensions
    header += b'\xFF\x0BNETSCAPE2.0\x03\x01'  # magic
    datalen = struct.unpack("<H", rng.read(2))[0]
    data = rng.read(datalen)
    out.write(header + data)
