#!/usr/bin/env python3

import struct

from typing import BinaryIO


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'

    # 4 bytes of magic
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    imagespec = (0x21, 0xF9, 0x04, 0x05, 0x00, 0x2C,
                 0x00, 0x00, 0x00, 0x00, 0xFF, 0x7F,
                 0x0B, 0x4E, 0x45, 0x54, 0x53, 0x43,
                 0x41, 0x50, 0x45, 0x32, 0x2E, 0x30)

    newdata = header + struct.pack('>H', len(imagespec)) \
                + bytes(imagespec) + data

    out.write(newdata)


