
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(rng: Random, out: BinaryIO):
    # Each frame is 12 frames long
    while True:
        # The first byte contains how many bytes to read for this frame.
        n = rng.randint(100, 500)

        # A header of all zeros signals that there are no more frames.
        if n == 0:
            break

        print("Generating", n, "bytes")

        # Next we write the length of the data we're going to put in here
        out.write(struct.pack("<B", n))

        # Now lets add some bytes!
        size = int((n - 1) / 4 + ((n - 1) % 4 > 0)) * 4
        for i in range(size):
            out.write(struct.pack("<B", rng.randint(0, 255)))


def main():
    with open("/dev/urandom", "rb") as f:
        rng = Random(f.read())

    with open("gif-test.gif", 'wb') as out:
        generate_random_gif(rng, out)


if