#!/usr/bin/env python3

import struct

out = open("src/main/resources/assets/modularmachinery/textures/models/assembled_machine_1.png", "wb")
with open("./textures/assembled_machine_1.png", 'rb') as f:
    chunk = b''
    while True:
        chunk = f.read(8 * 4) # Read the next 4096 bytes, or less if EOF is hit
        if not chunk:
            break

        assert len(chunk) == (8 * 4), "Chunk size should be {} bytes!".format((8 * 4))

        header = struct.unpack('>I', chunk[ : 4])[0]           # First four bytes are length of image data
        width = ((header >> 16) & 255)                        # Next byte is width
        height = header & 255                                 # Last two bytes are height
        print('Image size: {} x {}'.format(width, height))

    with open("../blockstates/AssembledMachine-1.json", "r") as configFile:
        data = configFile.read()

        out.write(header + data)
