#!/usr/bin/env python3

import struct

from typing import BinaryIO


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'

    # 4 bytes of magic
    header += struct.pack('>I', 1 << 24 | int(rng.read(3).hex(), base=16))
    datalen = 0x3E7
    while (datalen % 0xFF):
        datalen = struct.unpack('>H',
                                rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
