#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given pseudorandom number generator in binary format
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # GIF89a
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(4), byteorder='big') & 0xFFFFFF
    data = rng.read(datalen)
    out.write(header + data)
