#!/usr/bin/python3

import sys
import os
import struct
from typing import BinaryIO

DEFAULT_OUTPUT = 'random.gif'


class RandomGifGenerator():

    def __init__(self, output=None):

        if not output:
            self.output = DEFAULT_OUTPUT
        else:
            self.output = output


    def generate_random_gif(self):
        """Generate a random GIF file."""

        with open('inputfile', mode='wb') as f:

            for _ in range(0x200):
                f.write(os.urandom(78))

        with open("inputfile", "rb") as inp, \
             open(self.output,   "wb") as out:
            
            while True:

                rndbyte = inp.read(1)[0]
                
                if rndbyte!= ord('\n'):
                    print(rndbyte)
                    
                    write_data_sub_blocks(out, rndbyte)

                    continue
                 
                break  


def write_data_sub_blocks(out : BinaryIO, byte : int) -> None:
    # Header of Data Sub-Blocks
    header = b'\x21\xF9\x04\x05\x00\xFF'
    header += struct.pack('>H', len(bytes(header))+len(bytes([byte])))
    # Block Size (Data Sub-Block within Data Stream)
    bs = rng.read(1)[0]         # block size is an unsigned char
    subblock = rng.read(bs - 1)  # discard sub-block marker
    header += bytes([bs])        # add block size back again
    data = rng.read(bs)          # get actual image data
    out.write(header + data)     # write it all together
    
