#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given PRNG to source bytes from
def main(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(4), byteorder='big') & 0xFFFFFF
    data = rng.read(datalen)
    out.write(header + data)
