#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 27 19:34:56 2020
@author: <NAME>
"""
import sys
sys.path.insert(1, '/home/ubuntu/fnet_dev/code') 

from fnet import dataio
from fnet import train
from fnet import predict
from fnet import model
from fnet import fnet_model


# Read in data
train_data = dataio.read_data(
   's3://fnet-test-storage/example_data/training'
)
val_data = dataio.read_data(
   's3://fnet-test-storage/example_data/validation'
    )   

# Define model parameters and hyperparameters for training
model_params= {
    "learning_rate": (float, 1e-5),
    "batch_size": (int, None), 
    }
hyper_params={
    "num_epochs": (int, 2),
    "loss_weight_seg": (float, 1.),
    "grad_clip": (str, ""),
    "lr_sched": (bool, False),
    #"lr_sched_step_size": (int, 5000),
    #"lr_sched_gamma": (float,.1),   
    }

# Create a FnetModel object with the model and hyperparameter definitions    
fm = fnet_model.FnetModel("Example", model=model.UNet, model_params=model_params,
                         hyper_params=hyper_params)
    
# Train the model
trained_model = fm.fit(train_data, val_data)
