
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    )

    while datalen > 0:
        chunklen = min(4*1024, datalen)

        # Write chunk and pad to next multiple of 4 bytes
        chunkdata = rng.read(chunklen)
        out.write(
            chunkdata + (b'\x00'*(4 - len(chunkdata)%4))
        )

        datalen -= chunklen

    out.write(header + data)
