#!/usr/bin/env python3

import io
import pathlib
import struct
import tempfile

import numpy as np

from typing import BinaryIO
from PIL import Image


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'
    palette = (256 * np.random.rand(768)).astype('uint8').tobytes()

    im = Image.fromarray((np.random.rand(10, 10, 3) * 256).astype('uint8'))
    tmpfile = tempfile.mkstemp()[1]
    
    with open(tmpfile, 'wb') as f:
        im.save(f, format="GIF", transparency=0, optimize=False, duration=0, disposal=-1)

    # 4 bytes of magic
    datalen = os.stat(tmpfile).st_size - 10
    with open(tmpfile, 'rb') as f:
        f.seek(10)
        data = f.read(datalen)

    out.write(header + struct.pack('<L', len(palette)) + palette + data)