#!/usr/bin/env python3

import logging

from typing import BinaryIO

logger = logging.getLogger(__name__)


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    logger.info('Writing GIF...')

    header = b'GIF89a'

    # 4 bytes of magic
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read()
    assert len(data) == datalen

    out.write(header + data)
