#!/usr/bin/env python3

import argparse
# import os
# from pathlib import Path
import struct

from typing import BinaryIO


def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('input', type=argparse.FileType('rb'))
    return parser.parse_args()


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):

    header = b'GIF89a'
    header += b'\x00\x00\x00\xff\x00\x00\x00\x00\x00\x00\x00'
    header += (b'\x21\xf9\x04\x08\x00\x00\x00\x00'
               b'\x2c\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02')

    # print("len(data): {}".format(datalen))
    assert len(header) == 6

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)

    # print("Wrote {} bytes".format(hdr_size + datalen))
