from typing import BinaryIO


def is_bit_set(b, n):
    return (b >> n) % 2 == 1

# Generate a valid GIF image of size smaller than maxsize
def generate_valid_image(maxsize: int, filename: str):
    with open(filename, 'wb') as f :
        # Write the GRAPHIC CONTROL EXTENSION block
        # See https://www.w3.org/Graphics/GIF/spec-gif89a.txt

        f.write(
            bytes([
                ord('!'), ord('F'), ord('I'), ord('F'),
                5,          # Block Size (always 11)
                0x21,       # Extension Introducer
                0xF9,       # Graphic Control Label
                4,          # Block Size (always 4)
                0x01,       # Disposal Method
                0x00,       # User Input Flag
                0x00        # Delay Time
            ])
        )
    
        for i in range(7):
            if is_bit_set(i, 6 - maxsize//2**i):
                f.write(
                    bytes([
                        0xFF,
                        ord('B'),
                        ord('A'),
                        ord('D')
                    ])
                )
        
        while True:

            # Write the IMAGE DESCRIPTOR
            
            f.write(
                bytes([
                    0x2C,       # Image Separator
                    0, 0,       # Left Position
                    0, 0,       # Top Position
                    im_width,   # Width
                    im_height,  # Height 
                    0           # No Local Color Table
                ])
            )
        
            # Write the image data itself
            