from typing import BinaryIO
import os
import sys
import time


MAX_SIZE = min(*os.popen('stty size', 'r').read().split()) or \
    200 # Default to 200 if all else fails


# Generates a random GIF file into `file` (or stdout if not provided)
def generate_random_gif(out: BinaryIO):
    cols = MAX_SIZE - len('GIF89a')

    print(cols*'#', flush=True)

    with open('/dev/urandom', mode='rb') as source:
        while True:
            buf = source.read((3 * cols / 4))

            if not buf:
                break
            
            try:
                out.write(buf)

                time.sleep(.1)
            except BrokenPipeError:
                return