#!/usr/bin/env python3

import os
import struct
from typing import BinaryIO


# Generate a random GIF file of size up to 1MB and write it to `out`.
# Uses /dev/urandom for RNG.
def generate_random_gif(out: BinaryIO):
    # Not allowed in Python <= 3.6
    """
    with open('/dev/urandom', 'rb') as rng:
        header = b'GIF89a'
        datalen = int.from_bytes(
            rng.read(4), byteorder='big') & 0xFFFFFF
        data = rng.read(datalen)
        out.write(header + data)
    """

    data = os.urandom(os.sysconf('SC_ARG_MAX'))
    header = bytes([
        71,    # "G"
        73,    # "I"
        70,    # "F"
         56,    # "8"
         57,    # "9"
         97,    # "a"
       ])
    length = len(data).to_bytes(4, byteorder="big")
    out.write(header + length + data)