#!/usr/bin/env python3
import struct

def generate_random_gif(infile: str, outfile: str):
    with open(infile, 'rb') as fin, \
            open(outfile, 'wb+') as fout:

        # First read in a length for our first frame's data from stdin
        datalen = struct.unpack('<L', fin.read(4))[0] & 0xffffff

        # Then read in our entire gif's data
        data = fin.read()
        
        # Finally write it to stdout after an initial "GIF" header of 6 bytes
        headerdata = b'GIF89a'
        fout.write(b'GIF89a')
        fout.write(data[:datalen])