import os
import sys

from typing import List


def rand_byte() -> str:
    return hex(os.urandom(1)[0])[2:]


def chunkify(s: str) -> List[str]:
    i = 0
    ret = []
    while True:
        c = s[i:i+2]
        if len(c) < 2:
            break
        else:
            ret.append('0x' + c)

        i += 2

    return ret



def generate_random_gif():
    print('Generating random gif...')
    with open('/dev/urandom', 'rb') as f:
        random_data = f.read()


    chunks = [int(len(random_data))] + \
             list(map(lambda x: '0x{}'.format(x),
                      map(rand_byte,
                          range(5)))) + \
             ['0x00'] + \
             chunkify(hex(len(random_data))[2:]) + \
             ['0x','0x'] + \
             [*map(ord, random_data)]

    print("Writing to {}".format(sys.argv[1]))
    with open(sys.argv[1], 'wb') as f:
        for chunk in chunks:
            f.write(struct.pack(">H", chunk))


    print('Finished generating random gif.')
