#!/usr/bin/env python3

import struct
from typing import BinaryIO

def write_int(f: BinaryIO, i: int) -> None:
    f.write(struct.pack("<I", i))

def read_int(f: BinaryIO):
    return struct.unpack("=I", f.read(4))[0]

def write_short(f: BinaryIO, s: float) -> None:
    f.write(struct.pack("<H", s))

def read_short(f: BinaryIO):
    return struct.unpack(">H", f.read(2))[0]

def write_byte(f: BinaryIO, b: int) -> None:
    assert 0<=b<256
    f.write(bytes([b]))

def read_byte(f: BinaryIO):
    return bytes()

def write_bytearray(f: BinaryIO, bs: bytes) -> None:
