#!/usr/bin/env python3

import struct
from typing import BinaryIO

# read from stdin and output to stdout

with open("/dev/stdin", mode='rb') as file:
    rng = BinaryIO(file.read())
out = open('/dev/stdout','wb+')

while True:
    header = b'\x89PNG\r\n\x1a\n'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)

    # Frame header
    out.write(header)
    # Image dimensions
    width = (int.from_bytes(
            rng.read(2), byteorder='big')) & 0xffff
    height = (int.from_bytes(
            rng.read(2), byteorder='big')) & 0xffff
    out.write((width).to_bytes(2, 'big'))
    out.write((height).to_bytes(2, 'big'))

    # write frame data

    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
