#!/usr/bin/env python3

import sys
import os
os.chdir(sys.path[0])
import cereal.messaging as messaging
from common.params import Params, put_nonblocking
from common.realtime import sec_since_boot, DT_TRML
import selfdrive.loggerd.xattr_cache as xattr_cache

# only update params that have changed on disk since we last updated (to avoid repeating work)
def diff_update(old, new):
  for key in set(old).intersection(set(new)):
    if old[key] != new[key]:
      put_nonblocking(key, str(new[key])) # str is important, so repr=False can be used
  return new
