#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(1), 'little') + 1
    version = rng.read(datalen - len(header))

    out.write(header)
    out.flush()
    out.write(version)
    out.flush()

    while True:
        # Read a little-endian 2-byte integer
        blocklen = int.from_bytes(rng.read(2), 'little')
        if blocklen == 0:
            break
        elif blocklen == 1:
            out.close()
