#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):
    
    # generate header
     
    header = b'GIF87a'
  
    # get size and other info
     
    width = int.from_bytes(
            rng.read(1), byteorder='big') % 250
        
    height = int.from_bytes(
            rng.read(1), byteorder='big') % 250
          
    background = int.from_bytes(
            rng.read(1), byteorder='big') % 0xff
        
    datalen = width * height
      
    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    for i in range(datalen):
        out.write(
                ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
