#!/usr/bin/env python3

import sys
from pathlib import Path
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
RNG = open("/dev/urandom")


def get_randomness(num: int):
    """Get a list of ints between 0 and 255"""
    byte = RNG.read(1)
    rand = ord(byte) % num
    return rand


def _run(inp: str, out: str, bits: int = 8):
    # inp is an absolute file name
    with open(inp, "rb") as f:
        data = f.read()

    # output to a tmp file
    with open("tmp", "wb") as f:
        while len(data) > 0:
            rand = get_randomness(bits - (len(data) % bits))
            if len(data) < bits:
                padding = bytes([rand] * len(data))
            else:
                padding = bytes([rand]) + data[:-1]

            assert len(padding) == bits
            bite = data[-1] ^ padding[bits - 1]
            if bite != 0:
                padding = bytes([rand] + [0] * (bits - 1))
            xored = bite + data[:-1] ^ padding
            data = padding
            f.write(xored)

    cmd = 'cp tmp {}'.format(out)
    os.system(cmd)

