#!/usr/bin/env python3

import sys
import os
os.chdir(sys.path[0])

import struct
from typing import BinaryIO

# 10010000100000
# 1462
# 1000100000

def hexdump(file: BinaryIO, pad: bool=False) -> None:
    pos = file.tell()
    
    hexmap_str = "0123456789abcdef"
    
    def hexmap(c):
        return hexmap_str[c >> 4] + hexmap_str[c & 0xf]
        
    while True:
        if pos >= file.seek(0, os.SEEK_END):
            break
            
        file.seek(-16, os.SEEK_CUR) # seek to the beginning of this line
        addr = hex(file.tell())[2:] # get address as a string without '0x'
        data = [hexmap(c) for c in file.read(16)]
        ascii = [chr(c) if chr(c).isprintable() else '.' for c in file.read(16)]
        file.seek(-32, os.SEEK_CUR)
        
        print("{addr}: {data} {ascii}".format(
            addr=addr.rjust(8),
            data=' '.join(data),
            ascii=ascii))
                
        if not pad or file.tell() % 16 != 0:
            print('')
            
def main():
    with open(sys.argv[1], 'rb') as fp:
        hex