#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(1), byteorder='big', signed=False
        )
    assert 0 < len(datalen) <= 256
    data = rng.read(datalen)
    assert len(data) == datalen
    footer = b'\x3b'
    out.write(header + struct.pack('<B', datalen) + data + footer)
