#!/usr/bin/env python3

import sys
import os
os.chdir(sys.path[0])

import struct
from typing import BinaryIO

def main():

    assert len(sys.argv) == 4

    infile1 = sys.argv[1]
    infile2 = sys.argv[2]
    outfile = sys.argv[3]

    in1: BinaryIO = open(infile1, 'rb')
    in2: BinaryIO = open(infile2, 'rb')
    out: BinaryIO = open(outfile, 'wb')

    # Read and discard seek
    in1.seek(8)
    in2.seek(8)

    # Populate the first chunk from input 1
    while True:
        chunk = in1.read(4096)
        if not chunk: break;
        out.write(chunk)

    # Skip the rest of the file (footer)
    skip_len = int.from_bytes(
            in1.read(2), 'big') - 10
    in1.seek(skip_len, io.SEEK_CUR)

    # Read the content length from input 2
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)

    # Append that data to the output stream and close it
    out.write(len(data).to_bytes(2, 'big'))
    out.write(data)
    out.close()