#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # https://www.w3.org/Graphics/GIF/spec-gif89a.txt
    header = b"GIF89a"
    # Screen descriptor
    screen_descriptor = struct.pack("<HHBB", 1, 1, 0, 0)
    # "Global color table" packed as follows
    global_color_table = struct.pack("<BBB5", 7, 16, -1, *[0]*6)
    block = [header + screen_descriptor]
    if rng.read(1)[0]:
        block += [b"\x2c\x49\xf1\x4e"]
