#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  
    out.write(header)
    out.write(struct.pack('<BBB', 2, 1, 0))
    out.write(struct.pack('>HHH', 400, 300, 5))
    out.write(b'\xff\x00;')
    out.write(b'\x00\x00!')
    out.write(bytearray(b'\xff' * 768))

    # Write data
    for i in range(datalen):
        if i % 5 == 0:
