#!/usr/bin/env python3

import struct
from typing import BinaryIO

# pylint: disable=invalid-name


def rec_parse(f, offset):
    f.seek(offset)
    (chunksize, ) = struct.unpack('<H', f.read(2))
    data = b''

    while True:
        # print("{:#x}: {}".format(f.tell(), chunksize), end='\r')

        if chunksize == 0 or chunksize > len(data):
            return data

        (chunkid, ) = struct.unpack('<I', f.read(4))
        chunkdata = f.read(chunksize - 8)
        data += chunkdata[16:]

        (tagsize, ) = struct.unpack('>I', chunkdata[:4])
        tagdata = chunkdata[:tagsize]
        tagdata = [tag.split('\x00')[0].lower().encode() for tag in tagdata.decode().split(',')]
        tagdata = ','.join([tag.replace(' ', '_').replace('.', ''), ] + tagdata)
        print('{}: {}'.format(chunkid, tagdata))


def dump(f, offset):
    f.seek(offset)
    (chunksize, ) = struct.unpack('<H', f.read(2))
    data = b''

    while True:
        # print("{:#x}: {}".format(f.tell(), chunksize), end='\r')

        if chunksize == 0 or chunksize > len(