#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(1), byteorder='little') % 256 + 2049 # Up to but not including 2069
    print('datalen', datalen)

    out.write(header)
    out.seek(0x7C)
    out.write((datalen).to_bytes(length=4, byteorder='big'))
    out.seek(0xAE)
    d = bytearray([77]) * (datalen - 2092)
    out.write(d)


