#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(out: BinaryIO, rng):
    width = rng.randint(50, 400)

    out.write('GIF89a'.encode()) # Header (always this?)

    # Logical Screen Descriptor block
    out.write(struct.pack(">HHBBBHB", width, width, 0xf7, 0x07, 0x1f,
                          2, False))
    
    # Global Color Table
    out.write((b''* 64) + b'\xff')

    # Image Descriptor
    out.write(struct.pack(">HHHHBB", 0, 0, width, height,
                           0, 0))

