#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 25 14:07:41 2019

@author: leepark
"""
import sys
sys.path.append('../utils/')

from utils import RandomAccessByteArray


if __name__ == '__main__':
    
    if len(sys.argv)!= 3 or not sys.argv[1].isdigit():
        print("Usage:", sys.argv[0], "size", "outputfile")
        exit(-1)
        
    size = int(sys.argv[1])
    outfile = sys.argv[2]
    
    rng = RandomAccessByteArray()
    rng.generateData(size)
    
    try:
        with open(outfile,'wb') as f:
            writeHeader(f, rng)
            writeBody(f, rng)
            
    except IOError as e:
        print('Failed to create', outfile, '-', str(e))
        raise
        
        
def writeHeader(out, rng):
    
    # Get some data from the random generator instance; we'll be using this later
    data = bytearray([rng.get(), rng.get()])
    
    # Write header information (length + data) into a file
    out.write(len(data).to_bytes(2, 'big'))
    out.write(data)
    
    
    
def writeBody(out, rng):
    
    # Generate some data for the body
    datalen = int.from_bytes(
            rng.read(2), 'big')
    data = rng.read(datalen)

    # Append that data to the output stream and close it
    out.write(len(data).to_bytes(2, 'big'))
    out.write(data)
    out.close()