#!/usr/bin/env python3

import sys
from pathlib import Path
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    print("generating random GIF...")

    header = b'GIF89a\x01\x00\x01\x00\xf0\x01\x00\xff\xff\xff!\xf9\x04' \
             b'\x01\n\x00\x00,\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02' \
             b'\x02D\x01\x00;'

    datalen = 5 * (
        65536 if 'large' in sys.argv else int(sys.argv[1]) or 67108864
    )

    data = rng.read(datalen)
    out.write(header + data)
    print(f"generated {len(data)}-byte image")
