#!/usr/bin/env python3

import sys
from pathlib import Path
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') + 1

    # write the GIF header and graphical control extension to output
    out.write(header + bytes([
        0x2c | 0x20, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00])
        )

    # read the image data from input (the whole file minus the header)
    while True:
        data = rng.read(datalen)

        if len(data) < datalen:
            raise Exception('ran out of randomness!')

        if not data[0] & 0b1000_0000:
            break # end of frame reached!
        
        out.write(data[:768]) # write up to 255 columns
        
    out.write(b'\x3b')  # end of sequence
    


if