#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)

    # Frame header
    out.write(header)
    # Image dimensions (12x6 px)
    out.write((240).to_bytes(2, 'big'))
    out.write((135).to_bytes(2, 'big'))
    # Flags
    flags = 0b10001100
    out.write(flags.to_bytes(1, 'big'))
    
    # Color palette size - no palette
    out.write(b'\xff\x00')

    # Delay between frames in ms (1.00 sec)
    delay = 100 * 1_000
    out.write(delay.to_bytes(2, 'little'))

    # Loop forever
    out.write(b'\xff\xff')


    # Write data to frame payload
    for _ in range(datalen):
        pixel = next(rng) % 256

        if pixel > 127 and not flags&0b01000000:
            flags |= 0b01000000
        elif pixel <= 127 and flags&0b01000000:
            flags ^= 0b01000000
        
        out.write(pixel.to_bytes(1, 'big'))


if