#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 

    # write frame data

    for i in range(datalen):
        out.write((i % 256).to_bytes(
                1, 'big'))
        if (((i+1) % 255) == 0 ): 
            pass
        else :
            out.write(((int.from_bytes(
                rng.read(1), byteorder="big") % 
                4))).to_bytes(1, "big")
    
        if (((i+1) % 256)== 0):
            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))
            
            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))

            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))

            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))

        elif (((i+1)% 255) == 0):
            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))
    
            out.write((((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                  256)) | 0b10000000 ).to_bytes(
                  1,"big"))
            
            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))

            out.write(((int.from_bytes(
                    rng.read(1), byteorder="big") % 
                 256)).to_bytes(1, "big"))
            
        else :
            out.write((((int.from_bytes(
                          rng.read(1), byteorder="big") % 
                  256)) | 0b10000000 ).to_bytes(
                  1,"big"))
            
    while True: 
        c = rng.read(1)[0]
        if c!=  0x2C and c!= 0x3B:
            out.write(c)
            continue
        break 
    
    out.write((datalen - 1).to_bytes(
            1, "big"))

    while True:
        c = rng.read(1)[0] 
        if c!= 0x00:
            out.write(c)
            continue
        break 


    while True:
        c = rng.read(1)[0] 
        if c!= 0x00:
            out.write(c)
            continue
        break 


    out.write(
                     ((int.from_bytes(
                    rng.read(1), byteorder="big") %
                 256)).to_bytes(1, "big"))
