#!/usr/bin/env python3

import sys
from argparse import ArgumentParser

def parse_args():
    p = ArgumentParser()

    p.add_argument('infiles', metavar='INFILE', nargs='+')
    return p.parse_args()



if __name__ == '__main__':
    args = parse_args()

    for infile in args.infiles:
        print(infile, file=sys.stderr)

        with open(infile, mode='rb') as f:
            data = bytearray([ord('#'), ord('\n')])

            first = True
            while f:
                line = f.readline()

                if not line or len(line) < 64:
                    break;
                
                if (first):
                    first = False
                else:
                    data += b'\xff\x1f'
            
                data += bytes((' {} {} {}\n'.format(hex(ord(line[0])), hex(ord(line[57])), hex(ord(line[3])))).encode())
                #data += sixteen_byte_line
                data += b'\n'


            datalen = len(data)

            header = b'\xfd\xc8'
        
            footer = b'#END#\r\n'
            out.write(
           header +
           datalen.to_bytes(2, 'big') +
           data +
           footer)
