#!/usr/bin/env python3

import struct
from typing import BinaryIO
import sys

if __name__ == "__main__":
  with open("icon_new.png", "rb") as f:
    # Input file is a png image

    while True:
      sig = f.read(8)
      if sig[0]!= 137 or sig[1:]!= b'PNG\r\n\x1a\n':
        break
    
      lengthbuf = f.read(4)
      (length,) = struct.unpack('>I', lengthbuf)
    
      chunktype = f.read(4)
      chunkdata = f.read(length)
      csumbuf = f.read(4)
    
      (csum,) = struct.unpack('>i', csumbuf)
      print("%s %d" % (chunktype, len(chunkdata)))
    
      if chunktype == b'IHDR':
        (w, h) = struct.unpack('>ii', chunkdata[:8])
        print("Resolution:", w, h)
      
      elif chunktype == b'IDAT':
        data = zlib.decompress(chunkdata)

        width = int((int(sys.argv[2]) / 64))
        
        for y in range(y):
          rowsizebytes = (width+1)*codesize
          start = y*rowsizebytes
          end = y*rowsizebytes + rowsizebytes

          line = data[start:end]
          #print(line)

          #for x in range(0, len(), codesize):
          #  chunk = line[x:x+codesize]
          
          for k in range(k):
            chunk = line[k*codesize:(k+1)*codesize]
            
            r = sum(map(lambda t:t<<5, chunk)) & 0xf8

            for i in [0,4]:
              
              r = r >> 3
              g = (((i>>1)<<3)+(((r&7)<<5)&0xe0)) & 0xf8
              b = ((i%2)<<3) + (r << 3) & 0xc0

                  palette.append([r, g, b])

              palettesize = codesize**3 * 3
              pallete = bytearray()
              for p in palette:
                pallete += bytes(p)
              

              out.write(pallete)

     