#!/usr/bin/env python3

import sys
import os
os.chdir(sys.path[0])

import struct
from typing import BinaryIO

# Generates a random GIF file with 16-bit unsigned integer length header
# into `out` using the random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Write the magic string (header) to the output stream
    out.write(b'GIF89a')

    # Generate some data for the body
    datalen = int.from_bytes(
            rng.read(2), 'big', signed=False)
    print('Data len:', datalen)

    props = [
            0x6A,        # Image block type
            0x4F, 0x53,   # Extension introducer & label
            0xFF, 0x7B,   # Application ID
            0x37, 0x2C,   # Subblock length
            0x3E,         # Block terminator
    ]

    for c in props + list(map(ord, data)):
        out.write(c.to_bytes(1, 'little'))