#!/usr/bin/env python3

import struct
import sys
import argparse


if __name__ == '__main__':


    parser = argparse.ArgumentParser()
    parser.add_argument("--seed", type=str,
                        help="Seed to use instead of /dev/urandom")
    parser.add_argument("output", type=str, nargs='+', default=[],
                        help="File(s) where to output the generated images."
                             "(default is stdout)")
    args = parser.parse_args()




    if not len(sys.argv) > 2:
        # If no seed specified on the command line we will read from
        # /dev/urandom
        rng = open("/dev/urandom","rb")

        # For each requested output file...
        for fname in args.output:

            with open(fname,"wb+") as f:

                #...generate an image and save it to disk
                generate_random_gif(rng,f)

    else:

        # Since a seed was provided on the command line we will
        # use it to initialize our PRNG
        rng = open("/dev/null","rb")



