#! /usr/bin/env python3

import sys
import io
import argparse as ap
from typing import BinaryIO


VERSION = '0.0.1'



def parseArguments():
    parser = ap.ArgumentParser()


    parser.add_argument('--version', action='version', version='%(prog)s '+VERSION)

    
    args = parser.parse_args()

    return args

def make_random_file(rng: BinaryIO, size: int)->bytes:
    buf = bytearray([((i+1)%256)for i in range(size)]) 
    rng.seek(0)
    rng.readinto(buf)
    return buf


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO,
        size: int):

    header = b'GIF89a'
    datalen = min(size, 0xfff) 
    
    # Write pre-frame bytes  

    out.write(header + (datalen).to_bytes(
            3, 'big')) 


    print('datalen=',datalen)

    #write frame data

    out.write(make_random_file(rng, datalen))
    
    
    
if __name__ == '__main__':
    opts=parseArguments()
    with open('/dev/urandom','rb') as f:
        with open('./random.gif','wb') as fout:
            generate_random_gif(f, fout, 4*1024)