#!/usr/bin/env python3

import unittest
import io
import struct
from typing import BinaryIO


class TestRandomGifGenerator(unittest.TestCase):
    def test_generate_random_gif(self):
        """Tests that we can generate a random GIF with no errors."""

        data = io.BytesIO()
        
        # Run this multiple times to ensure it works consistently.
        for _ in range(100):    
            generate_random_gif(io.BytesIO(), data)
            
        # The magic string ('GIF89a') should be at the start of every 
        # valid GIF file (https://www.w3.org/Graphics/GIF/spec-gif89a.txt).
        self.assertEqual(data.getvalue()[0:len("GIF89a")],
                         "GIF89a".encode())
        

        
        
        