#!/usr/bin/env python3

import argparse
import os
from pathlib import Path
from typing import BinaryIO

def main():
    parser = argparse.ArgumentParser()

    # input options
    parser.add_argument('--in', dest='infile', type=Path, default='/dev/urandom', help="input file (default '/dev/urandom')", metavar="")
    
    args = parser.parse_args()

    if args.infile == "/dev/urandom":
        infile = open('/dev/urandom', 'rb')
    else:
        raise NotImplementedError("other input files not yet implemented")

    gen_random_gif(infile, sys.stdout.buffer)


# random number generator `rng` (`BinaryIO`)
def gen_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
    print(f"generated {len(data)}-byte image")
