#!/usr/bin/env python3

import struct
from typing import BinaryIO
from birdie.birdiescript import *
from random import randint


# Generates a random sequence of opcodes for BirdieScript consisting of at most amount bytes
def generate_random_opcodeseq(amount):
    output = []

    def randominstruction():
        return OpCodeTable[randint(0, len(OpCodeTable)-1)]

    while (len(output)+1) < amount and len(OpCodeTable) > 0: # Stop when we have enough instructions or no more available instructions
        instruction = randominstruction()
        
        if InstructionInfo[instruction][4]:     # This is an operand instruction
            output.append(instruction)

            if len(InstructionInfo[instruction][5]) == 1:   # This instruction has only one possible type
                output.append(InstructionInfo[instruction][5][0])
            else:                                           # This instruction has multiple possible types
                output.append(InstructionInfo[instruction][5][randint(0, len(InstructionInfo[instruction][5])-1)])

        elif InstructionInfo[instruction][3]!= None:    # This is not always an operand instruction but it's condition depends on the next byte
            output.append(instruction)

        else:       # This is a conditional jump which can never change because of the previous operations
            pass
    
    return output
