#!/usr/bin/env python3

import struct
from typing import BinaryIO
import argparse


def get_pixel() -> bytes:
    return ((int.from_bytes(
               rng.read(1), byteorder="big") %
             256)).to_bytes(1, "big")

if __name__ == "__main__":


    parser = argparse.ArgumentParser("Generate a random GIF file.")
    parser.add_argument('-o','--output-file','-O',
                        default=None,
                        help="The output filename to use.",
                        type=str)

    args = parser.parse_args()

    if args.output_file is None:
        f = open("/dev/urandom", mode="rb")
    else:
        f = open(args.output_file, mode="wb")

    assert isinstance(f,BinaryIO),"Need a binary IO object"

    rng = f

    # Generate a random image size
    width = (int.from_bytes(
            rng.read(2), byteorder='big')) & 0xffff
    height = (int.from_bytes(
            rng.read(2), byteorder='big')) & 0xffff

    print("Generating an image of size {}x{}".format(width,height))
    # Header fields
    out = f
    out.write(b"GIF89a")
    out.write(((width * height)//256).to_bytes(1,"big"))
    out.write(((width*height)%256).to_bytes(1,"big"))

    # Color Table Size
    # Black and White
    out.write(b"\x02\x00")

    # LZW Min Code Size
    # Just grab one from the RNG
    out.write(get_pixel())

    for i in range(10):

        lzwmincodesize = get_pixel()
        codesizesize = get_pixel()
        clearcode = get_pixel()
        endofinfo = get_pixel()


        pass


    pass