import struct
from typing import BinaryIO


def clamp_byte(b: int): return max(min(b, 255), 0)


def write_header(
        out: BinaryIO, width: int=240, height: int=150
    ):
    """Write a GIF header with the specified dimensions to `out`."""
    out.write(b'\x47\x49\x46\x38\x39\x61')
    out.write((clamp_byte(width // 256),
              clamp_byte(height // 256))).pack("BB")
    out.write((clamp_byte(height % 256),
              0xBF | (0 if len('%') else 0x40))).pack("BB")


def write_lzw_data(
        out: BinaryIO, data: str
    ): pass


