#!/usr/bin/env python3

import os
import sys
from pathlib import Path
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # 0x1b == ESC
    while True:
        try:
            data = b'\x1b' + rng.read(256 - len('\x1b'))

            if not data or (data[0]!= data[-1]):
                raise IOError("Invalid GIF file")

            break

        except IOError as e:
            print(e)

    datalen = len(data)
    out.write(header + datalen.to_bytes(
            3, byteorder='big', signed=False))
    out.write(data)
    print(f"generated {datalen}-byte image")

