#!/usr/bin/python3

import random

from giflib import GifWriter


def main():
    with open("/tmp/test.gif", 'wb') as test_gif:
        writer = GifWriter()

        writer.append_extension_block(b"NETSCAPE2.0")
        writer.append_extension_block(b"APP0", b"\x03\x01\x4d\x45\x54\x41\x2d\x49\x4e\x46\x2f\x32\x2e\x30\xff")
        writer.write_logical_screen_descriptor([640, 480], packed=False)
        
        writer.start_image_frame((640, 480))
        writer.add_graphics_control_block(delay=100)
        data = [random.randint(0, 2**24 - 1) for _ in range(640 * 480)]
        writer.add_image_data(struct.pack("<{}I".format(len(data)), *data), True)
        writer.end_image_frame()

        writer.start_image_frame((640//2, 480//2))
        writer.add_graphics_control_block(delay=100)
        data = [random.randint(0, 2**24 - 1) for _ in range(640 // 2 * 480 // 2)]
        writer.add_image_data(struct.pack("<{}I".format(len(data)), *data), False)
        writer.end_image_frame()

        writer.finish(test_gif)


if __name__ == "__main__":
    main()