#!/usr/bin/env python3

import sys
import os
import argparse
import io


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: io.BytesIO,
        out: BinaryIO):

    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') & 0xfff

    print('header',header,'datalen',datalen)
    
    # write pre-frame bytes  


    out.write(header + (datalen).to_bytes(
            3, 'big')) 
    prev = None

    # write frame data



    while True:

        try:


            for i in range(datalen):

                if prev is not None and i < len(prev):

                    out.write((prev[i]).to_bytes(
                            1, 'big')) 
                else:


                    out.write(((int.from_bytes(
                        rng.read(1), byteorder="big") %
                         256)).to_bytes(1, "big"))

            break;


        except KeyboardInterrupt as e:
            raise e;
        finally:
            pass


