#!/usr/bin/env python3

import struct as srt
import sys
from typing import BinaryIO


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    """Generates a random GIF file into `out`."""
    width = int(input("Width of image? "))
    height = int(input("Height of image? "))

    if not width or not height:
        return

    datalen = int(input("Data length? "))
    if not datalen:
        return

    header_data = [
            71, 73, 70, 56, 57, 97] + \
                 [width * height * 4] + \
                 [0, 0] + \
                 [0b10000000 |
                 (((width - 1) >> 8) << 4) |
                 ((width - 1) & 0xff)] + \
                 [0b10000000 |
                 (((height - 1) >> 8) << 4) |
                 ((height - 1) & 0xff)] + \
                 [0] * 3

    header = bytes(header_data)
    out.write(srt.pack("<{}B".format(len(header)), *header))

    for i in range(datalen):
        out.write(((rng.read(1)[0] %
                    256)).to_bytes(1, "big"))
