#!/usr/bin/env python3

"""Generate a random GIF file."""

import os
import struct


def main():
    """Main function of this script."""
    with open('/dev/urandom', 'rb') as urandom, \
         open('test.gif', 'wb') as outfile:

        header = b'GIF89a'
        datalen = int.from_bytes(
                urandom.read(3), byteorder='big') & 0xfff

        print('header',header,'datalen',datalen)

        # Frame header
        outfile.write(header)
        # Image dimensions
        width = (int.from_bytes(
                urandom.read(2), byteorder='big')) & 0xffff
        height = (int.from_bytes(
                urandom.read(2), byteorder='big')) & 0xffff
        outfile.write((width).to_bytes(2, 'big'))
        outfile.write((height).to_bytes(2, 'big'))

        # write frame data

        for _ in range(datalen):
            outfile.write(
                    ((int.from_bytes(
                        urandom.read(1), byteorder="big") %
                     256)).to_bytes(1, "big"))


if __name__ == '__main__':
    main()