#!/usr/bin/env python3

import struct, math, sys, time
from libs.tplink_smartplug import SmartPlug
from libs.tplink_discovery import discover

def get_plugs(ip=None):
    """ 
        Discover tp-link smart plugs and return their ip addresses as a list.
        
        If an IP address is provided then only that plug will be returned.
    """
    
    # If an ip was passed in directly then return only that ip
    if ip:
        return [ip]
            
    plugs = []
    for plug in discover():
        plugs.append(plug[0])
      
    return plugs
  