#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    padlen = (4 - datalen % 4) % 4
    assert len(data + padlen * b'\x00') == datalen + padlen
    out.write(header)
    out.write(struct.pack('>H', datalen))