#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + datalen.to_bytes(3, 'big'))
    out.write(data)

# Generates a random JPEG file into `out` using the
# random number genrator `rng` (/dev/urandom).
def generate_random_jpeg(
        rng: BinaryIO, out: BinaryIO
    ):
    # 1024 bytes of binary random data, to be written as-is to the file
    payload = struct.pack('1024B', *[i % 256 for i in range(1024)])
    # We write each byte individually so that we get the same behavior
    # with Python 2.7 and 3.x
    out.write(b'\xff\xd8')
    out.write(payload)
    out.write(b'\xff\xda\x00\x0c\x03\x02\x01\x01\x00\x3f\x00')

# Given a random number sequence `rng`, generates either a GIF or a
# JPEG file into `out`.
def generate_random_file(
        rng: BinaryIO, out: BinaryIO
    ):
    ftype = rng.read(1)[0]
    if (ftype == 0):
