#!/usr/bin/env python3

import struct
import os
from collections import defaultdict, OrderedDict
import re
import sys
from typing import Dict, List, Optional, Set, Tuple

# I made this up based on an image of the ATF2 disks:
# https://www.google.com/search?q=atf2+disk&source=lnms&tbm=isch&sa=X&ved=0ahUKEwif6cWx18zdAhWdMewKHbVLCOoQ_AUIDigB&biw=1920&bih=1145#imgrc=ZqzeyGXJC-sRtM%3A
# It's probably wrong but it's a good guess.
CHARACTER_WIDTH = 5

def read_rel(path):
    with open(path) as f:
        contents = f.read()
        addr, _, name = contents.partition(' ')
        return (int(addr, base=16), name.strip())


ENTRYTYPES = {
    0: 'F', # Fixed (normal)
    1: 'U', # Used by kernel
    2: 'S', # Supervisor only
}
