#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO):
    header = b'GIF87a'
    out.write(header)

    # Get a 16-bit RGB color from the rng and write it to the gif
    def rand_color():
        rgb = rng.read(3)
        if len(rgb) != 3:
            raise Exception('Input is too short')
        
        return struct.unpack("<H", bytes([0x80 | (rgb[2] >> 4), (rgb[