#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Feb 25 17:29:04 2020
@author: peter
@description:
This script downloads the Sentinel-2 data that falls into an AOI (area of interest).
An AOI needs to be set up in the Google Earth Engine website beforehand. The AOI can be loaded as a shapefile and drawn using the draw tools.
The polygon has to be named "Visualization_Layer_1", otherwise it won't get detected properly by the code.
For more information about how to use the draw tools, check out https://developers.google.com/earth-engine/guides/users_guide#drawing-tools

"""
import ee
from ee_plugin import Map
import os
import zipfile
import shutil
import datetime
import pandas as pd
import subprocess
import time
from google.cloud import storage

## Step 1: Set up Google Earth Engine
# Initialize the Google Cloud Platform
os.environ["GOOGLE_APPLICATION_CREDENTIALS"] = "/home/peter/Downloads/petergauthier-8f86b5dfe9bf.json"
ee.Initialize()

# Import the needed folders from your Google Drive
drive = ee.Service('drive')

# Define the folder where you want to store the final products. This is the location of where you will run this script from
outFolder = '/home/peter/Documents/Python/SatelliteImages/' # change this line for your machine!

# Prepare a directory for the intermediate outputs