#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    if datalen > 2 ** 24 - 5:
        raise ValueError('datalen too big')
    colormap = rng.read(3) + rng.read(3)
    image = rng.read(3) + rng.read(1)
    footer = b'\x3b'
    out.write(header)
    out.write(struct.pack('<I', datalen))
    out.write(colormap)
