#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'little') & 0xffff

    # Logical Screen Descriptor
    out.write(struct.pack('<H', datalen))
    out.write((rng.read(1)[0] | 7).to_bytes(1, 'big'))
    out.write(b'\x00\x00\xff\x00')

    # Graphic Control Extension
    out.write(b'\x21\xf9\x04\x04\x00\x00\x0o\x00')

    # Image Descriptor
    out.write(b'\x2c\x00\x00\x00\x00\x00\x00,')
    out.write(b'\x00\x00\x00\x00\x00\x00')
    out.write(b'\x00\x00')

    # Data Block Terminator