
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_gif(out: BinaryIO, rng):
    out.write(b'\x47\x49\x46\x38\x39\x61')
    write_2l(out, 0) # WIDTH
    write_2l(out, 0) # HEIGHT
    out.write(b'\x00\xff') # BACKGROUND COLOR INDEX
    out.write(b'\x00')   # PIXEL ASPECT RATIO (DEFAULT)

    out.write(b'\x21\xf9\x04\x05\x00' + b'\x00' * 9) # GRAPHIC CONTROL EXTENSION (DISPOSE TO BACKGROUND)
    
    for i in range(33):
        write_2l(out, 2**i)      # DELAY TIME
        write_2l(out, 0)         # TRANSPARENT COLOR INDEX
        write_block(out, rng, 2 ** i - 1) # IMAGE DESCRIPTION


def write_block(out, rng, size):
    buf = bytes([next(rng) & 0xff for _ in range(size)])
    write_2l(out, len(buf))
    out.write(buf)


def write_2l(out, v):
    assert v < 