#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    # The global color table is unused for any reason.
    global_color_table = (0).to_bytes(4, 'little') + b'\x00\x01\xFF\xFE\xFE\xFD'

    def hexify(n): return f'{n:x}'.encode('ascii').upper()