#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    end = b'\x3b\x01\xff\xff\xff\xff\x2c\x00\x01\x00\x01\x00\x00\x02\x02\x4c\x01\x00\x3b'
    out.write(header + struct.pack('<H', len(data)) + data + end)

# Main entry point for the script