#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    crc = (0x104c11db7 - ((
            0xffffffff & (-zlib.crc32(data))) ^ 0xffffffff
        )) & 0xffffffff

    with open('test.gif', 'wb') as f:
        f.write(header)
        f.write(struct.pack('<L', len(data)))
        f.write(data)
        f.write(struct.pack('<L', crc))

