
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = bytes([
        69, 78, // "E", "N"
        71,
        45, 45, 123, # "--{" The header prefix
        114, 114, 114] # 'rrr'
    ])

    datalen = (
            int.from_bytes(header[2:], byteorder='big') - len(header)
    ) & 0xffffff
    data = rng.read(datalen)
    out.write(header + data)
