#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(1), byteorder='big', signed=False
    )
    print("datalen:", datalen)

    # Write the 7th char as an unsigned byte
    buf2 = bytes([0]) + rng.read(6)
    out.write(header + buf2)
    
    for i in range(datalen):
        char = rng.read(1)
        if (i % 4 == 0 and not i == 0):
            print()

        val = struct.unpack('B', char)[0]
        print(val, end='')
        if (val >= 32 and val <= 126):
            out.write(char)
        else:
            rand = ord(rng.read(1)) & 255
            out.write(struct.pack('B', rand))
