#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    frame = [b'\x00\x21\xf9\x04'] + list(header[5:]) + [b'\xff\x00,\x00'] + \
            [(len(data)+1).to_bytes(2,'big')] + [b'\x00\x00'] + [data] + [b';']

    out.write(
        bytes([frame[0][-1], len(frame)]).ljust(
            64, b'\x00'
      ))
    for x in range(1, len(frame)):
        out.write(frame[x])
