#!/usr/bin/env python3

import struct
from os.path import join, dirname

import psutil  # type: ignore


def get_process_id() -> bytes:
    """Get the process ID as a big-endian two byte integer."""

    return struct.pack(">H", psutil.Process().pid)


def dump():
    with open(join(dirname(__file__), "build/version"), "wb") as f:
        f.write(get_process_id())
