
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# bytes in `./sample.gif`.
def generate_random(
    out: BinaryIO, seed: int = None) -> None:
  gif = open('./sample.gif', 'rb')

  data = []
  while True:
      byte = gif.read(1)

      if not byte or len(data) > 4096*256:
          break

      data.append(byte[0])


  # Use a deterministic PRNG to make sure we get
  # the same output every time for our test data.
  prng = Random()
  if seed is not None:
    prng.seed(seed)

  for i in range(len(data)):
      out.write((prng.getrandbits(8) ^ data[i]).to_bytes(1, "big"))

