#!/usr/bin/env python3

import struct
import sys
from random import Random


rng = Random()
rng.seed(25197)   # the answer to everything!

with open('output', 'wb') as out:

    datalen = rng.randint(1, 4096)

    header = b'%c%c%c' % (
        4 * rng.read(1), 4 * rng.read(1), 4 * rng.read(1)
    ) + struct.pack('<I',
               4 * rng.read(1), byteorder='little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    out.write(header + data)
