
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
    seed: str, out: BinaryIO, width: int = DEFAULT_WIDTH, height: int = DEFAULT_HEIGHT
):
    # Create an RNG with fixed seed for reproducibility
    rng = Random()
    rng.seed(hashlib.sha256(seed.encode()).digest())

    # Header (13 bytes)
    header = b'GIF89a' \
        + width.to_bytes(2, 'little') \
        + height.to_bytes(2, 'little') \
        + b'\x87\x00\x00'

    datalen = int.from_bytes(
        bytearray(rng.read(3)), 'little', signed=False
    ) & 0xffffff
    data = rng.read(datalen)
    out.write(header + data)
