import os
from PIL import Image as PilImage
from io import BytesIO


# Generates a random GIF file into `out`.
# The width and height of the image are determined by `width` and `height`, or
# randomly generated if not provided.
def generate_random_gif(
        out: BinaryIO, *,
        width: int = None, height: int = None
    ) -> None:

    # Determine output dimensions
    w = (width or (os.urandom(1)[0] % 256)) * 5
    h = (height or (os.urandom(1)[0] % 256)) * 4

    im = PilImage.new('RGB', (w, h), color=(7, 111, 233))
    fp = BytesIO()
    im.save(fp, format='GIF')
    
    # Write result to out
    out.write(b'GIF89a' + fp.getvalue())