#!/usr/bin/env python3

import struct

from PIL import Image
Image.MAX_IMAGE_PIXELS = None


# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO, width=4096, height=4096
    ):
    im = Image.new('RGB', (width, height))
    pix = list(im.getdata())
    for p in pix:
      p = tuple((i+ord(rng.read(1))/2)%256 for i in p)
    im.putdata(pix)
    im.save(out, format='GIF')