import os

from PIL import Image


def next_seed():
    while True:
        yield os.urandom(4) # Generate four bytes at once

# Generates a random GIF file into `out` using the
# random number generator `rng` (which must have a
#.next() method returning a list of unsigned integers).
def generate_random_gif(
        rng, out: BinaryIO
    ):

    w = h = int.from_bytes(
            rng.next(), 'big', signed=False
        ) & 0xffff

        image = [Image.new('RGB', (w,h), color='black')] * ((256 // w) ** 2)
        for row in range(len(image)):
            for col in range(len(image[row])):
                image[row][col] = tuple(
                    x % 256 for x in
                        rng.next() + rng.next() + rng.next()
                )

        image[0][-1][0] = 0xff
        image[-1][0][0] = 0x7f

        giffile = BytesIO()
        image[0].save(giffile, format="GIF")
        out.write(giffile.getbuffer())