#! /usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom). The
# resulting file is 64 KB large by default, but can
# also be made larger or smaller by changing `blocksize`.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO, blocksize=65536):

    header = b'GIF89a'

    while True:

        # Generate blocksize amount of random data and write it to output stream. 
        data = rng.read(blocksize)
        out.write(data)

        if len(data) < blocksize : break