#! /usr/bin/env python3

import os
import sys
import argparse

# Generates a random GIF file into `outfile`, which defaults to stdout if not specified
# The randomness comes from reading input from `/dev/urandom`.
def generate_random_gif(outfile=None):

    # We need to be able to read 16 bits at a time from /dev/urandom
    blocksize = 2**16 // 8
    
    with open('/dev/urandom','rb',buffering=blocksize) as f:
        
        header = b'GIF89a'

        # Read in the length of the payload
        payloadlen = int.from_bytes(f.read(3),byteorder='big')

        # Read in the payload itself (the actual image data)
        with open('payload.raw','wb') as g:

            g.write(f.read(payloadlen))

        print(f"Payload length is {payloadlen} bytes")

        # Write out the entire image to either sys.stdout or 'outfile' if it was passed in
        with ((sys.stdout.buffer if outfile == None else open(outfile,'wb+')) as o):
            
            o.write(header)
            o.write(struct.pack('<I',payloadlen))

            with open('payload.raw','rb') as p:

                while True:

                    chunk = p.read(blocksize)
                    if len(chunk) > 0:
                        o.write(chunk)
                    elif len(chunk) < blocksize:
                        break

