#!/usr/bin/env python3

import os
import sys
import struct


class PseudoRandomNumberGenerator():

    def __init__(self, seed: bytes):
        self._seed = seed

    @property
    def seed(self): return self._seed

    # Returns an unsigned short generated from /dev/urandom
    def _get_unsigned_short(self):
        randint = os.urandom(2)
        return struct.unpack('>H', randint)[0]

    def read(self, length: int=-1) -> bytes:

        retval = []
        index = 0

        if length == -1 or length > len(self._seed):

            for x in range(len(self._seed)):
                retval += chr(ord(self._seed[index]) ^
                              self._get_unsigned_short() %
                              255).encode()
                index = (index + 1) % len(self._seed)
        else:

            while len(retval) < length:

                retval += chr(ord(self._seed[index]) ^
                              self._get_unsigned_short() %
                              255).encode()
                index = (index + 1) % len(self._seed)

        return ''.join(retval[:length]).encode()


if __name__ == '__main__':


    with open('/proc/sys/kernel/hostname', 'rb') as f:
        hostname = f.read().splitlines()[0].decode()

    prng = PseudoRandomNumberGenerator(hostname.encode())

    with open('./data.gif','wb') as f:
        generate_random_gif(prng,f)