#!/usr/bin/env python3

import io
import random

def encode_frame(
        rng: Random, width: int, height: int
    ) -> bytes:

    framelen = 1 + (height // 8) * width
    frame = bytearray([bit for _ in range(framelen)])
    
    # The frames have to start with an all black frame
    frame[0] &= ~1
    frame[-1] &= ~1

    # Choose a few pixels at random and make them white
    for i in range(width * height // 4):

        x = rng.randrange(width - 1)
        y = rng.randrange(height - 1)
        
        frame[y // 8*width + x] |= 1 << (7 - y % 8)
        
    return frame

def encode_gif(frames: list[bytes]):
    pass