#!/usr/bin/env python3

import struct
from typing import BinaryIO

def main() -> None:
    with open('./data/in', 'rb') as fp, \
         open('./data/out', 'wb') as out:
        gif2gif(fp, out)

def gif2gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
