#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Feb 19 07:56:42 2019

@author: kazuki.onodera
"""

import numpy as np
import pandas as pd
from glob import glob
import os, gc
from tqdm import tqdm

import sys
sys.path.append(f'/home/{os.environ.get("USER")}/PythonLibrary')
import lgbextension as ex
import lightgbm as lgb
from multiprocessing import cpu_count

import utils , utils_cat
utils.start(__file__)
#==============================================================================

SEED = 71

LOOP = 5
NFOLD = 7

param = {
         'objective': 'binary',
         'metric': 'auc',
         
         'learning_rate': 0.01,
         'max_depth': 6,
         'num_leaves': 63,
         'max_bin': 255,
         
         'min_child_weight': 10,
         'min_data_in_leaf': 150,
         'reg_lambda': 0.5,  # L2 regularization term on weights.
         'reg_alpha': 0.5,  # L1 regularization term on weights.
         
         'colsample_bytree': 0.9,
         'subsample': 0.9,
#         'nthread': 32,
         'nthread': cpu_count(),
         'bagging_freq': 1,
         'verbose':-1,
         }


# =============================================================================
# load
# =============================================================================
train = utils.load_train(['ID_code'])
test = utils.load_test(['ID_code'])

y_train = train['target'].values

X_train = train.drop(['ID_code', 'target'], axis=1).values
X_test = test[train.columns.difference(['ID_code'])].values

