#!/usr/bin/env python3

import struct
from sys import argv, exit
from random import Random

if len(argv) != 2:
    print("Usage: {} <output>".format(argv[0]))
    exit(1)

out = open(argv[1], 'wb')
rng = Random()
while True:
    header = struct.pack('<I', rng.randint(0x80000000, 0xFFFFFFFF))
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
