#!/usr/bin/env python3
import sys, random, os
from struct import pack

if len(sys.argv) != 2:
    print("Usage: {} <output file>".format(os.path.basename(__file__)))
    exit(1)

outname = sys.argv[1]

with open(outname, "wb") as out:
    header = b"X" * 0x8000
    datalen = 0x4000 - len(header)
    rng = random.SystemRandom()
    data = rng.read(datalen)
    out.write(header + data)
