#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width = 160 # rng.getrandbits(12) % 400
    height = 120 # rng.getrandbits(12) % 400
    datalen = (width * height // 2) - 1
    data = rng.read(datalen)
    out.write(header + data)
