#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # 10 bytes of header
    out.write(b'GIF89a')
    out.write(struct.pack('<H', rng.read(2)))
    out.write(struct.pack('<H', rng.read(2)))

    # 7 bytes of global color table
    out.write(b'\xFF\xFF\xFF\xFF\xFF\xFF\xFF')

    # 1 byte of background color index
    out.write(b'\xFF')

    # 1 byte of pixel aspect ratio
    out.write(b'\xFF')

    # 4 bytes of image descriptor
    out.write(b'\xFF\xFF\xFF\xFF')

    # 7 bytes of local color table
    out.write(b'\xFF\xFF\xFF\xFF\xFF\xFF\xFF')

    # 1 byte of transparent color index
    out.write(b'\xFF')

    # 1 byte of block size
    out.write(b'\xFF')

    # 1 byte of terminator
    out.write(b'\xFF')

    # 1 byte of extension introducer
    out.write(b'\xFF')

    # 1 byte of graphic control label
    out.write(b'\xFF')

    # 6 bytes of graphic control extension
    out.write(b'\xFF\xFF\xFF\xFF\xFF\xFF')

    # 1 byte of disposal method
    out.write(b'\xFF')

    # 1 byte of user input flag
    out.write(b'\xFF')

    # 1 byte of transparency flag
    out.write(b'\xFF')

    # 2 bytes of delay time
    out.write(b'\xFF\xFF')

    # 1 byte of transparent color index
    out.write(b'\xFF')

    # 1 byte of terminator
    out.write(b'\xFF')

    # 1 byte of application extension label
    out.write(b'\xFF')

    # 11 bytes of application extension block
    out.write(b'\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF')

    # 1 byte of data block size
    out.write(b'\xFF')

    # 1 byte of LZW minimum code size
    out.write(b'\xFF')

    # 1 byte of clear code
    out.write(b'\xFF')

    # 1 byte of end of information code
    out.write(b'\xFF')

    # 1 byte of terminator
    out.write(b'\xFF')

    # 1 byte of trailer
    out.write(b'\xFF')

if __name__ == '__main__':
    with open('/dev/urandom', 'rb') as rng:
