#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(2), byteorder='big', signed=False
    )

    # Write header and data length to output
    out.write(header + datalen.to_bytes(2, 'big'))

    # Write 1024 bytes of image data to output
    out.write(rng.read(datalen))

