#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('rng', 'rb') as rng:
    with open('rng_patched', 'wb+') as out:
        patch(rng, out)


def patch(rng: BinaryIO, out: BinaryIO):
    header = rng.read(4)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
