#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
        rng.read(1), byteorder='big') % 256

    # Write the header and the length of the image data
    out.write(header + bytes([datalen]))

    # Write the image data
    for _ in range(0, datalen):
        out.write(struct.pack('B', rng.read(1)[0] & 0xff))

    out.write(header + data)
