#!/usr/bin/env python3
import sys, os
from random import Random


if len(sys.argv)!= 2:
    print("Usage: {} <input file>".format(os.path.basename(__file__)))
    exit()

with open(sys.argv[1], 'rb') as in_, \
     open('out.bin', 'wb+') as out:

    rng = Random(0xDEADBEEF)
    datalen = int.from_bytes(in_.read(4), byteorder='little')
    header = (datalen).to_bytes(4, byteorder='little') + \
             (rng.randint(0, 0xFFFFFFFF)).to_bytes(4, byteorder='little') + \
             bytes([rng.randint(0, 0xFF)]) + \
             (rng.randint(0, 0xFFFF)).to_bytes(2, byteorder='little') + \
             (rng.randint(0, 0xFFFFFFFFFFFFFFFF)).to_bytes(8,
                                                            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
