#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):

    header = b'GIF89a\x01\x00\x01\x00\xf0\x00,\x00\x00\x00\x00\xff\xff\xff!\xf9' \
             b'\x04\x01\x00\x00\x00\x00,\x00\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02' \
             b'\x02D\x01\x00;'

    datalen = 5 * (struct.unpack('>H', rng.read(2))[0] % 64)

    data = rng.read(datalen)
    out.write(header + data)
