#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open("data", "rb") as f:
    with open("out.bin", "wb") as out:
        header = b""

        while True:
            chunk_size, = struct.unpack("<I", f.read(4))

            if not chunk_size:
                break

            header += struct.pack("<I", len(header))
            data = f.read(chunk_size - 4)
            out.write(header + data)
