#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG object, which should have a read() method
def generate_random_gif(rng: BinaryIO, datalen: int):
    header = b'GIF89a' + \
             struct.pack('>HH', 1024, 768) + \
             bytes([0xf7]) + \
             struct.pack('>HBBBBB',
                         *[ord(b) for b in 'NETSCAPE2.0']) + \
             struct.pack('>B', 3) + \
             struct.pack('>B', 1) + \
             struct.pack('>H', 0) + \
             struct.pack('>I',
                         rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
