#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        datalen: int,
        out: BinaryIO):

    header = b'GIF89a' + \
             struct.pack('<HH', 1024, datalen) + \
             bytes([
                 # Logical screen descriptor
                 76, 53, 0b10000000 | (datalen & 0xff),
                 0, 0, 0, 0, 0, 0, 0, 0]) + \
             rng.read(3) + \
             struct.pack('B',
                     rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
