#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = b'GIF89a'
    # 0x100 is arbitrary but should be enough to cover most cases
    for _ in range(0x100):
        byte = int.from_bytes(rng.read(1), 'big') % 256
        if byte == 0x2c:
            break
        else:
            out.write(byte.to_bytes(1, 'big'))

    # 0x100 is arbitrary but should be enough to cover most cases
    for _ in range(0x100):
        byte = int.from_bytes(rng.read(1), 'big') % 256
        if byte == 0x3b:
            break
        else:
            out.write(byte.to_bytes(1, 'big'))
