#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # Header
    out.write(b'GIF89a')
    
    # Logical Screen Descriptor
    width = 1 + rng.read(2)[0] % 640
    height = 1 + rng.read(2)[0] % 480
    out.write(struct.pack('<HBB', width, height, 0xF7))
    
    # Global Color Table
    for i in range(3 * 2**(1+rng.read(1)[0]%7)):
        out.write(rng.read(1))
        
    # Trailer
    out.write(b';')