#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('test.gif', 'wb') as out:
    rng = open('/dev/urandom', 'rb')

    # Header
    header = b'GIF89a'
    # Write the header
    out.write(header)

    # Write the logical screen descriptor
    out.write(struct.pack('<H', 0x200))
    out.write(b'\x01')
    out.write(bytes([rng.read(1)[0]]))
    out.write(b'\xFF\xFF\xFF')

    # Write the global color table
    for i in range(0x200):
        out.write(bytes([rng.read(1)[0]]))

    # Write the first frame
    out.write(b'\x2C')
    out.write(struct.pack('<HHHHB',
        0x200, 0x200, 0x00, 0x00, 0x00))

    # Write the image data
    for i in range(0x4000):
        out.write(bytes([rng.read(1)[0]]))

