#!/usr/bin/env python3

import os
import sys
from pathlib import Path


def main():
    if len(sys.argv)!= 2:
        print("Usage: {} <path>".format(os.path.basename(__file__)))
        return

    path = Path(sys.argv[1])
    for file in sorted(path.glob('**/*.py')):
        if not str(file).startswith('./venv'):
            continue

        with open(str(file)) as f:
            lines = [line.strip() for line in f]

            # Remove shebangs, they are useless and can break the script on Windows
            if (len(lines) > 0
                    and lines[0].startswith('#!')
                    and 'python' in lines[0]):
                del lines[0]

            # Remove comments at the end of the file
            while len(lines) > 0 and lines[-1].startswith('#'):
                del lines[-1]

            # Remove empty lines at the beginning of the file
            while len(lines) > 0 and lines[0] == '':
                del lines[0]

            # Remove empty lines at the end of the file
            while len(lines) > 0 and lines[-1] == '':
                del lines[-1]

        with open(str(file), "w") as f:
            f.write('\n'.join(lines))


if