#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    width = 1024
    height = 768
    color_table_size = 7
    background_color_index = 0
    pixel_aspect_ratio = 0
    flags = 0b10000000 # global color table flag
    datalen = (width * height * 3) // 8
    data = rng.read(datalen)
    out.write(header + data)

