#!/usr/bin/env python3

import struct
from sys import argv, exit

if len(argv) != 2:
    print('Usage: %s <output>' % argv[0])
    exit(-1)

out = open(argv[1], 'wb')

# The header for a data block in an EEPROM image file
header = b'EEPROM'

# The data to write into the EEPROM image
data = bytes([i & 0xff for i in range(0x10000)])

with out:
    # Write the header and length of the data block
    out.write(header + len(data).to_bytes(3, 'big'))
    # Write the data block itself
    out.write(data)

