#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width = 1024
    height = 768
    color_table_size = 7
    background_color = 0xFF
    pixel_aspect_ratio = 0
    global_color_table_flag = 1
    sort_flag = 0
    color_resolution = 7
    has_global_color_table = 1
    interlaced = 0
    data = struct.pack('<6sHHBBB', header, width, height, color_table_size, background_color, pixel_aspect_ratio, global_color_table_flag | (sort_flag << 1) | (color_resolution << 2), has_global_color_table | (interlaced << 1))
    out.write(data)

