#!/usr/bin/env python3

import struct
from typing import BinaryIO

def main():
  with open('out.bin', 'wb') as out:
    with open('in.bin', 'rb') as rng:
      while True:
        write_block(rng, out)

def write_block(rng: BinaryIO, out: BinaryIO):
    # Read the header and data length
    header = rng.read(12)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    # Write the header and length of the data block
    out.write(header + len(data).to_bytes(3, 'big'))
    # Write the data block itself
    out.write(data)

