#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a\x01\x00\x01\x00\x00\xff\x00,\x00\x00\x00\x00\x01\x00;'
    data = bytearray()
    for i in range(256):
        data += struct.pack('<BBB', *[int.from_bytes(rng.read(1), 'big') for _ in range(3)])
    out.write(header + data)
