#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Aug 14 20:57:26 2020

@author: zhantao
"""
import numpy as np
from scipy.stats import norm, multivariate_normal
from matplotlib import pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from sklearn.datasets import make_blobs

def plot_gaussian(mean, cov):
    x = np.linspace(-10, 10, 100)
    y = np.linspace(-10, 10, 100)
    
    X, Y = np.meshgrid(x, y)
    pos = np.empty(X.shape + (2,))
    pos[:, :, 0] = X; pos[:, :, 1] = Y
    
    rv = multivariate_normal(mean=mean, cov=cov)
    Z = rv.pdf(pos)
    
    fig = plt.figure()
    ax = fig.add_subplot(projection='3d')
    surf = ax.plot_surface(X, Y, Z, cmap='viridis', edgecolor='none')
    ax.set_title('Gaussian Distribution')
    ax.view_init(elev=15., azim=-45.)
    return fig, ax

def plot_multivar_gaussian():
    mean = [0, 0]
    cov = [[1, 0], [0, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .9], [.9, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .5], [.5, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .3], [.3, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .1], [.1, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .05], [.05, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .01], [.01, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .001], [.001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .0001], [.0001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .00001], [.00001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .000001], [.000001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .0000001], [.0000001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .00000001], [.00000001, 1]]
    fig, ax = plot_gaussian(mean, cov)
    
    mean = [0, 0]
    cov = [[1, .000000001], [.00000000