#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = b'GIF89a'
    # 0x100 is arbitrary but should be enough to cover most cases
    for _ in range(0x100):
        datalen = int.from_bytes(
            rng.read(3), byteorder='big')

        if (datalen == 0):
            continue

        data = rng.read(datalen)

        blocktype = rng.read(1)[0] & 0b1111

        if blocktype == 0x2c or blocktype == 0x21:
            out.write(header + bytes([blocktype]) +
                      datalen.to_bytes(3, 'big'))

            out.write(data)


if