#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the given parameters.
def generate_gif(
    out: BinaryIO, width: int, height: int, color_depth: int = 8, loop_count=0
):

    # Header
    out.write("GIF89a".encode())

    # Logical screen descriptor
    out.write(struct.pack("<HHBBB", width, height, (color_depth - 1), 0, 0))

    # Global color table
    if color_depth == 8:
        for i in range(256):
            out.write(bytes([i]))

    # Image descriptor
    out.write(b"\x2C")
    out.write(struct.pack("<HHHHB", 0, 0, width, height, 0))

    # Local color table
    if color_depth == 8:
        for i in range(256):
            out.write(bytes([i]))

    # Graphic control extension
    out.write(b"\x21\xF9\x04")
    out.write(struct.pack("<BBBB", 0, 0, 0, 0))

    # Application extension
    out.write(b"\x21\xFF\x0BNETSCAPE2.0")
    out.write(b"!\x03NETSCAPE")
    out.write(b"\x00\x03\x01\x00")

    # Graphics control label
    out.write(b"\x21\xF9\x04")
    out.write(struct.pack("<BBBB", 0, 0, 0, 0))

    # Plain text data block
    out.write(b"\x21\x01\x00")

    # Trailer
    out.write(b";")


if