#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO, List


def read_u8(f: BinaryIO) -> int:
    return struct.unpack('B', f.read(1))[0]


def read_u16(f: BinaryIO) -> int:
    return struct.unpack('<H', f.read(2))[0]


def read_u32(f: BinaryIO) -> int:
    return struct.unpack('<I', f.read(4))[0]


def read_u64(f: BinaryIO) -> int:
    return struct.unpack('<Q', f.read(8))[0]


def write_u8(f: BinaryIO, val: int):
    f.write(struct.pack('B', val))


def write_u16(f: BinaryIO, val: int):
    f.write(struct.pack('<H', val))


def write_u32(f: BinaryIO, val: int):
    f.write(struct.pack('<I', val))


def write_u64(f: BinaryIO, val: int):
    f.write(struct.pack('<Q', val))


class