#!/usr/bin/env python3
import sys
import random

if __name__ == '__main__':
    if (len(sys.argv)!= 2):
        print("Usage: gif-generator <output file>")
        exit(-1)

    with open(sys.argv[1], "wb") as out:
        for i in range(0, 5):
            generate_gif(out)

def generate_gif(
        out,
        rng=random.Random()
        ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    # Write the header and length of the data block
    out.write(header + len(data).to_bytes(3, 'big'))
    # Write the data block itself
    out.write(data)

