#!/usr/bin/env python3

import os
import sys
import struct
from collections import namedtuple, OrderedDict


def read_file(filename):
    with open(filename, "rb") as f:
        return bytearray(f.read())


def write_file(filename, data):
    with open(filename, "wb") as f:
        f.write(data)


def align4(x):
    if x % 4!= 0:
        x += (4 - x % 4)

    assert x % 4 == 0
    return x


def align8(x):
    if x % 8!= 0:
        x += (8 - x % 8)

    assert x % 8 == 0
    return x


def align16(x):
    if x % 16!= 0:
        x += (16 - x % 16)

    assert x % 16 == 0
    return x


class