#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    # Write the header and length of the data
    out.write(header + len(data).to_bytes(
            3, byteorder='big'))

    # Write the color table (all black)
    for _ in range(256):
        out.write((0x00, 0x00, 0x00))

    # Write the data itself
    out.write(data)

