#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom by default)
def generate_random_gif(
        rng=None, out=sys.stdout.buffer
    ):
    if not rng:
        rng = os.urandom

    header = b'GIF89a'
    datalen = 1024 * 64 - 7
    data = rng(datalen)

    # Write the header and length of the data block
    out.write(header + len(data).to_bytes(3, 'big'))
    # Write the data block itself
    out.write(data)