#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # Generate the size of the data section
    datalen = 0x1000
    while True:
        if datalen > 2**24 - 1: break
        try:
            rng.seek(-datalen, 1)
            rng.read(datalen)
            break
        except OSError:
            datalen *= 2
    
    # Write the header and length of the data
    out.write(header + len(data).to_bytes(3, 'big'))
    # Write the data itself
    out.write(data)