#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # Write the header
    out.write(b'GIF89a')

    # Write the screen descriptor
    out.write(struct.pack('<HHBB', 100, 100, 0xff, 0))

    # Write the global color table
    out.write(bytes([0] * 768))

    # Write the application extension block
    out.write(b'\x21\xFF\x0BNETSCAPE2.0\x03\x01\x00\x00\x00')

    # Write the image descriptor
    out.write(b'\x2C\x00\x00\x00\x00\x00\x00\x00\x00\x00')

    # Write the local color table
    out.write(bytes([0] * 768))

    # Write the image data
    for _ in range(5):
        out.write(bytes([0] * 100))

    # Write the trailer
    out.write(b';')
