#!/usr/bin/env python3
import random
from struct import pack


def generate_random_gif(rng, out):
    width = rng.read(2)
    height = rng.read(2)
    pxsize = rng.read(1)[0]
    flags = rng.read(2)
    lctlen = rng.read(1)[0]

    # Header
    out.write(b'GIF89a')
    out.write(width)
    out.write(height)
    out.write(flags[0] + flags[1])
    out.write(lctlen)

    # Local color table
    for _ in range(lctlen):
        out.write(rng.read(1))

    # Image data
    for y in range(height):
        for x in range(width):
            out.write(rng.read(pxsize // 8))

    # Trailer
    out.write(b'\x3B')


if __name__ == '__main__':
    with open('/dev/urandom', 'rb') as rng:
        with open('./test.gif', 'wb') as f:
            generate_random_gif(rng, f)