#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(f: BinaryIO, size: int) -> None:
    f.write(b'GIF89a') # Header
    f.write(struct.pack('<H', 10)) # Logical screen width
    f.write(struct.pack('<H', 10)) # Logical screen height
    f.write(b'\xF0\x00') # Global color table flag + background color index
    f.write(b'\xFF\xFF\xFF') # Color table (white)
    f.write(b'\x2C\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01;') # Image descriptor
    for i in range(size):
        f.write(b'\x47\x49\x46\x38\x39\x61') # GIF header
        f.write(struct.pack('<H', 10)) # Logical screen width
        f.write(struct.pack('<H', 10)) # Logical screen height
        f.write(b'\xF0\x00') # Global color table flag + background color index
        f.write(b'\xFF\xFF\xFF') # Color table (white)
        f.write(b'\x2C\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01;') # Image descriptor
        f.write(b'\x44\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00