#!/usr/bin/env python3

import sys
import random
import struct

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print("Usage: {} <input-file>".format(sys.argv[0]))
        exit(-1)

    with open(sys.argv[1], "rb") as f:
        rng = random.Random()
        rng.seed(f.read())

    out = open("/dev/stdout", "wb")

    header = b'BM'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = bytes([rng.read(1)[0] for _ in range(datalen)])

    out.write(header + struct.pack('>H', len(data)))
    out.write(data)

