#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width = 1024
    height = 768
    color_table = [
        0xff0000, 0x00ff00, 0x0000ff, 0xffffff,
        0x000000, 0xff00ff, 0x00ffff, 0xffff00,
    ]
    # 1-byte version + 1-byte log2(width) + 1-byte log2(height)
    # + 1-byte background color index + 1-byte aspect ratio
    # + 1-byte global color table flag (0b10000000) + 1-byte color table size
    # + 1-byte color resolution + 1-byte sort flag + 1-byte size of global color table
    # + 1-byte background color index + 1-byte pixel aspect ratio
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte color table size + 1-byte color table size
    # + 1-byte