#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom or /dev/urandom).
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # Write header
    out.write(b'GIF89a')

    # Write screen descriptor
    buf = b'\x01\x00\x01\x00\x00\xff\x00\x00\x00!'
    out.write(buf)

    # Write global color table
    for i in range(256):
        out.write(struct.pack('BBB', i, 0, 0))

    # Write graphic control extension
    buf = b'\x21\xf9\x04\x01\x00\x00\x00\x00'
        out.write(buf)

