#!/usr/bin/env python3
import sys
from typing import BinaryIO, Optional


def main(argv: list[str] = sys.argv) -> int:
    if len(argv) < 2 or argv[1].lower() in ("-h", "--help"):
        print("Usage: {} FILE".format(argv[0]))
        return 64

    with open(argv[1], "rb") as f:
        data = bytearray(f.read())

        # Remove the first two bytes (the header).
        del data[:2]

        # Find the last occurrence of a zero byte and remove it.
        i = -1
        while True:
            try:
                i = data.rindex(b"\x00", i + 1)
            except ValueError:
                break

            del data[i : i + 1]

        # Write the new file to stdout.
        sys.stdout.buffer.write(data)

    return 0


if