#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG object.
def generate(
        rng: BinaryIO,
        out: BinaryIO
        ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = bytes([rng.read(1)[0] for _ in range(datalen)])

    out.write(header + struct.pack('>H', len(data)))
    out.write(data)

