#!/usr/bin/env python3
import sys
from typing import BinaryIO

# Generates a random GIF file into `out` using the given width and height.
def generate_random(width: int, height: int, out: BinaryIO):
    # Header
    out.write(b'GIF89a')

    # Logical screen descriptor (10 bytes)
    out.write(bytes([
        width % 256,
        width // 256,
        height % 256,
        height // 256,
        0x87,  # Global color table flag set to true with 256 colors
        0x00,  # Background color index
        0x00,  # Pixel aspect ratio - assume square pixels
    ]))

    # Color table (256 * 3 = 768 bytes)
    for i in range(256):
        out.write(bytes([
            i,
            0x00,
            0x00,
        ]))

    # Image descriptor (10 bytes)
    out.write(bytes([
        0x2C,  # Image separator
        width % 256,
        width // 256,
        height % 256,
        height // 256,
        0x00,   # No local color table
        0x00,   # LZW minimum code size
        0x00,   # Left position of image data
        0x00,   # Top position of image data
        0x00,   # Width of image block
        0x00,   # Height of image block
    ]))

    # Image data (width * height bytes)
    for _ in range(height):
        for _ in range(width):
            out.write(bytes([
                ord(' '),
                0xFF,
                0x00,
            ]))


if