#!/usr/bin/env python3

import struct
from typing import BinaryIO

def read_uint16(f: BinaryIO):
    return int.from_bytes(f.read(2), byteorder="little")

with open("data/font.bin", "rb") as f, \
     open("data/font.h",   "wb") as h, \
     open("data/font.c",   "wb") as c:

    header = b""
    for i in range(0x80):
        if (i % 16 == 0 and i!= 0):
            h.write(b"\n")

        glyph = bytes([read_uint16(f)]) * 4
        header += struct.pack("<H", len(glyph))
        c.write(struct.pack("<B", len(glyph)))
        c.write(glyph)

    # Write the font to a file
    with open("data/font.raw", "wb") as out:
        out.write(header + data)
