#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(b'\x01\x02', byteorder='big') << 8 | \
              int.from_bytes(
                  rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
