#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), byteorder='big', signed=False
        )

    # Write header and length of data block to output
    out.write(header + len(datalen).to_bytes(2, 'big'))

    # Write data block to output
    for _ in range(0, datalen):
        out.write(rng.read(1))

