#!/usr/bin/env python3

import struct
import sys


with open(sys.argv[1], 'rb') as f:
    rng = f.read()

out = open('out.png', 'wb')
while len(rng):
    header = rng[:8]
    rng = rng[8:]
    # packed field of color resolution (bits per pixel)
    r = rng.read(1)[0] & 7
    g = rng.read(1)[0] & 7
    b = rng.read(1)[0] & 7
    packed = bytes([r | (g << 3) | (b << 6)])

    # background color index
    bg = rng.read(1)[0]

    # aspect ratio
    ar = rng.read(1)[0] & 0xf

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + data)
