#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' + bytes([
        0x12, 0x34, # width and height
        0xf7,        # flags (global color table)
        0x0b,        # background index
        0x00,        # pixel aspect ratio
    ])

    palette = [struct.pack('BBB', *rng.randint(0, 256, size=3)) for _ in range(256)]
    data = bytearray()
    while len(data) < 2**16 - 1:
        data += struct.pack('<H', rng.randint(0, 2**16-1))
    data[-1] = 0xff

    out.write(header)
    out.write(bytes(palette))
    out.write(data)

