#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'big')

    # Write the header and the length of the data field
    out.write(header + datalen.to_bytes(2, 'big'))

    # Read in the rest of the bytes from /dev/urandom
    while True:
        chunk = rng.read(1024)

        if len(chunk) == 0:
            break

        out.write(chunk)

