#!/usr/bin/env python3

import struct
from typing import BinaryIO

def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width = 1024
    height = 768

    # Logical screen descriptor
    out.write(struct.pack('<6sHHBBB', *([b'']*6+[width,height])))

    # Global color table (black and white only)
    out.write(bytes([0x02, 0xff, 0x00, 0xff]))

    # Image descriptor
    out.write(struct.pack('<BHHHHBB', 0x2c, 0, 0, width, height, 0, 0))

    # LZW minimum code size
    out.write(b'\x02')

    # Image data
    datalen = int((width / 8) * height)
    data = rng.read(datalen)
    out.write(header + data)
