#!/usr/bin/env python3
import sys
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (stdin by default).
def generate_random_gif(
        rng: BinaryIO=sys.stdin.buffer, out: BinaryIO=sys.stdout.buffer
    ):
    header = b'GIF89a'

    # Read the length of the image data from stdin
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')

    # Write the header and the image data to stdout
    out.write(header + rng.read(datalen))
