#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (or /dev/urandom if not specified).
def generate_random_gif(
        rng: BinaryIO=None, out: BinaryIO=sys.stdout.buffer
    ):
    # If no RNG is given, use /dev/urandom instead
    if rng == None:
        rng = open('/dev/urandom', 'rb')

    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)

    out.write(header + data)
