#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

def main(argv: list[str]) -> int:
    if len(argv) != 2:
        print('Usage: {} <file>'.format(argv[0]), file=sys.stderr)
        return 1
    
    with open(argv[1], 'rb') as fp:
        data = fp.read()
        
    #print(data)
    
    i = 0
    while i < len(data):
        length, = struct.unpack_from('<I', data, i)
        i += 4
        print('{:08x} {:08x}'.format(i - 4, length))
        i += length
