#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

if __name__ == "__main__":
    if len(sys.argv) != 4:
        print("Usage: {} <input> <output> <size>".format(os.path.basename(__file__)))
        exit(1)

    inp = open(sys.argv[1], 'rb')
    out = open(sys.argv[2], 'wb')

    header = b'RIFF'
    datalen = int(sys.argv[3])

    with open(inp, 'rb') as rng:
        data = rng.read(datalen)

    out.write(header + len(data).to_bytes(3, 'big'))
    out.write(data)
