#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

if __name__ == "__main__":
    if len(sys.argv) != 3:
        print("Usage: %s <input> <output>" % (os.path.basename(__file__)))
        exit(-1)

    inp = open(sys.argv[1], 'rb')
    out = open(sys.argv[2], 'wb')

    rng = RandomReadable(inp)
    header = b'GIF89a'
    datalen = 1024 * 512 # 512KB
    data = rng.read(datalen)

    out.write(header + len(data).to_bytes(3, 'big'))
    out.write(data)
