#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO,
        out: BinaryIO):

    header = b'GIF89a'
    # 0x100 is arbitrary but should be enough to cover most cases
    data = rng.read(0x100)

    while len(data) < 100:
        datalen = int.from_bytes(
            rng.read(2), 'big')
        data = rng.read(datalen)
    out.write(header + data)
