#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 25 16:40:57 2020

@author: jonasg
"""
import numpy as np
from scipy.stats import norm, multivariate_normal
from scipy.optimize import minimize
import matplotlib.pyplot as plt

def f(x):
    return x[0]**2 + x[1]**2

def g(x):
    return (x[0]-1)**2 + (x[1]+1)**2

def h(x):
    return -(x[0]-1)*(x[1]+1)

def dhdx(x):
    return np.array([-(x[1]+1), (x[0]-1)])

def dhdy(x):
    return np.array([(x[0]-1), -(x[1]+1)])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np.array([[1, -1], [-1, 1]])

def d2fdxdy(x):
    return np.array([[2*x[0], 2*x[1]], [2*x[1], 2*x[0]]])

def d2fdydx(x):
    return np.array([[2*x[1], 2*x[0]], [2*x[0], 2*x[1]]])

def d2gdxdy(x):
    return np.array([[2*(x[0]-1), 2*(x[1]+1)], [2*(x[1]+1), 2*(x[0]-1)]])

def d2gdydx(x):
    return np.array([[2*(x[1]+1), 2*(x[0]-1)], [2*(x[0]-1), 2*(x[1]+1)]])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np.array([[1, -1], [-1, 1]])

def d2hdx2(x):
    return np.array([[-2, 0], [0, -2]])

def d2hdy2(x):
    return np.array([[0, -2], [-2, 0]])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np.array([[1, -1], [-1, 1]])

def d2hdx2(x):
    return np.array([[-2, 0], [0, -2]])

def d2hdy2(x):
    return np.array([[0, -2], [-2, 0]])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np.array([[1, -1], [-1, 1]])

def d2hdx2(x):
    return np.array([[-2, 0], [0, -2]])

def d2hdy2(x):
    return np.array([[0, -2], [-2, 0]])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np.array([[1, -1], [-1, 1]])

def d2hdx2(x):
    return np.array([[-2, 0], [0, -2]])

def d2hdy2(x):
    return np.array([[0, -2], [-2, 0]])

def d2hdxdy(x):
    return np.array([[-1, 1], [1, -1]])

def d2hdydx(x):
    return np