#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'\x47\x49\x46\x38\x39\x61' # GIF89a
    data = rng.read(1024 * 1024)
    out.write(header + len(data).to_bytes(3, 'big'))
    out.write(data)
