#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom).
# The size of the output is determined by the first 10 bytes read from `rng`.
def generate_random_gif(out: BinaryIO, rng: BinaryIO) -> None:
    # Read the header.
    header = rng.read(6)

    # Write the header to out.
    out.write(header)

    # Read the rest of the header and write it to out.
    while True:
        chunk_size = int.from_bytes(rng.read(1), byteorder="big")

        if chunk_size == 0x00:
            break

        elif chunk_size > 0x00:
            data = rng.read(chunk_size)

            out.write(data)

            if len(data) < chunk_size:
                break


if