#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

if __name__ == '__main__':
    if len(sys.argv)!= 4:
        print("Usage: {} <input> <output> <seed>".format(os.path.basename(__file__)))
        exit(-1)

    with open(sys.argv[1], 'rb') as f, \
         open(sys.argv[2], 'wb+') as out, \
         open(sys.argv[3], 'rb') as seed_f:

        width, height = struct.unpack('<HH', f.read(4))
        rng = Random(seed=int.from_bytes(seed_f.read(), byteorder='little'))

        for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))