#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # Generate the header and data blocks
    header = b'GIF89a\x01\x00\x01\x00\xf0\x01\x00\xff\xff\xff\x00,\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02D\x01\x00;'
    data = bytearray()

    for i in range(64 * 64 // 256):
        data += bytes([rng.read(1)[0] ^ (i + 1)])

    # Write the header
    out.write(header)
    # Write the data block itself
    out.write(data)

