#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the given parameters.
def generate_gif(
    out: BinaryIO, width: int = 1024, height: int = 768, delay: int = 50
):
    # Header
    out.write("GIF89a".encode())

    # Logical screen descriptor
    out.write(struct.pack("<HHBBB", width, height, 0xF0, 0x00, 0x00))

    # Global color table (black)
    for _ in range(0xFF + 1):
        out.write(b"\x00\x00\x00")

    # Image descriptor
    out.write(struct.pack("<HHHHB", 0, 0, width, height, 0x00))

    # Local color table (black)
    for _ in range(0xFF + 1):
        out.write(b"\x00\x00\x00")

    # Graphic control extension
    out.write(struct.pack("<BBHBB", 0x21, 0xF9, 4, 0b00001111, delay))

    # Image data
    for y in range(height):
        for x in range(width // 8):
            out.write((y % 2 * 0xAA).to_bytes(1, "little"))


if