#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the given parameters.
def generate(out: BinaryIO, width: int = 1024, height: int = 768):
    # Header
    out.write(b'GIF89a')

    # Logical Screen Descriptor
    out.write(struct.pack('<HHBBB', width, height, 0xf0 | ((width >> 8) & 0x0f), (height >> 8) & 0xff, 0))

    # Global Color Table
    for i in range(0, 256 * 3, 3):
        out.write(bytes([i // 3 % 256]))

    # Image Descriptor
    out.write(struct.pack('<BHHBBBBBHB', 0x2c, 0, 0, 0, 0, 0, 0, 0, 0, 0))

    # Local Color Table
    for i in range(0, 256 * 3, 3):
        out.write(bytes([i // 3 % 256]))

    # Image Data
    data_size = width * height
    out.write(bytes([(data_size >> 8) & 0xff, data_size & 0xff]) + bytes([0] * data_size))


if