#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 1024 * 512 # 512KB
    data = rng.read(datalen)

#    print('header', len(header))
#    print('data', len(data))

    out.write(header + struct.pack('<HHH', 640, 480, 0xf7))
    while True:
        chunklen = min(datalen, 255)

        if not data or chunklen == 0:
            break
        
        out.write(bytes([chunklen]) + data[:chunklen])
        data = data[chunklen:]


if