#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom).
# The size of the output is determined by the first 10 bytes read from `rng`.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # Read the header and determine the length of the image data
    header = b'GIF89a' + rng.read(7)
    width, height = struct.unpack('<HH', header[6:10])

    # Write the header to the output
    out.write(header)

    # Generate each pixel as an RGB triple
    for y in range(height):
        for x in range(width):
            r = rng.read(1)[0] % 256
            g = rng.read(1)[0] % 256
            b = rng.read(1)[0] % 256

            out.write(struct.pack('BBB', r, g, b))


if