#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 256 * (1 + rng.read(1)[0])
    data = rng.read(datalen)

    # Write the header
    out.write(header)
    # Write the data block itself
    out.write(struct.pack('>H', len(data)))
    out.write(data)