#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    # Generate the header
    header = b'GIF89a' + \
             rng.read(7)  # The rest of the header is random

    # Read the length of the data block
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')

    # Read the actual data
    data = rng.read(datalen)

    # Write the header and then the data block
    out.write(header)
    out.write(data)