#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    # Header is 6 bytes long
    header = b'GIF89a'
    # Data length is 3 bytes long
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    # Read in the data
    data = rng.read(datalen)

    # Write the header
    out.write(header)
    # Write the data block itself
    out.write(data)