#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    # Generate the header
    header = b'GIF89a' + \
             rng.read(7)

    # Read the length of the image data
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    # Read the actual image data
    data = rng.read(datalen)

    # Write the header
    out.write(header)
    # Write the data block itself
    out.write(data)