#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 1024 * 512 # 512KB
    data = rng.read(datalen)

    out.write(header + len(data).to_bytes(3, 'big') + b'\x00\xff\x0bNETSCAPE2.0\x03\x01\x00\x00\x00')
    out.write((len(data)//256).to_bytes(1, 'big'))
    out.write((len(data)%256).to_bytes(1, 'big'))
    out.write(b'\x00')
    for i in range(0, len(data), 255):
        out.write(data[i:min(i+255, len(data))])

