#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom).
# The size of the output is determined by `size`.
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO, size: int):
    header = b'GIF89a'
    datalen = size - len(header)
    data = rng.read(datalen)

    # Write the header
    out.write(header)
    # Write the data block itself
    out.write(data)

