#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:
    header = b'GIF89a'
    datalen = 0x10000

    while True:
        chunklen = min(datalen, 256 * 1024)

        if not chunklen: break

        # Write the header and length of the data block
        out.write(header + chunklen.to_bytes(3, 'big'))
        # Write the data block itself
        out.write(rng.read(chunklen))

