#!/usr/bin/env python3

import struct
from typing import BinaryIO

from . import (
    _read_int,
    _write_int,
)


def read(file: BinaryIO):
    return {
        'n': _read_int(file),
        'm': _read_int(file),
        'a': [None] * _read_int(file),
        'b': [None] * _read_int(file),
    }


def write(data: dict, file: BinaryIO):
    _write_int(len(data['a']), file)
    _write_int(len(data['b']), file)
    for i in range(len(data['a'])):
        _write_int(data['a'][i], file)
    for i in range(len(data['b'])):
        _write_int(data['b'][i], file)


def parse(s: str):
    n, m = map(int, s.split())
    a = list(map(int, input().split()))
    b = list(map(int, input().split()))
    return {
        'n': n,
        'm': m,
        'a': a,
        'b': b,
    }


def main():
    data = read(sys.stdin.buffer)
    print(data['n'])
    print(data['m'])
    for x in data['a']:
        print(x, end=' ')
    print()
    for y in data['b']:
        print(y, end=' ')
