#!/usr/bin/env python3
import sys
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(out: BinaryIO, rng: BinaryIO):
    # Header
    out.write(b'GIF89a')
    
    # Logical Screen Descriptor
    out.write(b'\x01\x00\x01\x00\x80\xff\x00\x00\x00!')
    
    # Graphic Control Extension
    out.write(b'\x21\xf9\x04\x01\x00\x00\x00\x00\x00')
    
    # Image Descriptor
    out.write(b'\x2c\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02\x44\x01\x00;')
    
    # Image Data
    for i in range(768):
        out.write(bytes([int.from_bytes(rng.read(1), 'big')]))
