#!/usr/bin/env python3

import struct
from typing import BinaryIO

with open('data.dat', 'rb') as f:
    with open('out.dat', 'wb') as o:
        process(f, o)

def process(rng: BinaryIO, out: BinaryIO):
    header = rng.read(4)
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + datalen.to_bytes(3, 'big') + data)
