#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big') + 1
    data = rng.read(datalen)
    trailer = b'\x3b'

    out.write(header)
    out.write(struct.pack('<H', 20)) # width
    out.write(struct.pack('<H', 20)) # height
    out.write(b'\x87\xff\x00')      # color map
    out.write(data)
    out.write(trailer)
