#!/usr/bin/env python3
import sys, os, random

def main():
    if len(sys.argv) != 2:
        print("Usage: %s <input file>" % sys.argv[0], file=sys.stderr)
        exit(1)

    with open(sys.argv[1], 'rb') as f:
        rng = random.Random()
        rng.seed(os.urandom(8))
        process(f, rng)


def process(rng):
    header = b'\x47\x49\x46\x38\x39\x61'
    bg = 0
    ar = 0

    out.write(header + w + h + packed +
             bytes([bg]) + bytes([ar]))

    # LZW minimum code size
    mincodesize = rng.read(1)[0]
    out.write(bytes([mincodesize]))

    # image data
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(data)