#!/usr/bin/env python3

import os
import sys
from PIL import Image, ImageDraw, ImageFont

# Create a new image with white background.
im = Image.new('RGB', (128, 128), color=(255, 255, 255))
draw = ImageDraw.Draw(im)
font = ImageFont.truetype('/usr/share/fonts/truetype/dejavu/DejaVuSansMono-Bold.ttf', 24)

# Draw the text in the center of the image.
w, h = draw.textsize("Hello World!")
draw.text(((128 - w) / 2, (128 - h) / 2), "Hello World!", font=font)

# Write the image as a PNG file to stdout.
with open("/dev/stdin", "rb") as rng, open("/dev/stdout", "wb") as out:
    # Copy the image data from the input stream to the output stream.
    while True:
        buf = rng.read(4096)
        if not buf: break
        out.write(buf)
