#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

def main():
    if len(sys.argv) < 2:
        print("Usage: {} <file>".format(os.path.basename(__file__)))
        return
    
    with open(sys.argv[1], "rb") as f:
        while True:
            data = f.read(4)
            if not data:
                break
            
            val, = struct.unpack("<I", data)
            print("{:08x}".format(val))
