#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Open a file in binary mode for writing
with open('image.dat', 'wb') as out:
    # Create a new RNG object with a seed of 0x123456789ABCDEF
    rng = Random(0x123456789ABCDEF)

    # Write the magic number (in big-endian format)
    out.write(struct.pack('>I', 0xDEADBEEF))

    # Write the width and height (again, in big-endian format)
    out.write(struct.pack('>HH', 1024, 768))

    # Write the length of the image data
    datalen = 1024 * 768 * 4
    out.write(datalen.to_bytes(3, 'big'))

    # Generate some random bytes for the image data itself
    # and write them to the output stream
    data = rng.read(datalen)
    out.write(data)