#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom or /dev/urandom).
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # Write the header.
    out.write(b'GIF89a')
    
    # Write the screen descriptor.
    buf = bytearray([0x21, 0xf9, 0x04])
    buf += b'\xff\xff\xff\xff'
    buf += b'\x00\x00\x00\x00'
    buf += b'\xff\xff\xff\xff'
    buf += b'\x00'
        out.write(buf)
