#!/usr/bin/env python3

import os, sys, re
from pathlib import Path


def main():
    if len(sys.argv) < 2:
        print("Usage: {} [path]".format(os.path.basename(__file__)))
        return

    path = sys.argv[1]
    for file in Path(path).glob('**/*.py'):
        if not str(file).startswith('./venv') and not str(file).startswith('./build'):
            with open(str(file), 'r+') as f:
                content = f.read()

                # Remove all comments from the file
                content = re.sub(re.compile("#.*?\n"), "", content)

                # Remove all empty lines from the file
                content = re.sub(re.compile("\n\s*\n"), "\n", content)

                # Remove trailing whitespace characters
                content = re.sub(re.compile("[ \t]+\n"), "\n", content)

                # Replace multiple newlines by only one newline
                content = re.sub(re.compile("\n{3,}"), "\n\n", content)

                # Remove empty lines at the beginning of the file
                content = re.sub(re.compile("^[\n]*"), "", content)

                # Remove empty lines at the end of the file
                content = re.sub(re.compile("[\n]*$"), "", content)

                # Write back to the file
                f.seek(0)
                f.write(content)
                f.truncate()


if