#!/usr/bin/env python3

import struct
from sys import argv, stdout


def read_file(filename):
    with open(filename, "rb") as f:
        return bytearray(f.read())


if __name__ == "__main__":

    if len(argv)!= 4:
        print("Usage: {} <input> <output> <size>".format(argv[0]))
        exit(-1)

    data = read_file(argv[1])
    size = int(argv[3], base=0)

    trailer = b""
    while len(trailer) < (size - len(data)):
        trailer += bytes([len(trailer)]) + b"\x00" * 7

    header = struct.pack("<2sI", b"MZ", len(data))
    trailer = struct.pack("<2sI", b"MZ", len(trailer))

    out = open(argv[2], "wb")
    out.write(header)
    out.write(data)
    out.write(trailer)
