#!/usr/bin/env python3
import struct


def main(
        *,
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'big') + 1
    data = rng.read(datalen)
    trailer = b'\x3b'
    out.write(header)
    out.write(struct.pack('<H', datalen))
    out.write(data)
    out.write(trailer)
