#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Dec  4 15:48:25 2020

@author: <NAME>
"""


def gif_encode(
        in_: str, out: str
    ) -> None:
    with open(in_, mode='rb') as f:
        rng = f.read()
    with open(out, mode='wb+') as f:
        encode(rng, f)


def encode(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # 16-bit width and height
    w = rng.read(2)
    h = rng.read(2)

    # packed field of color resolution (bits per pixel)
    r = rng.read(1)[0] & 7
    g = rng.read(1)[0] & 7
    b = rng.read(1)[0] & 7
    packed = bytes([r | (g << 3) | (b << 6)])

    # background color index
    bg = rng.read(1)[0]

    # aspect ratio
    ar = rng.read(1)[0] & 0xf

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + w + h + packed + bg.to_bytes(1, 'little'))
    out.write(ar.to_bytes(1, 'little'))
    out.write(data)