#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom or /dev/urandom).
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # Write the magic string and version number to the output stream.
    out.write(b'GIF89a')

    # Generate a 16-bit integer with the length of the image data.
    datalen = struct.pack('>H', int.from_bytes(
            rng.read(2), byteorder='big'))

    # Write the image header to the output stream.
    out.write(datalen)
    out.write(b'\x00\x00')
    out.write(b'\x00\xf0')
    out.write(b'\x00\x00')

    # Write the image data to the output stream.
    for _ in range(int.from_bytes(datalen, byteorder='big')):
        out.write(rng.read(1))


if