#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # Write the header
    out.write(b'GIF89a')

    # Generate some random bytes for the length of the image data
    # and write them to the output stream
    img_data = bytearray()
    while True:

        # Get a random byte from /dev/urandom
        b = int.from_bytes(rng.read(1), 'big', signed=False)

        if 0 <= b < 256:
            break

        img_data += b.to_bytes(1, 'big')

    out.write(img_data)

