#!/usr/bin/env python3

import sys
import random

if __name__ == '__main__':
    if len(sys.argv)!= 4:
        print('Usage:', sys.argv[0], '<input file> <output file>',
                '<seed>')
        exit()

    inpath = sys.argv[1]
    outpath = sys.argv[2]
    seed = int(sys.argv[3])

    with open(inpath, 'rb') as f:
        header = f.read(16)

    with open(outpath, 'wb') as out:
        rng = random.Random(seed)

        # width and height
        w = rng.read(2)
    h = rng.read(2)

    # packed field of color resolution (bits per pixel)
    r = rng.read(1)[0] & 7
    g = rng.read(1)[0] & 7
    b = rng.read(1)[0] & 7
    packed = bytes([r | (g << 3) | (b << 6)])

    # background color index
    bg = rng.read(1)[0]

    # aspect ratio
    ar = rng.read(1)[0] & 0xf

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + w + h + packed + bg.to_bytes(1, 'little'))
    out.write(ar.to_bytes(1, 'little'))
    out.write(data)