#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# given RNG and size.
def generate_gif(rng: BinaryIO, width: int, height: int, out: BinaryIO):

    # Write the header.
    out.write(b'GIF89a')
    out.write(struct.pack('<HH', width, height))
    # Copy the image data from the input stream to the output stream.
    while True:
        buf = rng.read(4096)
        if not buf: break
        out.write(buf)
