#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'

    # Generate 100 bytes of data for our image
    data = bytearray()
    for _ in range(100):
        data += struct.pack('B', int.from_bytes(rng.read(1), 'little') % 256)

    # Write the header and length of the data to the output stream
    out.write(header + len(data).to_bytes(2, 'big'))
    # Write the data itself
    out.write(data)

