#!/usr/bin/env python3

import struct
from typing import BinaryIO

def read_rng(rng: BinaryIO):
    header = rng.read(4)

    w = rng.read(2)
    h = rng.read(2)

    # packed field of color resolution (bits per pixel)
    r = rng.read(1)[0] & 7
    g = rng.read(1)[0] & 7
    b = rng.read(1)[0] & 7
    packed = bytes([r | (g << 3) | (b << 6)])

    # background color index
    bg = rng.read(1)[0]

    # aspect ratio
    ar = rng.read(1)[0] & 0xf

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + w + h + packed + bg.to_bytes(1, 'little'))
    out.write(ar.to_bytes(1, 'little'))
    out.write(data)