#!/usr/bin/env python3

import sys
import random

if __name__ == '__main__':
    if len(sys.argv)!= 2:
        print('Usage:', sys.argv[0], '<output>')
        exit()
    
    with open('/dev/random', 'rb') as rng:
        with open(sys.argv[1], 'wb') as out:
            main(rng, out)

def main(rng, out):
    header = b'\x89\x50\x4e\x47\x0d\x0a\x1a\x0a'
    w = (64 * 8).to_bytes(2, 'little')
    h = (64 * 8).to_bytes(2, 'little')
    packed = b'\x08\x00'
    bg = random.randint(0, 255)
    # aspect ratio
    ar = rng.read(1)[0] & 0xf

    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + w + h + packed + bg.to_bytes(1, 'little'))
    out.write(ar.to_bytes(1, 'little'))
    out.write(data)