#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Generate a 16-bit integer for the size of the data section
    datalen = int.from_bytes(
            rng.read(2), byteorder='big', signed=False
        )
    # Read in that many bytes from /dev/urandom
    data = rng.read(datalen)

    # Write the header and length of the data to the output
    out.write(b'GIF89a')
    out.write(len(data).to_bytes(2, 'big'))
    # Write the data itself
    out.write(data)