#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (stdin by default).
def generate_random_gif(
        rng: BinaryIO=None, out: BinaryIO=None
    ):

    if not rng:
        from sys import stdin as rng
    if not out:
        from sys import stdout as out

    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'big') + 1
    data = rng.read(datalen)
    trailer = b'\x3b'
    out.write(header)
    out.write(struct.pack('<H', datalen))
    out.write(data)
    out.write(trailer)

