#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 1024 * (int.from_bytes(
            rng.read(2), byteorder='big', signed=False
        ) % 512)
    data = rng.read(datalen)

    # Write the header and length of the data to the output
    out.write(header + len(data).to_bytes(2, 'big'))
    # Write the data itself
    out.write(data)