#!/usr/bin/env python3

import sys
from collections import defaultdict, Counter

def parse_input(filename):
    with open(filename) as f:
        return [line.strip() for line in f]

def part1(lines):
    counter = Counter(lines[0])
    gamma = ''
    epsilon = ''
    for i in range(len(counter)):
        if counter['0'] > counter['1']:
            gamma += '0'
            epsilon += '1'
        else:
            gamma += '1'
            epsilon += '0'
    return int(gamma, 2) * int(epsilon, 2)

def part2(lines):
    oxygen = lines[:]
    co2 = lines[:]
    for i in range(len(oxygen[0])):
        if len(oxygen) == 1: break
        counter = Counter([l[i] for l in oxygen])
        if counter['0'] >= counter['1']:
            oxygen = [l for l in oxygen if l[i] == '0']
        else:
            oxygen = [l for l in oxygen if l[i] == '1']
    
    for i in range(len(co2[0])):
        if len(co2) == 1: break
        counter = Counter([l[i] for l in co2])
        if counter['0'] <= counter['1']:
            co2 = [l for l in co2 if l[i] == '0']
        else:
            co2 = [l for l in co2 if l[i] == '1']
    
    return int(oxygen[0], 2) * int(co2[0], 2)
