#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO


# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
    rng: BinaryIO,
    out: BinaryIO,
):
    # Write header
    out.write(struct.pack("!6s", b"GIF89a"))

    # Write screen descriptor
    width = 1024
    height = 768
    background_color = 0xFF
    pixel_aspect_ratio = 0
    out.write(struct.pack("<HHBB", width, height, background_color, pixel_aspect_ratio))

    # Write global color table
    for i in range(0, 256):
        out.write(struct.pack("BBB", i, i, i))

    # Write application extension block
    out.write(struct.pack("!H", 0xfffe))
    out.write(struct.pack("!H", 0x0b))
    out.write(struct.pack("!H", 0x0001))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0xffff))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
    out.write(struct.pack("!H", 0x0000))
   

if __name__ == '__main__':
    with open('/dev/urandom', 'rb') as rng:
        with open('./flag.gif', 'wb+') as out:
            generate_random_gif(rng, out)

