#!/usr/bin/env python3

import os
import sys
from pathlib import Path
import argparse
import subprocess as sp
import shutil
import logging
import re
import tempfile
import json
import time
import datetime
import hashlib
import random
import string
import urllib.request
import zipfile
import tarfile
import gzip
import bz2
import uuid
import pkg_resources
import requests
import yaml

# from . import __version__ as version
from . import __version__ as version
from . import __name__ as name
from . import __description__ as description
from . import __author__ as author
from . import __email__ as email

logging.basicConfig(level=logging.INFO)
logger = logging.getLogger(__name__)


def get_parser():
    parser = argparse.ArgumentParser()
    parser.add_argument("--version", action="store_true")
    return parser


def main():
    args = get_parser().parse_args()
    if args.version:
        print(f"{name} {version}")
        exit(0)
    else:
        print(f"{name} {version}")
        print(description)
        print(f"Author: {author}, {email}")
        exit(-1)

