#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom).
def generate_gif(out: BinaryIO, rng: BinaryIO):
    # Header
    out.write(b'GIF89a')
    out.write(struct.pack('<H', 100))
    out.write(struct.pack('<H', 100))
    out.write(b'\xF7\xFF\x0B\x00')
    
    # Image data
    datalen = 4 * 100 * 100
    while datalen > 0:
        chunklen = min(256, datalen)
        out.write(rng.read(chunklen))
        datalen -= chunklen
