#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO, Optional, List, Tuple

def read_file(filename: str) -> bytes:
    with open(filename, "rb") as f:
        return f.read()

def write_file(filename: str, data: bytes):
    with open(filename, "wb") as f:
        f.write(data)

def get_file_size(f: BinaryIO) -> int:
    cur = f.tell()
    f.seek(0, 2) # seek to end of file
    size = f.tell()
    f.seek(cur, 0)
    return size

def get_file_size_str(f: BinaryIO) -> str:
    size = get_file_size(f)
    if size < 1024:
        return "%d B" % (size, )
    elif size < 1024 * 1024:
        return "%.2f KiB" % (size / 1024, )
    else:
        return "%.2f MiB" % (size / 1024 / 1024, )
