#!/usr/bin/env python3

import os
import sys
from pathlib import Path
import argparse
import subprocess
import shutil
import re
import json
import time
import datetime
import logging
import tempfile
import glob
import math
import random
import string
import hashlib
import uuid
import base64
import urllib.request, urllib.error, urllib.parse
import requests
import xml.etree.ElementTree as ET
import yaml
import pytz
import dateutil.parser
import boto3
import botocore
import botocore.exceptions
import botocore.session
import botocore.configloader
import botocore.credentials
import botocore.utils
import botocore.auth
import botocore.awsrequest
import botocore.parsers
import botocore.paginate
import botocore.hooks
import botocore.regions
import botocore.client
import botocore.waiter
import botocore.history
import botocore.model
import botocore.signers
import botocore.translate
import botocore.endpoint
import botocore.loaders
import botocore.docs.bcdoc
import botocore.docs.bcdoc.restdoc
import botocore.docs.bcdoc.resource
import botocore.docs.bcdoc.docstring
import botocore.docs.bcdoc.example
import botocore.docs.bcdoc.methodpage
import botocore.docs.bcdoc.servicepage
import botocore.docs.bcdoc.indexpage
import botocore.docs.bcdoc.parameter
import botocore.docs.bcdoc.response
import botocore.docs.bcdoc.paginator
import botocore.docs.bcdoc.paginatorpage
import botocore.docs.bcdoc.waiterpage
import botocore.docs.bcdoc.waiter
import botocore.docs.bcdoc.shape
import botocore.docs.bcdoc.shapename
import botocore.docs.bcdoc.shapepage
import botocore.docs.bcdoc.listing
import botocore.docs.bcdoc.operation
import botocore.docs.bcdoc.section
import botocore.docs.bcdoc.topics
import botocore.docs.bcdoc.eventstreams
import botocore.docs.bcdoc.eventstreams.event
import botocore.docs.bcdoc.eventstreams.structure
import botocore.docs.bcdoc.eventstreams.member
import botocore.docs.bcdoc.eventstreams.eventpage
import botocore.docs.bcdoc.eventstreams.structurepage
import botocore.docs.bcdoc.eventstreams.memberpage
import botocore.docs.bcdoc.eventstreams.eventstreamspage
import botocore.docs.bcdoc.eventstreams.eventstreamsindex
import botocore.docs.bcdoc.eventstreams.eventstreamsindexpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindex
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindexpage
import botocore.docs.bcdoc.eventstreams.eventstreamslanding
import botocore.docs.bcdoc.eventstreams.eventstreamslandingpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindexpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindex
import botocore.docs.bcdoc.eventstreams.eventstreamslanding
import botocore.docs.bcdoc.eventstreams.eventstreamslandingpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindexpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindex
import botocore.docs.bcdoc.eventstreams.eventstreamslanding
import botocore.docs.bcdoc.eventstreams.eventstreamslandingpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindexpage
import botocore.docs.bcdoc.eventstreams.eventstreamslandingindex
import botoc