#!/usr/bin/env python3

import os
import sys
import struct
from random import SystemRandom


def main():
    if len(sys.argv)!= 2:
        print("Usage: {} <seed>".format(os.path.basename(__file__)))
        exit(-1)

    seed = int(sys.argv[1])
    rng = SystemRandom()
    rng.seed(seed, version=2)

    with open('flag.txt') as f:
        flag = f.read().strip('\n').encode('utf-8')

    with open('flag.enc', 'wb') as out:
        for c in flag:
            out.write(struct.pack('B', (c ^ rng.randrange(0x100)) & 0xff))

        while out.tell() < 512:
            out.write(struct.pack('B', ord(rng.read(1))))

    return True


