#!/usr/bin/env python3

import sys
import random

if len(sys.argv)!= 4:
    print('Usage:', sys.argv[0], '<output file> <width> <height>')
    exit()

with open(sys.argv[1], 'wb') as out, \
     open('/dev/urandom', 'rb') as rng:
    
    width = int(sys.argv[2])
    height = int(sys.argv[3])

    # Header
    out.write(b'BM')
    out.write((58 + (width * height)).to_bytes(4, byteorder='little'))
    out.write(b'\x00\x00\x00\x00')
    out.write(((58 + (width * height)) - 2).to_bytes(4, byteorder='little'))
    out.write(b'\x28\x00\x00\x00')
    out.write(width.to_bytes(4, byteorder='little'))
    out.write(height.to_bytes(4, byteorder='little'))
    out.write(b'\x01\x00\x18\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
           # Extension
        label = bytes([int.from_bytes(rng.read(1), byteorder='little')])
        length = int.from_bytes(rng.read(1), byteorder='little')
        data = rng.read(length)
        out.write(b'\x21')
        out.write(label)
        out.write(data)

        # Block size
        block_size = int.from_bytes(rng.read(1), byteorder='little')

    # Image data
    for y in range(height):
        for x in range(width):
            index = int.from_bytes(rng.read(1), byteorder='little')
            out.write(bytes([index]))

