#!/usr/bin/env python3
import sys
import random
import struct


if __name__ == '__main__':
    if len(sys.argv)!= 3:
        print("Usage: {} <seed> <output>".format(sys.argv[0]))
        exit(-1)

    seed = int(sys.argv[1])
    output_path = sys.argv[2]

    rng = random.Random()
    rng.seed(seed)

    with open(output_path, 'wb') as out:
        # Logical screen descriptor
    width = rng.read(1)[0] % 40 + 10
    height = rng.read(1)[0] % 40 + 10
    packed = struct.pack('<HHBBB', width, height, 0xF7, 0x00, 0x00)
    out.write(packed)

    # Global color table
    for _ in range(0xFF):
        r = rng.read(1)[0] % 256
        g = rng.read(1)[0] % 256
        b = rng.read(1)[0] % 256
        packed = struct.pack('BBB', r, g, b)
        out.write(packed)

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))