#!/usr/bin/env python3

import os
import sys
from pathlib import Path


def main(argv):
    if len(argv) < 2:
        print("Usage: {} <path>".format(os.path.basename(__file__)))
        return

    path = argv[1]
    for f in Path(path).rglob("*"):
        if not f.is_dir():
            continue

        # Skip hidden directories
        if str(f)[0] == ".":
            continue

        # Skip git directories
        if (f / ".git").exists():
            continue

        # Skip node_modules directories
        if (f / "node_modules").exists():
            continue

        # Skip.terraform directories
        if (f / ".terraform").exists():
            continue

        # Skip terraform.tfstate files
        if (f / "terraform.tfstate").exists():
            continue

        # Skip terraform.tfvars files
        if (f / "terraform.tfvars").exists():
            continue

        # Skip empty directories
        if next(iter(f.glob("*")), None) is None:
            continue

        print(str(f))


if