#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 1024 * 512 # 512KB
    data = bytearray()

    for i in range(datalen):
        if i == 0 or i == datalen - 1:
            data += bytes([rng.read(1)[0] % 256])
        else:
            data += bytes([(i & 7) ^ ((i >> 3) & 1)])
    out.write(header + len(data).to_bytes(3, 'big') + b'\x87\x00')
    out.write(data)
