#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 1024 * 512 # 512KB
    data = bytearray()

    for i in range(datalen):
        if i == 0 or i % 256 == 0:
            out.write(b'\x2c')

        data += bytes([rng.read(1)[0]])
        out.write(data[-1:])

    out.write(b';')

