#!/usr/bin/env python3

import os
import sys
from datetime import date, timedelta

# 1. Get the current date and time
today = date.today()
print("Today's date is", today)

# 2. Add one day to the current date
tomorrow = today + timedelta(days=1)
print("Tomorrow's date is", tomorrow)

# 3. Subtract one day from the current date
yesterday = today - timedelta(days=1)
print("Yesterday's date was", yesterday)

# 4. Calculate the number of days between two dates
delta = tomorrow - yesterday
print("There are", delta.days, "days between yesterday and tomorrow")

# 5. Convert a string into a date object
birthday_str = '09-08-1976'
birthday = date(*map(int, birthday_str.split('-')))
print("My birthday is", birthday)

# 6. Format a date as a string in a specific format
birthday_formatted = birthday.strftime("%A %d %B %Y")
print("Formatting my birthday:", birthday_formatted)

# 7. Create a list of dates for each day in a month
dates = [date(2020, 1, i) for i in range(1, 32)]
print("Dates in January 2020:", dates)

# 8. Find the first weekend day in a month
weekends = [date(2020, 1, i) for i in range(1, 32) if date(2020, 1, i).isoweekday() > 4]
first_weekend = min(weekends)
print("First weekend in January 2020:", first_weekend)

# 9. Find the last weekend day in a month
last_weekend = max(weekends)
print("Last weekend in January 2020:", last_weekend)

# 10. Count the number of weekend days in a month
num_weekends = len(weekends)
print("Number of weekends in January 2020:", num_weekends)

# 11. Calculate the number of days between two dates
start_date = date(2020, 1, 1)
end_date = date(2020, 1, 31)
num_days = (end_date - start_date).days + 1
print("Number of days in January 2020:", num_days)

# 12. Check if a given date is a weekend day