#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    datalen = int.from_bytes(rng.read(2), 'big') + 1
    data = rng.read(datalen)
    # write the GIF header and a single frame to stdout
    out.write(header)
    out.write(b'\x01\x00\x01\x00\x80\xff\x00\xff\xff\xff\xff\xff\xff,\x00\x00\x00\x00\x01\x00;')
    out.write(data)
