#!/usr/bin/env python3

import struct
import sys

# Read in the input file
with open(sys.argv[1], 'rb') as f:
    data = f.read()

# Create the output file
out = open('output.bin', 'wb')

# The header that we will write at the start of each chunk
header = b'\x00\x00'

while len(data):
    # Get the first 64 bytes of the data
    chunk = data[:64]
    # Remove those bytes from the data
    data = data[64:]
    # Calculate the length of this chunk
    datalen = len(chunk)
    # Write the header and length of the data to the output
    out.write(header + datalen.to_bytes(2, 'big'))
    out.write(data)

