#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # write GIF header
    out.write(b'GIF89a')
    
    # write screen descriptor
    out.write(b'\x01\x00\x01\x00\x80\xff\x00\x00\xff\xff\xff')
    
    # write application extension block
    out.write(b'\x21\xf9\x04\x01\x0a\x00\x01\x00\x00\x00\x00\x2c\x00')
    
    # write graphic control extension block
    out.write(b'\x21\xf9\x04\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00')
    
    # write image descriptor block
    out.write(b'\x2c\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02\x44\x01\x00')
    
    # write LZW-compressed pixel data
    out.write(b'\x21\xff\x0b\x4e\x45\x54\x53\x43\x41\x50\x45\x32\x2e\x30\x03\x01\x00\x00\x00')
    out.write(b'\x00\x21\xf9\x04\x01\x00\x01\x00\x01\x00\x00\x00\x00\x2c\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02\x44\x01\x00\x3b')
    
    # write trailer
    out.write(b';')
