#!/usr/bin/env python3
import sys
from typing import BinaryIO

if len(sys.argv) != 2:
    print('Usage: {} <input>'.format(sys.argv[0]))
    exit(1)

with open(sys.argv[1], 'rb') as f:
    with open(sys.argv[1] + '.out', 'wb') as out:
        process(f, out)

def process(rng: BinaryIO, out: BinaryIO):
    header = b'MZ'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    out.write(header + datalen.to_bytes(3, 'big') + data)
