#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    width = 1024
    height = 768
    color_table = [
        0xFF0000, # Red
        0x00FF00, # Green
        0x0000FF, # Blue
    ]
    data = bytearray()
    for y in range(height):
        for x in range(width):
            data.append(rng.read(1)[0] % len(color_table))
    datalen = len(data)
    trailer = b'\x3b'
    out.write(header)
    out.write(struct.pack('<H', datalen))
    out.write(data)
    out.write(trailer)
