#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3),
            byteorder='big',
            signed=False
    )
    data = rng.read(datalen)
    out.write(header + datalen.to_bytes(3, 'big') + data)
