#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(rng: BinaryIO, width=1024, height=768):
    # header
    print("GIF89a", file=sys.stdout, end="")

    # logical screen descriptor
    print(f"{width} {height}", file=sys.stdout, end="!")

    # global color table (black and white only)
    for _ in range(256):
        print("#000000", file=sys.stdout, end=",")

    # loop control block
    print(";")
    print("!" * 18 + "NETSCAPE2.0", file=sys.stdout, end="")
    print(";" * 19 + "#00", file=sys.stdout, end="")

    # image data
    while True:
        # delay time
        print(chr((rng.read(1)[0] % 10) + ord('0')), file=sys.stdout, end="")

        # image descriptor
        print("," * 9 + chr(0), file=sys.stdout, end="")

        # LZW minimum code size
        print(",", file=sys.stdout, end="")
        print(chr(128), file=sys.stdout, end="")

        # compressed data
        print("\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7\xa8\xa9\xaa\xab\xac\xad\xae\xaf\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7\xe8\xe9\xea\xeb\xec\xed\xee\xef\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff", file=sys.stdout, end="")


if