#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a' + bytes([0x21]) # Header and version

    width = 640
    height = 480
    color_table_size = 7
    global_color_table = [
        0x00, 0x00, 0x00,
        0xFF, 0x00, 0x00,
        0x00, 0xFF, 0x00,
        0xFF, 0xFF, 0x00,
        0x00, 0x00, 0xFF,
        0xFF, 0x00, 0xFF,
        0x00, 0xFF, 0xFF,
        0xFF, 0xFF, 0xFF,
    ]

    background_index = 0
    pixel_aspect_ratio = 0
    flags = 0b10000000 | (background_index << 4) | pixel_aspect_ratio

    screen_descriptor = struct.pack('<HHBBB', width, height, color_table_size, flags)

    image_descriptor = struct.pack('<BHHBB', 0x2C, 0, 0, 0, 0)

    data = bytearray()
    for i in range(height):
        data += bytes([global_color_table[i % len(global_color_table)]] * width)

    out.write(header)
    out.write(screen_descriptor)
    out.write(image_descriptor)
    out.write(bytes([data]))


if