#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

def main(args):
    if len(args) < 2:
        print("Usage: {} <input_file>".format(os.path.basename(__file__)), file=sys.stderr)
        return -1

    with open(args[1], 'rb') as f:
        data = bytearray(f.read())

    for i in range(0, len(data), 4):
        word = int.from_bytes(data[i : i + 4], "little")

        # Convert to little endian and flip the bits
        newword = (word & 0xFF) << 8 | ((word >> 8) & 0xFF)
        newword = ~newword & 0xFFFF

        data[i : i + 4] = newword.to_bytes(4, "little")

    with open(args[1], 'wb') as f:
        f.write(data)


if