#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    width = 256
    height = 100

    # write the GIF header
    out.write(header + bytes([width, height]))

    # write a single frame with all black pixels
    for _ in range(height * width // 8):
        out.write(b'\x00')


if __name__ == '__main__':
    if len(sys.argv)!= 2 or not sys.argv[1].endswith('.gif'):
        print('Usage:', sys.argv[0], '<output file>')
        exit()

    with open('/dev/urandom', 'rb') as f:
        with open(sys.argv[1], 'wb') as g:
            generate_random_gif(f, g)