#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # Generate the header (always 69 47 47 50)
    header = b'GIF' + bytes([0x38]) + b'\x00\x01'

    # Get the length of the data from the RNG
    while True:
        datalen = int.from_bytes(
            rng.read(2), byteorder='big', signed=False
        )
    data = rng.read(datalen)

    # Write the header and length of the data to the output
    out.write(header + datalen.to_bytes(2, 'big'))
    out.write(data)

