#!/usr/bin/env python3

import struct
from typing import BinaryIO

def gif_encode(rng: BinaryIO, out: BinaryIO):
    """Encode a GIF file from an input stream"""
    
    # Read in the header and length of the data
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(2), byteorder='big', signed=False
        )
    data = rng.read(datalen)

    # Write the header and length of the data to the output
    out.write(header + datalen.to_bytes(2, 'big'))
    out.write(data)

