#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'

    # 1024 bytes of data
    datalen = 1024
    data = bytearray([rng.read(1)[0] for _ in range(datalen)])

    trailer = b'\x3B\xFF\xFF\xFF'

    out.write(header)
    out.write(struct.pack('<H', datalen))
    out.write(data)
    out.write(trailer)
