#!/usr/bin/env python3
import sys
from typing import BinaryIO

# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    header = b'GIF89a'
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    data = rng.read(datalen)
    trailer = b'\x00\x3B'

    out.write(header + len(data).to_bytes(3, 'big') + data + trailer)


if __name__ == '__main__':
    with open('/dev/urandom', 'rb') as rng:
        if len(sys.argv)!= 2 or not sys.argv[1].endswith('.gif'):
            print('Usage:', sys.argv[0], '<output-file>')
            exit(-1)

        with open(sys.argv[1], 'wb') as f:
            generate_random_gif(rng, f)