#!/usr/bin/env python3

import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 256 * (1 + int.from_bytes(rng.read(1), 'big'))
    data = rng.read(datalen)
    trailer = b'\x3b'
    out.write(header)
    out.write(struct.pack('<H', datalen))
    out.write(data)
    out.write(trailer)
