#!/usr/bin/env python3
import sys
from typing import BinaryIO


# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
):
    # GIF header
    out.write(b'GIF89a')

    # Logical screen descriptor
    width  = (1 << 6) | ((250 & 0x3f) >> 0)
    height = (1 << 6) | ((250 & 0xffc0) >> 6)
    out.write((width).to_bytes(2, 'little'))
    out.write((height).to_bytes(2, 'little'))
    out.write(b'\xf7\x00')    # no global color table

    # Image descriptor
    out.write(b'\x2c')       # image separator
    xpos = ypos = 0         # position at top left corner of screen
    width &= ~0x40          # set size to full screen
    out.write(xpos.to_bytes(2, 'little'))
    out.write(ypos.to_bytes(2, 'little'))
    out.write(width.to_bytes(2, 'little'))
    out.write(height.to_bytes(2, 'little'))
    out.write(b'\x00')       # no local color table
    out.write(b'\x00')       # LZW compression

    # Graphics control block
    out.write(b'\x21\xf9\x04')   # graphics control label
    out.write(b'\x01\x00\x01\x00')     # delay in 1/100 sec
    out.write(b'\x00')               # no transparent color index

    # Application extension
    out.write(b'\x21\xff\x0bNETSCAPE2.0')
    out.write(b'\x03\x01')           # application identifier
    out.write(b'\x00\x00')           # authentication code
    out.write(b'\x00\x00\x00')       # subblock length
    out.write(b'\x00')               # end of subblock

    # Plain text extension
    out.write(b'\x21\x00\x0b')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write(b'\x00\x00\x00\x00')
    out.write