#!/usr/bin/env python3

import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (/dev/urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    header = b'GIF89a'
    datalen = 64 * (1 << rng.read(1)[0])
    data = bytes([rng.read(1)[0] for _ in range(datalen)])

    # Write the header and length of the data to the output
    out.write(header + len(data).to_bytes(2, 'big'))
    out.write(data)