#!/usr/bin/env python3

import os
import struct
from random import Random

if __name__ == '__main__':
    width, height = 8, 8
    rng = Random()

    with open("test_data.dat", "wb") as out:
        # Header
        packed = struct.pack("<BBHHH", 0x4A, 0x47, 0, width, height)
        out.write(packed)

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))