#!/usr/bin/env python3
import struct
from random import Random

def generate_random_image(filename, width=800, height=400):
    """Generate a random image and write it to filename."""
    rng = Random()
    out = open(filename, 'wb')

    # Header
    out.write(b'P1\n')
    out.write(str(width).encode())
    out.write(b' ')
    out.write(str(height).encode())
    out.write(b'\n')

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))

    # Trailer
    out.write(b';')