#!/usr/bin/env python3

import os
import random
import struct

if __name__ == '__main__':
    width = 800
    height = 400

    out = open("test.ppm", "wb")
    out.write(b"P6\n%d %d\n255\n" % (width, height))

    rng = random.Random()
    rng.seed(os.urandom(1024))

    # Palette
    for i in range(256):
        r = rng.read(1)[0] % 256
        g = rng.read(1)[0] % 256
        b = rng.read(1)[0] % 256
        packed = struct.pack('BBB', r, g, b)
        out.write(packed)

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))