#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

# Generates a random GIF file into `out` using the
# random number generator `rng` (os.urandom)
def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ):
    # Header
    out.write('GIF89a'.encode())
    width = rng.read(2)[0] + 1
    height = rng.read(2)[0] + 1
    out.write(struct.pack("<HHB", width, height, 0xF))
    out.write(b'\xFF\xFF\xFF')
    # Image data
    for _ in range(height * width):
        out.write(rng.read(1))
    # Trailer
    out.write(b';')
