
import random
import struct
from PIL import Image

def generate_image(filename, width=32, height=32, seed=None):
    """Generate a random image."""
    rng = random.Random()
    if seed is not None:
        rng.seed(seed)

    out = open(filename, 'wb')

    # Header
    out.write(struct.pack('!L', 0x474E5089))
    out.write(struct.pack('!L', width))
    out.write(struct.pack('!L', height))

    # Palette
    for i in range(256):
        r = rng.randint(0, 255)
        g = rng.randint(0, 255)
        b = rng.randint(0, 255)
        packed = struct.pack('BBB', r, g, b)
        out.write(packed)

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256

            if not ((index == 0) and (y < height // 2)):
                out.write(struct.pack('B', index))