
import sys
import random
import struct

if len(sys.argv) < 3:
    print("Usage: {} <seed> <output_file>".format(sys.argv[0]))
    exit()

rng = random.Random(int(sys.argv[1], base=16))
out = open(sys.argv[2], 'wb')

for i in range(100):
    # Header
    out.write(b'GIF89a')
    # Logical screen descriptor
    width = rng.read(1)[0] % 40 + 10
    height = rng.read(1)[0] % 40 + 10
    packed = struct.pack('<HHBBB', width, height, 0xF7, 0x00, 0x00)
    out.write(packed)

    # Global color table
    for _ in range(0xFF):
        r = rng.read(1)[0] % 256
        g = rng.read(1)[0] % 256
        b = rng.read(1)[0] % 256
        packed = struct.pack('BBB', r, g, b)
        out.write(packed)

    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))

    # Trailer
    out.write(b';')