#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

if __name__ == '__main__':
    if len(sys.argv)!= 4:
        print("Usage: {} <input> <output> <seed>".format(os.path.basename(__file__)))
        exit(-1)

    with open(sys.argv[1], 'rb') as f:
        image_data = bytearray(f.read())

    width, height = struct.unpack('<HH', image_data[:4])
    image_data = bytes(image_data[4:])

    seed = int(sys.argv[3])
    rng = Random(seed)

    # Header
    out = open(sys.argv[2], "wb")
    out.write(struct.pack("<I", seed))
    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))

    # Trailer
    out.write(b';')