#!/usr/bin/env python3

import struct
from random import Random


rng = Random()
rng.seed('hello world')

with open('test.gif', 'wb') as out:
    # Write the header
    out.write(b'GIF89a')
    # Write the image data
    out.write(b'\x00\x00')

    # Write the LZW compressed image data
    lzw_min_code_sizes = [8, 4, 2, 0]
    for lzw_min_code_size in lzw_min_code_sizes:
        out.write(bytes([lzw_min_code_size]))

        while True:
            code = rng.read(1)[0]
            if code == 0:
                break
            else:
                out.write(bytes([code]))

    # Write the trailer
    out.write(b';')
