#!/usr/bin/env python3

import os
import sys
import struct
from random import Random


if __name__ == '__main__':

    if len(sys.argv)!= 4:
        print("Usage: {} <seed> <width> <height>".format(os.path.basename(__file__)))
        exit(-1)

    seed = int(sys.argv[1])
    width = int(sys.argv[2])
    height = int(sys.argv[3])

    rng = Random()
    rng.seed(seed)

    out = open('image.raw', 'wb')

    # Header
    out.write(struct.pack('<I', width))
    out.write(struct.pack('<I', height))
    # Image data
    for y in range(height):
        for x in range(width):
            index = rng.read(1)[0] % 256
            out.write(struct.pack('B', index))