#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO, Optional, Tuple

# https://github.com/python-pillow/Pillow/blob/master/src/PIL/ImageFile.py
# https://github.com/python-pillow/Pillow/blob/master/src/PIL/_binary.py

def _get_byte(fp: BinaryIO) -> int:
    return ord(fp.read(1))

def _get_short(fp: BinaryIO) -> int:
    return struct.unpack('>H', fp.read(2))[0]

def _get_long(fp: BinaryIO) -> int:
    return struct.unpack('>I', fp.read(4))[0]

def _get_float(fp: BinaryIO) -> float:
    return struct.unpack('>f', fp.read(4))[0]

def _get_double(fp: BinaryIO) -> float:
    return struct.unpack('>d', fp.read(8))[0]

def _get_string(fp: BinaryIO, length: int) -> str:
    return fp.read(length).decode()

def _skip(fp: BinaryIO, length: int):
    fp.seek(length, 1)
