#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Sep 26 15:47:39 2020

@author: jonas
"""
import random
from PIL import Image

def generate_random_gif(rng, out):
    """Generate a GIF file of random data."""
    # Generate the header
    out.write(b'GIF89a')
    
    # Generate the logical screen descriptor
    width = rng.read(2)
    height = rng.read(2)
    packed = b'\x80\x00' + width + height + b'\x00'
    out.write(packed)
    
    # Write an image block
    out.write(b'\x2c\x00\x00\x00\x00')
    out.write(width)
    out.write(height)
    out.write(b'\x00')
    
    # Write out the local color table
    out.write(b'\x00')
    for i in range(0, 256):
        out.write(bytes([i]))
        out.write(bytes([i]))
        out.write(bytes([i]))
        
    # Write out the image data
    datalen = int.from_bytes(height, byteorder='little') * \
              int.from_bytes(width, byteorder='little')
    for _ in range(0, datalen):
        out.write(rng.read(1))


if __name__ == '__main__':
    with open('/dev/urandom', mode='rb') as rng:
        with open('test.gif', mode='wb') as f:
            generate_random_gif(rng, f)