#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO

def main(argv):
    if len(argv) < 2:
        print("Usage: {} file".format(os.path.basename(__file__)),
              file=sys.stderr)
        return -1

    with open(argv[1], "rb") as f:
        data = f.read()

        # Check for the magic number.
        if not data[:4] == b"Yaz0":
            print("{} does not appear to be a Yaz0 file.".format(argv[1]),
                  file=sys.stderr)
            return -1

        # Get the decompressed size from the header.
        decomp_size, = struct.unpack("<I", data[4:8])

        # Decompress the data.
        outdata = yaz0.decompress(data[8:])

        # Make sure it's the right size.
        if len(outdata)!= decomp_size:
            raise Exception("Decompressed size is wrong.")

        # Write the output file.
        with open(argv[1][:-4], "wb") as of:
            of.write(outdata)


if