#!/usr/bin/env python3

import os, sys
from pathlib import Path


def main():
    if len(sys.argv)!= 2:
        print("Usage:", sys.argv[0], "<path>")
        return

    path = Path(sys.argv[1])
    for file in sorted(path.glob('**/*.py')):
        if not (file.name == '__init__.py' or file.name.startswith('_')):
            with open(file, 'r') as f:
                lines = [line[:-1] for line in f.readlines()]

            # remove shebang
            if lines and lines[0].startswith('#!'):
                del lines[0]

            # remove empty lines at the end of file
            while lines[-1] == '':
                del lines[-1]

            # add newlines to all but last line
            lines = ['{}\n'.format(line) for line in lines[:-1]] + [lines[-1]]

            with open(file, 'w') as f:
                f.writelines(lines)


if