#!/usr/bin/env python3

import os, sys
from pathlib import Path


def main():
    if len(sys.argv) < 2:
        print("Usage: {} [path]".format(os.path.basename(__file__)))
        return

    path = Path(sys.argv[1])
    for p in sorted(path.glob('**/*.py')):
        if not str(p).startswith('./venv'):
            continue

        with open(str(p)) as f:
            lines = []

            for line in f.readlines():
                if 'import' in line and 'from' not in line:
                    line = line.replace('import', '# import')

                elif 'from' in line:
                    line = line.replace('from', '# from')

                lines.append(line)

            with open(str(p), 'w') as f:
                f.writelines(lines)



if