#!/usr/bin/env python3

import os
import sys
from pathlib import Path


def main():
    if len(sys.argv)!= 2:
        print("Usage: {} <path>".format(os.path.basename(__file__)))
        return

    path = Path(sys.argv[1])
    for f in sorted(path.glob('**/*.py')):
        if str(f).startswith('./tests'):
            continue

        with open(str(f)) as fp:
            lines = [line.rstrip() for line in fp]

            # Remove shebangs and encoding declarations from the top of files
            while (lines and not lines[0].startswith('#!')
                   and not lines[0].startswith('# -*- coding: utf-8 -*-')
                   ):
                del lines[0]

            # Remove trailing whitespace on blank lines, but preserve it on non-blank ones
            for i, line in enumerate(lines):
                if line == '':
                    lines[i] = ''
                else:
                    lines[i] = line.rstrip() + '\n'

            with open(str(f), 'w') as outfp:
                outfp.writelines(lines)


if