#!/usr/bin/env python3

import os
import sys


def main():
    if len(sys.argv)!= 2:
        print("Usage: {} <path>".format(os.path.basename(__file__)))
        return

    path = sys.argv[1]
    for root, dirs, files in os.walk(path):
        for file_name in sorted(files):
            full_path = os.path.join(root, file_name)

            with open(full_path, "r") as f:
                lines = [line.rstrip() for line in f.readlines()]

                # Remove empty lines at the end of the file.
                while not lines[-1]:
                    del lines[-1]

                # Remove trailing whitespace from each line.
                new_lines = []
                for line in lines:
                    new_lines.append(line.rstrip())

                if lines == new_lines:
                    continue

                print("{}:".format(full_path))
                for i, (old, new) in enumerate(zip(lines, new_lines)):
                    if old!= new:
                        print("{:>4} {:<50} -> {}".format(i + 1, old, new))

                print("")

        break


if