#!/usr/bin/env python3

import os
import sys
import struct
from typing import BinaryIO


def generate_random_gif(
        rng: BinaryIO, out: BinaryIO
    ) -> None:

    # The GIF format is a bit weird in that it has a fixed-size header and then
    # an unbounded data section.  We'll just write the header first so we can
    # figure out how long the data section will be later on.
    header = b'\x47\x49\x46\x38\x39\x61\x01\x00\x01\x00\x80\x00\x00\xff\xff\xff\xff\xff\xff\x21\xf9\x04\x01\x0a\x00\x01\x00\x2c\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x02\x44\x01\x00\x3b'
    out.write(header)
#    print("Header length:", len(header))

    # Now we need to find the end of the header by scanning for the null byte
    # that terminates the header string.
    pos = 0
    while True:
        if not (byte := rng.read(1)):
            raise Exception('ran out of bytes')

        if byte == b'\x00':
            break

        pos += 1


    # Now we know where the body starts, so let's go back there and start writing
    # random bytes until we hit the end of the file or run out of space.
    rng.seek(-pos - 1, os.SEEK_END)
    while True:
        chunk = rng.read(512)
        if not chunk:
            break

        out.write(chunk)



if