#!/usr/bin/env python3

import os
from PIL import Image


def generate_random_gif(rng, out):

    # GIF Header
    out.write(b'GIF89a')  # signature
    out.write(os.urandom(7))  # version and size of global color table
    out.write(bytes([255]))  # background index
    out.write(bytes([0]))   # pixel aspect ratio (aspect ratio = 0 -> square pixels)

    # Frame Descriptor
    out.write(bytes([0x2C]))  # image separator
    out.write(os.urandom(9))  # frame position & dimension
    out.write(bytes([0]))   # local color table flag
    out.write(bytes([0]))   # interlace flag
    out.write(bytes([0]))   # sort flag
    out.write(bytes([0]))   # reserved
    out.write(bytes([0]))   # LZW minimum code size

    # Image Data
    imgdata = b'\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x    for _ in range(0, datalen):
        out.write(rng.read(1))


if __name__ == '__main__':
    with open('/dev/urandom', mode='rb') as rng:
        with open('test.gif', mode='wb') as f:
            generate_random_gif(rng, f)