#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep  7 21:54:56 2020

@author: <NAME>
"""
import struct

def generate_random_gif(rng, out):
    """Generate a random GIF image."""
    # First come the header.  We'll just use the default values here (all zeroes).
    header = b'GIF89a\x00\x00\x00\x00\xff\xff\xff\x00,\x00\x00\x00\x00\x01\x00\x01\x00\x00\x02\x00;'
    # Next comes the length of the data section.  It's stored as a 3-byte big-endian
    # integer, so we need to read three bytes from /dev/urandom and interpret those
    # into the file.  This is done by reading three bytes from /dev/urandom and
    # interpreting them as a little-endian unsigned integer.
    datalen = int.from_bytes(
            rng.read(3), byteorder='big')
    out.write(header + datalen.to_bytes(3, 'big'))

    # Now we can write the actual data to the file.
    for _ in range(0, datalen):
        out.write(rng.read(1))


if __name__ == '__main__':
    with open('/dev/urandom', mode='rb') as rng:
        with open('test.gif', mode='wb') as f:
            generate_random_gif(rng, f)