#!/usr/bin/env python3

import os
from PIL import Image


def generate_random_gif(rng, output):

    # Generate a random palette of 256 colors
    palette = []
    for i in range(0, 768, 3):
        r = next(rng) & 0xff
        g = next(rng) & 0xff
        b = next(rng) & 0xff

        color = (r << 16) | (g << 8) | b
        palette += [color] * 4

    # Create the image and fill it with random pixels
    im = Image.new("P", (256, 256), None)
    im.putpalette(palette)
    for y in range(im.height):
        for x in range(im.width):
            pixel = next(rng) & 0xff
            im.putpixel((x,y), pixel)

    # Save to file
    im.save(output, format="GIF")


if __name__ == '__main__':
    with open('/dev/urandom', mode='rb') as rng:
        with open('test.gif', mode='wb') as f:
            generate_random_gif(rng, f)