#!/usr/bin/env python3
"""Random GIF generator - generates randomized GIFs with varying levels of exploitability"""

import os
import uuid
import tempfile
import subprocess

class RandomGifGenerator:

    def __init__(self):

        self.tempdir = tempfile.TemporaryDirectory()
        self.rng = os.open('/dev/urandom', os.O_RDONLY)
        self.filename = f'{uuid.uuid4()}.gif'.encode('utf-8')


    def generate_gif(self):
        """Generates a random GIF and returns it's file path"""
        with open(os.path.join(self.tempdir.name, self.filename), 'wb') as fout:
            generate_random_gif(self.rng, fout)
        return os.path.join(self.tempdir.name, self.filename)

